#pragma once
#include "afxcmn.h"
#include "afxwin.h"
#include "vzlprclientctrlctrl1.h"
#include "libcsv.h"


typedef enum _ReadState {
	READ_ID = 0,
	READ_PLATE,
	READ_ENABLE,
	READ_CREATE_TIME,
	READ_EXPIRES_TIME,
	READ_ENABLE_TIME_SEG,
	READ_TIME_SEG,
	READ_ENABLE_BLACK_LIST,
	READ_CUSTOMER_CODE,
	READ_CUSTOMER_ENCODE,
	READ_COMPLETE
}ReadState;

typedef struct
{
	unsigned	uVehicleID;				/**<ݿID*/
	char		strPlateID[16];			/**<ַ*/
	unsigned	uCustomerID;			/**<ͻݿIDVZ_LPR_WLIST_CUSTOMER::uCustomerIDӦ*/
	unsigned	bEnable;				/**<ü¼Ч*/
	unsigned	bEnableTMEnable;		/**<ǷЧʱ*/
	char		strTMEnable[64];		/**Чʱ*/
	unsigned	bEnableTMOverdule;		/**<Ƿʱ*/
	char		strTMOverdule[64];		/**ʱ*/
	unsigned	bUsingTimeSeg;			/**<Ƿʹʱ*/
	unsigned	bAlarm;					/**<Ƿ񴥷¼*/
	int			iColor;					/**<ɫ*/
	int			iPlateType;				/**<*/
	char		strCode[32];			/**<*/
	char		strComment[64];			/**<*/
}
LPR_WLIST_VEHICLE;

// CDlgWlist dialog

class CDlgWlist : public CDialog
{
	DECLARE_DYNAMIC(CDlgWlist)

public:
	CDlgWlist(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgWlist();

// Dialog Data
	enum { IDD = IDD_DLG_WLIST };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	void SetDeviceIP( CString strIP, int nPort, CString strUserName, CString strPwd );

	CListCtrl m_lstPlate;
	CEdit m_editPlate;
	CVzlprclientctrlctrl1 m_lprClientCtrl;
	afx_msg void OnClose();
	
	DECLARE_EVENTSINK_MAP()
	void OnLPRWlistInfoOutVzlprclientctrlctrl1(long lVehicleID, LPCTSTR strPlateID, BOOL bEnable, LPCTSTR strOverdule, BOOL bUsingTimeSeg, BOOL bAlarm, LPCTSTR strReserved, long lCustomerID, LPCTSTR strCustomerName, LPCTSTR strCustomerCode);
	afx_msg void OnBnClickedBtnAdd();
	afx_msg void OnBnClickedBtnEdit();
	afx_msg void OnBnClickedBtnDele();
	afx_msg void OnBnClickedBtnQuery();
	afx_msg void OnBnClickedBinClear();

	void LoadPlateList( CString strPlateKey );
	int GetSeleIndex( );

	void QueryByPage(int nPageIndex);

	void QueryWlist( );

	

private:
	int m_nLprHandle;
	CString m_strDeivceIP;
	int m_nPort;
	CString m_strUserName;
	CString m_strPwd;
public:
	void OnLPRWlistInfoOutExVzlprclientctrlctrl1(long lVehicleID, LPCTSTR strPlateID, BOOL bEnable, BOOL bEnableTM, BOOL bEnableOverdule, LPCTSTR strTMEnable, LPCTSTR strOverdule, BOOL bUsingTimeSeg, BOOL bAlarm, LPCTSTR strPlateCode, 
		LPCTSTR strPlateComment, long lCustomerID, LPCTSTR strCustomerName, LPCTSTR strCustomerCode);
	
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnLvnItemchangedListPlate(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedBinBatchImport();
	afx_msg void OnBnClickedBtnFirstPage();
	afx_msg void OnBnClickedBtnPrevPage();
	afx_msg void OnBnClickedBtnNextPage();
	afx_msg void OnBnClickedBtnLastPage();

	void InsertWlistRecord(void *item_str, size_t size);

	void EndInsertRecord( );

	int m_nTotalCount;
	int m_nCurPage;
	int m_nPageCount;

	CString m_strPlate;
	CStatic m_lblPageInfo;
	CStatic m_lblCountInfo;

	LPR_WLIST_VEHICLE m_vehicle;

	int m_nParseIndex;
};
