unit GroupNetDemoForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, VzLPRSDK, jpeg, ComCtrls;

const
    GROUP_RESULT_MSG = WM_USER+101;
    GROUP_IMG_MSG = WM_USER+102;

type
  TMainForm = class(TForm)
    pnl1: TPanel;
    pnl2: TPanel;
    grp1: TGroupBox;
    lbl1: TLabel;
    edtDevIP: TEdit;
    lbl2: TLabel;
    edtPort: TEdit;
    lbl3: TLabel;
    lbl4: TLabel;
    edtUsername: TEdit;
    edtPwd: TEdit;
    btnOpen: TButton;
    btnClose: TButton;
    lbl5: TLabel;
    lbl6: TLabel;
    edtPlate: TEdit;
    edtPlate2: TEdit;
    imgEnter: TImage;
    imgExit: TImage;
    lbl7: TLabel;
    lbl8: TLabel;
    lbl9: TLabel;
    lvDev: TListView;
    lvGroupResult: TListView;
    btnOpenGroup: TButton;
    btnStopGroup: TButton;
    btnPlayVideo: TButton;
    btnStopPlay: TButton;
    btnForceTrigger: TButton;
    procedure GroupNetForm_Greae(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure btnPlayVideoClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnStopPlayClick(Sender: TObject);
    procedure btnForceTriggerClick(Sender: TObject);
    procedure GroupNetForm_Close(Sender: TObject;
      var Action: TCloseAction);
    procedure pnl1_click(Sender: TObject);
    procedure pnl2_OnClick(Sender: TObject);
    procedure btnOpenGroupClick(Sender: TObject);
    procedure btnStopGroupClick(Sender: TObject);
    procedure GetGroupResultMsg(var Msg:TMessage);message GROUP_RESULT_MSG;
    procedure GetGroupImgMsg(var Msg:TMessage);message GROUP_IMG_MSG;
  private
    { Private declarations }
    procedure InitCtls;
    procedure InitVars;
    procedure InitImgEnter;
    procedure InitImgExit;
    procedure ClearVideo1;
    procedure CLearVideo2;
    function GetSeleHandle: Integer;
    function GetVideo1Handle:Integer;
    function GetVideo2Handle:Integer;
    function GetGroupTimeInteval(time: Integer):string;

  public
    { Public declarations }
  end;

  type
    TGroupThread = class(TThread)
  private
    LPRHandle: VzLPRClientHandle;
    DevID: Integer;
    DevSN: string;
    DevType: Integer;
  protected
    procedure Execute; override;
  public
    constructor Create(handle: VzLPRClientHandle; id: Integer; sn: string; EnterExitType: Integer);
  end;

var
  MainForm: TMainForm;
  mFirst: Boolean;
  mPlayHandle, mPlayHandle2: Integer;
  FGroupImgThread1, FGroupImgThread2: TGroupThread;

implementation

{$R *.dfm}

//ʾϢ
type
    GROUP_RESULT_INFO = record
    entryExitType: Integer;
    lprHandle: VzLPRClientHandle;
    license: array[0..15] of Char;
    entryTime: string;
    exitTime: string;
    interval: string;
    imgPath: string;
end;
   PGROUP_RESULT_INFO  = ^GROUP_RESULT_INFO ;

constructor TGroupThread.Create(handle: VzLPRClientHandle; id: Integer; sn: string; EnterExitType: Integer);
begin
  LPRHandle := handle;
  DevID := id;
  DevSN := sn;
  DevType := EnterExitType;
  inherited Create(False);
end;

procedure TGroupThread.Execute;
var
  img_size, ret: Integer;
  img_buf: PByte;
  groupDir, imgDir, imgPath: string;
  pGroupResultInfo:PGROUP_RESULT_INFO;
  FileStream : TFileStream;
  jpegImgGroup : TJPEGImage;
begin
  img_size := 1280 * 720;
  GetMem(img_buf, img_size);
  ZeroMemory(img_buf, img_size);

  ret := VzLPRClient_LoadGroupFullImageById(LPRHandle, DevID, PChar(DevSN), img_buf, @img_size);
  if ret <> 0 then
  begin
    Exit;
  end;

  groupDir := ExtractFilePath(ParamStr(0))  +'\';
  if not DirectoryExists(groupDir) then
  begin
     ForceDirectories(groupDir); //Ŀ¼
  end;

  if DevType = 0 then
  begin
    imgDir := groupDir + '\';
    if not DirectoryExists(imgDir) then
    begin
       ForceDirectories(imgDir); //Ŀ¼
    end;
  end
  else if DevType = 1 then
  begin
    imgDir := groupDir + '\';
    if not DirectoryExists(imgDir) then
    begin
       ForceDirectories(imgDir); //Ŀ¼
    end;
  end;

  imgPath :=  imgDir + IntToStr(DevID) +  FormatDateTime('_yyyymmdd_hhnnss',Now) + '.jpg' ;
  if ((img_size > 0)and (img_size < 1280 * 720))  then
  begin
    GetMem(pGroupResultInfo, SizeOf(GROUP_RESULT_INFO));
    ZeroMemory(pGroupResultInfo, SizeOf(GROUP_RESULT_INFO));

    FileStream := TFileStream.Create(imgPath, fmCreate);
    FileStream.Position := 0;
    FileStream.WriteBuffer(img_buf^, img_size);
    pGroupResultInfo.imgPath := imgPath;
    FreeAndNil(FileStream);

    PostMessage(MainForm.Handle, GROUP_IMG_MSG, Integer(DevType), Integer(pGroupResultInfo));
  end;

  FreeMem(img_buf);
end;

procedure TMainForm.GetGroupImgMsg(var Msg:TMessage);
var
  devType: Integer;
  pGroupImgInfo:PGROUP_RESULT_INFO;
  imgPath: string;
  FileStream: TFileStream;
  jpegImgGroup: TJPEGImage;
begin
  devType := Integer(Msg.WParam);
  pGroupImgInfo := PGROUP_RESULT_INFO(Msg.LParam);
  imgPath := pGroupImgInfo.imgPath;

  if (Trim(imgPath) <> '') and (FileExists(imgPath)) then
  begin
    jpegImgGroup := TJPEGImage.Create;
    jpegImgGroup.LoadFromFile(imgPath);

    if(devType = 0) then
    begin
      imgEnter.Picture.Graphic := jpegImgGroup;  //ʾͼƬ
    end
    else if(devType = 1) then
    begin
      imgExit.Picture.Graphic := jpegImgGroup;  //ʾͼƬ
    end;

    jpegImgGroup.Free;
  end;

  FreeMem(pGroupImgInfo);
end;

//ʶص1
function OnPlateInfo1(mhandle: VzLPRClientHandle; pUserData: Pointer; pResult: PTH_PlateResult;
                      uNumPlates: Word; eResultType: VZ_LPRC_RESULT_TYPE; var pImgFull: VZ_LPRC_IMAGE_INFO;
                      var pImgPlateClip: VZ_LPRC_IMAGE_INFO): Integer; stdcall;
begin

end;

//ص
function OnGroupResult(mhandle: VzLPRClientHandle; pUserData: Pointer; exitEntryInfo:Integer;
                      exitIvsInfo: PTH_PlateResult;entryIvsInfo: PTH_PlateResult;
                      exitDGInfo: pIVS_DG_DEVICE_INFO; entryDGInfo: pIVS_DG_DEVICE_INFO): Integer; stdcall;
var
  pGroupResultInfo:PGROUP_RESULT_INFO;
  entrySN, exitSN, strInterval: string;
  time: Integer;
begin
  if(mhandle > 0) and(pUserData <> nil)then
  begin
    GetMem(pGroupResultInfo, SizeOf(GROUP_RESULT_INFO));
    ZeroMemory(pGroupResultInfo, SizeOf(GROUP_RESULT_INFO));

    pGroupResultInfo.lprHandle := mhandle;

    if exitEntryInfo = 0 then
    begin
      pGroupResultInfo.entryExitType := 0;

      //ƺ
      StrCopy(PChar(@pGroupResultInfo.license[0]), PChar(@entryIvsInfo.license[0]));

      //ʱ
      pGroupResultInfo.entryTime := Format('%d-%.2d-%.2d %.2d:%.2d:%.2d',[entryIvsInfo.struBDTime.bdt_year,entryIvsInfo.struBDTime.bdt_mon,
                                     entryIvsInfo.struBDTime.bdt_mday,entryIvsInfo.struBDTime.bdt_hour,entryIvsInfo.
                                     struBDTime.bdt_min,entryIvsInfo.struBDTime.bdt_sec]);
    end
    else  if (exitEntryInfo = 1) then
    begin
      pGroupResultInfo.entryExitType := 1;

      //ƺ
      StrCopy(PChar(@pGroupResultInfo.license[0]), PChar(@exitIvsInfo.license[0]));

      //ʱ
      pGroupResultInfo.entryTime := Format('%d-%.2d-%.2d %.2d:%.2d:%.2d',[entryIvsInfo.struBDTime.bdt_year,entryIvsInfo.struBDTime.bdt_mon,
                                     entryIvsInfo.struBDTime.bdt_mday,entryIvsInfo.struBDTime.bdt_hour,entryIvsInfo.
                                     struBDTime.bdt_min,entryIvsInfo.struBDTime.bdt_sec]);

      //ʱ
      pGroupResultInfo.exitTime := Format('%d-%.2d-%.2d %.2d:%.2d:%.2d',[exitIvsInfo.struBDTime.bdt_year, exitIvsInfo.struBDTime.bdt_mon,
                                     exitIvsInfo.struBDTime.bdt_mday, exitIvsInfo.struBDTime.bdt_hour,
                                     exitIvsInfo.struBDTime.bdt_min, exitIvsInfo.struBDTime.bdt_sec]);

      //ʱ
      time := exitIvsInfo.tvPTS.uTVSec - entryIvsInfo.tvPTS.uTVSec;
      strInterval := MainForm.GetGroupTimeInteval(time);
      pGroupResultInfo.interval := strInterval;
    end;

    //ͼƬ
    entrySN := StrPas(@entryDGInfo.vzSN[0]);
    if((entryIvsInfo.uId > 0) and (Trim(entrySN) <> '')) then
    begin
      FGroupImgThread1 := TGroupThread.Create(mhandle, entryIvsInfo.uId , entrySN, 0);
    end;

    //ͼƬ
    exitSN := StrPas(@exitDGInfo.vzSN[0]);
    if((exitIvsInfo.uId > 0) and (Trim(exitSN)<> '')) then
    begin
      FGroupImgThread2 := TGroupThread.Create(mhandle, exitIvsInfo.uId, exitSN, 1);
    end;

    PostMessage(MainForm.Handle, GROUP_RESULT_MSG, Integer(pGroupResultInfo), 0);
  end;
end;

procedure TMainForm.GetGroupResultMsg(var Msg: TMessage);
var
  i, count: Integer;
  strDevIP: string;
  pGroupInfo : PGROUP_RESULT_INFO;
begin
  pGroupInfo := PGROUP_RESULT_INFO(Msg.WParam);

  //ʶ
  if (pGroupInfo.entryExitType = 0) then
  begin
    edtPlate.Text := pGroupInfo.license;
  end
  else if pGroupInfo.entryExitType = 1 then
  begin
    edtPlate2.Text := pGroupInfo.license;
  end;

   //ͬһ̨豸ֻܴһ
  count := lvDev.Items.Count;
  for i:=0 to count - 1 do
  begin
    if (pGroupInfo.lprHandle = StrToInt(lvDev.Items[i].SubItems.Strings[1])) then
    begin
      strDevIP := lvDev.Items[i].Caption;
    end;
  end;

  with lvGroupResult.Items.Add do
  begin
    Caption := strDevIP;
    SubItems.Add(pGroupInfo.license);
    SubItems.Add(pGroupInfo.entryTime);
    SubItems.Add(pGroupInfo.exitTime);
    SubItems.Add(pGroupInfo.interval);
  end;

  FreeMem(pGroupInfo);
end;

procedure TMainForm.GroupNetForm_Greae(Sender: TObject);
begin
  //DLL
  LoadBusModule();

  //SDKʼ
  VzLPRClient_Setup();

  //ʼؼ
  InitCtls();

  //ʼ
  InitVars();
end;

procedure TMainForm.InitCtls();
begin
  lvDev.Columns.Add;
  lvDev.Columns.Add;
  lvDev.Columns[0].Caption := '豸IP';
  lvDev.Columns[1].Caption := 'Ƿ';
  lvDev.Columns[0].Width := 100;
  lvDev.Columns[1].Width := 120;

  lvGroupResult.Columns.Add;
  lvGroupResult.Columns.Add;
  lvGroupResult.Columns.Add;
  lvGroupResult.Columns.Add;
  lvGroupResult.Columns.Add;
  lvGroupResult.Columns[0].Caption := '豸IP';
  lvGroupResult.Columns[1].Caption := 'ƺ';
  lvGroupResult.Columns[2].Caption := 'ʱ';
  lvGroupResult.Columns[3].Caption := 'ʱ';
  lvGroupResult.Columns[4].Caption := 'ʱ';
  lvGroupResult.Columns[0].Width := 100;
  lvGroupResult.Columns[1].Width := 100;
  lvGroupResult.Columns[2].Width := 140;
  lvGroupResult.Columns[3].Width := 140;
  lvGroupResult.Columns[4].Width := 100;

  InitImgEnter();
  InitImgExit();
end;

procedure TMainForm.InitImgEnter;
begin
  imgEnter.Canvas.Pen.Width := 1;
  imgEnter.Canvas.Pen.Color := clWhite;
  imgEnter.Canvas.Brush.Color := clSilver;
  imgEnter.Canvas.Pen.Mode := pmCopy;
  imgEnter.Canvas.Rectangle(0,0,321,265);
end;

procedure TMainForm.InitImgExit;
begin
  imgExit.Canvas.Pen.Width := 1;
  imgExit.Canvas.Pen.Color := clWhite;
  imgExit.Canvas.Brush.Color := clSilver;
  imgExit.Canvas.Pen.Mode := pmCopy;
  imgExit.Canvas.Rectangle(0,0,321,265);
end;

procedure TMainForm.InitVars();
begin
  mFirst := True;
  mPlayHandle := 0;
  mPlayHandle2 := 0;
end;

procedure TMainForm.ClearVideo1();
begin
  pnl1.Color := clSilver;
  pnl1.Refresh;
  pnl1.Tag := 0;

  edtPlate.Text := '';

  imgEnter.Picture := nil;
  InitImgEnter();
end;

procedure TMainForm.CLearVideo2();
begin
  pnl2.Color := clSilver;
  pnl2.Refresh;
  pnl2.Tag := 0;

  edtPlate2.Text := '';

  imgExit.Picture := nil;
  InitImgExit();
end;


procedure TMainForm.btnOpenClick(Sender: TObject);
var
  strIP, strUsername, strPwd:PChar;
  mPort:Word;
  mHandle:VzLPRClientHandle;
  count,i:Integer;
begin
  strIP := PChar(edtDevIP.Text);
  mPort := StrToInt(edtPort.Text);
  strUsername := PChar(edtUsername.Text);
  strPwd := PChar(edtPwd.Text);

  //ͬһ̨豸ֻܴһ
  count := lvDev.Items.Count;
  for i:=0 to count - 1 do
  begin
    if (StrPas(strIP)) = lvDev.Items[i].Caption then
    begin
      ShowMessage('豸Ѵ');
      Exit;
    end;
  end;

  //豸
  mHandle := VzLPRClient_Open(strIP, mPort, strUsername, strPwd);
  if mHandle = 0 then
  begin
    ShowMessage('豸ʧܣ¼Ϣ!');
    Exit;
  end;

  //ӵб
  with  lvDev.Items.Add do
  begin
    Caption := strIP;
    SubItems.Add('');
    SubItems.Add(IntToStr(mHandle));
  end;

  //ѡһ
  lvDev.SetFocus;
  lvDev.Items[lvDev.Items.Count -1].Selected := True;

end;

function TMainForm.GetSeleHandle():Integer;
var
  nHande: Integer;
begin
  if(lvDev.Selected <> nil) then
  begin
    nHande := StrToInt(lvDev.Selected.SubItems.Strings[1]);
    Result := nHande;
  end
  else
  begin
    Result := 0;
  end;
end;

function TMainForm.GetVideo1Handle():Integer;
begin
  if(pnl1.Tag <> 0) then
  begin
    Result := pnl1.Tag;
  end
  else
  begin
    Result := 0;
  end;
end;

function TMainForm.GetVideo2Handle():Integer;
begin
  if(pnl2.Tag <> 0) then
  begin
    Result := pnl2.Tag;
  end
  else
  begin
    Result := 0;
  end;
end;

procedure TMainForm.btnPlayVideoClick(Sender: TObject);
var
  lprHandle, videoHandle:VzLPRClientHandle;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  if((lprHandle = GetVideo1Handle()) or (lprHandle = GetVideo2Handle)) then
  begin
    ShowMessage('豸ѾƵ,ֹͣ!');
    Exit;
  end;

  if mFirst = True then
  begin
    if(mPlayHandle > 0) then
    begin
      VzLPRClient_StopRealPlay(mPlayHandle);
      mPlayHandle := 0;
    end;

    videoHandle := GetVideo1Handle();
    if(videoHandle > 0) then
    begin
      VzLPRClient_SetPlateInfoCallBack(videoHandle, nil, nil, 0);
    end;

    VzLPRClient_SetPlateInfoCallBack(lprHandle, OnPlateInfo1, Self, 1);
    mPlayHandle := VzLPRClient_StartRealPlay(lprHandle, pnl1.Handle);
    pnl1.Tag := lprHandle;
  end
  else
  begin
    if (mPlayHandle2 > 0) then
    begin
      VzLPRClient_StopRealPlay(mPlayHandle2);
      mPlayHandle2 := 0;
    end;

    videoHandle := GetVideo2Handle();
    if(videoHandle > 0) then
    begin
      VzLPRClient_SetPlateInfoCallBack(videoHandle, nil, nil, 0);
    end;
    VzLPRClient_SetPlateInfoCallBack(lprHandle, OnPlateInfo1, Self, 1);
    mPlayHandle2 := VzLPRClient_StartRealPlay(lprHandle, pnl2.Handle);
    pnl2.Tag := lprHandle;
  end;

end;

procedure TMainForm.btnCloseClick(Sender: TObject);
var
  lprHandle:Integer;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  if (lprHandle = GetVideo1Handle()) then
  begin
    if(mPlayHandle > 0) then
    begin
      VzLPRClient_StopRealPlay(mPlayHandle);
      mPlayHandle := 0;
    end;

    ClearVideo1();
  end
  else
  begin
    if(mPlayHandle2 > 0) then
    begin
      VzLPRClient_StopRealPlay(mPlayHandle2);
      mPlayHandle2 := 0;
    end;

    CLearVideo2();
  end;

  VzLPRClient_Close(lprHandle);

  lvDev.Selected.Delete;
end;

procedure TMainForm.btnStopPlayClick(Sender: TObject);
var
  lprHandle, videoHandle:Integer;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  if(mFirst) then
  begin
    if (mPlayHandle > 0) then
    begin
      VzLPRClient_StopRealPlay(mPlayHandle);
      mPlayHandle := 0;
    end;

    videoHandle := GetVideo1Handle();
    if (videoHandle > 0) then
    begin
      VzLPRClient_SetPlateInfoCallBack(videoHandle, nil, nil, 0);
    end;

    CLearVideo1();

  end
  else
  begin
    if(mPlayHandle2 > 0) then
    begin
      VzLPRClient_StopRealPlay(mPlayHandle2);
      mPlayHandle2 := 0;
    end;

    videoHandle := GetVideo2Handle();
    if(videoHandle > 0) then
    begin
      VzLPRClient_SetPlateInfoCallBack(videoHandle, nil, nil, 0);
    end;

    CLearVideo2();
  end;
end;

procedure TMainForm.btnForceTriggerClick(Sender: TObject);
var
  lprHandle : Integer;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  if lprHandle > 0 then
  begin
    VzLPRClient_ForceTrigger(lprHandle);
  end;
end;

procedure TMainForm.GroupNetForm_Close(Sender: TObject;
  var Action: TCloseAction);
begin
  //رƵ1
  if(mPlayHandle > 0)then
  begin
    VzLPRClient_StopRealPlay(mPlayHandle);
    mPlayHandle := 0;
  end;

  //رƵ2
  if(mPlayHandle2 > 0)then
  begin
    VzLPRClient_StopRealPlay(mPlayHandle2);
    mPlayHandle2 := 0;
  end;

  //SDKͷȫ
  VzLPRClient_Cleanup();

  FreeAndNil(FGroupImgThread1);
  FreeAndNil(FGroupImgThread2);
end;

procedure TMainForm.pnl1_click(Sender: TObject);
begin
  pnl1.Color := clGray;
  pnl2.Color := clSilver;

  mFirst := True;
end;

procedure TMainForm.pnl2_OnClick(Sender: TObject);
begin
  pnl1.Color := clSilver;
  pnl2.Color := clGray;

  mFirst := False;
end;

procedure TMainForm.btnOpenGroupClick(Sender: TObject);
var
  lprHandle, ret : Integer;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  ret := VzLPRClient_SetDGResultEnable(lprHandle, True);
  if (ret <> 0) then
  begin
    ShowMessage('ʧ');
    Exit;
  end;
  lvDev.Selected.SubItems.Strings[0] := '';

  VzLPRClient_SetPlateGroupInfoCallBack(lprHandle, OnGroupResult, Self);
end;

procedure TMainForm.btnStopGroupClick(Sender: TObject);
var
  lprHandle, ret : Integer;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  ret := VzLPRClient_SetDGResultEnable(lprHandle, False);
  if (ret <> 0) then
  begin
    ShowMessage('ֹͣʧ');
    Exit;
  end;
  lvDev.Selected.SubItems.Strings[0] := '';

  VzLPRClient_SetPlateGroupInfoCallBack(lprHandle, nil, nil);
end;

function TMainForm.GetGroupTimeInteval(time: Integer):string;
var
  h, m, s:Integer;
  strInterval: string;
begin
  h := 0;
  m := 0;
  s := 0;
  if time = 0 then
  begin
    strInterval := '0';
  end
  else
  begin
    s := time mod 60;
    m := time div 60;
    m := m mod 60;
    h := time div 3600;
    
    if (h > 0) then
    begin
      strInterval := IntToStr(h) + 'ʱ' + IntToStr(m) + '' + IntToStr(s) + '';
    end
    else if (m > 0) then
    begin
      strInterval := IntToStr(m) + '' + IntToStr(s) + '';
    end
    else if (s > 0) then
    begin
      strInterval :=  IntToStr(s) + '';
    end;
  end;
  Result := strInterval;
end;



end.
