unit VzDephiSDKDemoMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, VzLPRSDK, jpeg, ComCtrls;

const
    PLATE_INFO_MSG1 = WM_USER+101;
    PLATE_INFO_MSG2 = WM_USER+102;
    DEV_FOUND_MSG   = WM_USER+103;

type
  TFormMain = class(TForm)
    GroupBoxLogin: TGroupBox;
    lblDevIP: TLabel;
    lblUsername: TLabel;
    lblPort: TLabel;
    lblPwd: TLabel;
    edtDevIP: TEdit;
    edtPort: TEdit;
    edtUsername: TEdit;
    edtPwd: TEdit;
    btnOpen: TButton;
    btnClose: TButton;
    pnlVideo1: TPanel;
    pnlVideo2: TPanel;
    btnVideoPlay: TButton;
    btnVideoStop: TButton;
    btnManual: TButton;
    lblPlateResult1: TLabel;
    lblPlateResult2: TLabel;
    edtplate1: TEdit;
    edtPlate2: TEdit;
    imgPlate1: TImage;
    imgPlate2: TImage;
    btnRecord: TButton;
    btnRecordStop: TButton;
    btnCapture: TButton;
    btnGPIO: TButton;
    btnIsConnected: TButton;
    btnOSDCfg: TButton;
    btnBaseConfig: TButton;
    btnVideoConfig: TButton;
    btnInAndOut: TButton;
    grp1: TGroupBox;
    btnStartSearchDev: TButton;
    btnStopSearchDev: TButton;
    btnNetCfg: TButton;
    btnWhiteList: TButton;
    btnPlateQuery: TButton;
    btnRS485: TButton;
    tvFindDev: TTreeView;
    tvOpenDevice: TTreeView;
    lblUserPwd: TLabel;
    edtUserPwd: TEdit;
    btnPlayVoice: TButton;
    procedure btnOpenClick(Sender: TObject);
    procedure FromCreate(Sender: TObject);
    procedure btnVideoPlayClick(Sender: TObject);
    procedure btnManualClick(Sender: TObject);
    procedure GetPlateInfoMsg1(var Msg:TMessage);message PLATE_INFO_MSG1;
    procedure GetPlateInfoMsg2(var Msg:TMessage);message PLATE_INFO_MSG2;
    procedure btnCloseClick(Sender: TObject);
    procedure video1Play(Sender: TObject);
    procedure video2Play(Sender: TObject);
    procedure btnVideoStopClick(Sender: TObject);
    procedure btnCaptureClick(Sender: TObject);
    procedure btnRecordClick(Sender: TObject);
    procedure btnRecordStopClick(Sender: TObject);
    procedure btnIsConnectedClick(Sender: TObject);
    procedure btnGPIOClick(Sender: TObject);
    procedure btnOSDCfgClick(Sender: TObject);
    procedure btnBaseConfigClick(Sender: TObject);
    procedure btnVideoConfigClick(Sender: TObject);
    procedure btnInAndOutClick(Sender: TObject);
    procedure btnStopSearchDevClick(Sender: TObject);
    procedure btnStartSearchDevClick(Sender: TObject);
    procedure btnWhiteListClick(Sender: TObject);
    procedure btnPlateQueryClick(Sender: TObject);
    procedure btnRS485Click(Sender: TObject);
    procedure btnNetCfgClick(Sender: TObject);
    //procedure LvFindDev_Deletion(Sender: TObject; Node: TTreeNode);
    procedure FromClose(Sender: TObject; var Action: TCloseAction);
    procedure btnPlayVoiceClick(Sender: TObject);
  private
    function GetVideo1Handle: Integer;
    function GetVideo2Handle: Integer;
    function GetSeleHandle: Integer;
    procedure GetFindDevMsg(var Msg: TMessage);message DEV_FOUND_MSG;
    procedure InitImgPlate1;
    procedure InitImgPlate2;
    procedure ClearPic1;
    procedure ClearPic2;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;
  mPlayHandle, mPlayHandle2  : Integer;
  mFirst, bFindDev  : Boolean;
  m_sAppPath : string;
  m_sUserPwd : string;

implementation
uses frmOSDSet, frmBaseCfg, frmVideoCfg, frmInAndOut, frmWhiteList, frmPlateQuery, frmSerialControl, frmNetCfg, frmPlayVoice;

{$R *.dfm}
 //豸Ϣ
type
    DEVICE_INFO = record
    szIPAddr : array[0..15] of Char;
    usPort1  : Word;
    usPort2  : Word;
    SL       : LongWord;
    SH       : LongWord;
end;
   PDEVICE_INFO  = ^DEVICE_INFO ;

//ʾϢ
type
    DevPlate_INFO = record
    sPlatePath : array[0..259] of Char;
end;
   PDevPlate_INFO  = ^DevPlate_INFO ;

//豸
procedure TFormMain.btnOpenClick(Sender: TObject);
var
  strIP, strUser, strPwd: PChar;
  mPort: Word;
  mHandle : VzLPRClientHandle;
  index :Integer;
  pdata : LPVZ_LPRC_ACTIVE_ENCRYPT;
  mRet: Integer;
begin
  strIP := PChar(edtDevIP.Text);
  strUser := PChar(edtUsername.Text);
  strPwd := PChar(edtPwd.Text);
  mPort := StrToInt(edtPort.Text);
  m_sUserPwd := Trim(edtUserPwd.Text);

  mHandle := VzLPRClient_Open(strIP, mPort, strUser, strPwd);
  if mHandle = 0 then
  begin
    ShowMessage('豸ʧܣ¼Ϣ!');
  end
  else
  begin
    tvOpenDevice.Items.AddObjectFirst(nil, strIP, TObject(mHandle)); //IPhandle ӵб
    tvOpenDevice.Items[0].Selected := True;//ѡеǰ
  end
end;

//
procedure TFormMain.FromCreate(Sender: TObject);
begin
  //DLL
  LoadBusModule();

  //SDKʼ
  VzLPRClient_Setup();

  //ʼ
  mFirst := True;
  m_sAppPath :=  ExtractFilePath(ParamStr(0));

  pnlVideo1.Tag := 0;
  pnlVideo2.Tag := 0;

  //ʼͼƬؼ1ɫ
  InitImgPlate1();

  //ʼͼƬؼ2ɫ
  InitImgPlate2();

end;

//ʼʾͼƬؼ 1
procedure TFormMain.InitImgPlate1();
begin
  imgPlate1.Canvas.Pen.Width := 1;
  imgPlate1.Canvas.Pen.Color := clWhite;
  imgPlate1.Canvas.Brush.Color := clSilver;
  imgPlate1.Canvas.Pen.Mode := pmCopy;
  imgPlate1.Canvas.Rectangle(0,0,353,297);
end;

//ʼʾͼƬؼ 2
procedure TFormMain.InitImgPlate2();
begin
  imgPlate2.Canvas.Pen.Width := 1;
  imgPlate2.Canvas.Pen.Color := clWhite;
  imgPlate2.Canvas.Brush.Color := clSilver;
  imgPlate2.Canvas.Pen.Mode := pmCopy;
  imgPlate2.Canvas.Rectangle(0,0,353,297);
end;


//ȡ豸
function TFormMain.GetSeleHandle() :Integer;
var
   nHandle : Integer;
begin
   if (tvOpenDevice.Selected <> nil ) then
   begin
     nHandle := Integer(tvOpenDevice.Selected.Data);
     Result := nHandle;
   end
   else
   begin
     Result := 0;
   end;
end;

//ȡƵ1
function TFormMain.GetVideo1Handle() :Integer;
begin
  if (pnlVideo1.Tag <> 0) then
  begin
    Result := pnlVideo1.Tag;
  end
  else
  begin
    Result := 0;
  end;
end;

//ȡƵ2
function TFormMain.GetVideo2Handle() :Integer;
begin
  if (pnlVideo2.Tag <> 0) then
  begin
    Result := pnlVideo2.Tag;
  end
  else
  begin
    Result := 0;
  end;
end;

//ʶص2
function OnPlateInfo2(mhandle: VzLPRClientHandle; pUserData: Pointer; pResult: PTH_PlateResult; uNumPlates: Word; eResultType: VZ_LPRC_RESULT_TYPE; var pImgFull: VZ_LPRC_IMAGE_INFO; var pImgPlateClip: VZ_LPRC_IMAGE_INFO): Integer; stdcall;
var
  pPResult : PTH_PlateResult;
  strFile, sPlatePath, strPlate: string;
  arrPlate : array[0..15] of Char;
  pDevPlatePath : PDevPlate_INFO;
  mRet,i: Integer;
  sUserPwd : PChar;
  bIsEncrypt : Boolean;
begin
  if (eResultType > VZ_LPRC_RESULT_REALTIME) then
  begin
    GetMem(pDevPlatePath,SizeOf(TH_PlateResult));  //ٿռ
    ZeroMemory(pDevPlatePath,SizeOf(TH_PlateResult)); //

    GetMem(pPResult,SizeOf(TH_PlateResult));  //ٿռ
    ZeroMemory(pPResult,SizeOf(TH_PlateResult)); //
    CopyMemory(pPResult, pResult, SizeOf(TH_PlateResult)); //

    strFile := ExtractFilePath(ParamStr(0))  +'Result\';
    if not DirectoryExists(strFile) then
    begin
       ForceDirectories(strFile); //Ŀ¼
    end;

    //Գƽ
    bIsEncrypt := True;
    for i:= 0 to 14 do
    begin
      if(pPResult.license[i] = #0)  then
      begin
        bIsEncrypt := False;
        Break;
      end;
    end;

    if(bIsEncrypt) then
    begin
      sUserPwd := PChar(m_sUserPwd);

      mRet := VzLPRClient_AesCtrDecrypt(PChar(@pPResult.license[0]), 16, sUserPwd, PChar(@arrPlate[0]), 16) ;
      if(mRet = 0)then
      begin
        strPlate := StrPas(@arrPlate[0]);
        StrCopy(PChar(@pPResult.license[0]), PChar(@arrPlate[0]));
      end;
    end
    else
    begin
       strPlate := StrPas(@pPResult.license[0]);
    end;

    sPlatePath :=  strFile + strPlate +  FormatDateTime('_yyyymmddhhnnss',Now) + '.jpg' ;

    mRet := VzLPRClient_ImageSaveToJpeg(@pImgFull, PChar(sPlatePath), 90); //ͼ񱣴ΪJPEGָ·

    StrCopy(@pDevPlatePath.sPlatePath[0], PChar(sPlatePath));
     // ͽ߳
    PostMessage(FormMain.Handle, PLATE_INFO_MSG2,Integer(pPResult),Integer(pDevPlatePath));
  end;

end;

//ʶص1
function OnPlateInfo1(mhandle: VzLPRClientHandle; pUserData: Pointer; pResult: PTH_PlateResult; uNumPlates: Word; eResultType: VZ_LPRC_RESULT_TYPE; var pImgFull: VZ_LPRC_IMAGE_INFO; var pImgPlateClip: VZ_LPRC_IMAGE_INFO): Integer; stdcall;
var
  pPResult : PTH_PlateResult;
  pDevPlatePath : PDevPlate_INFO;
  strFile, sPlatePath, strPlate: string;
  arrPlate : array[0..15] of Char;
  sUserPwd : PChar;
  mRet,i: Integer;
  bIsEncrypt1 : Boolean;
begin
  if (eResultType > VZ_LPRC_RESULT_REALTIME) then
  begin
    GetMem(pDevPlatePath,SizeOf(TH_PlateResult));  //ٿռ
    ZeroMemory(pDevPlatePath,SizeOf(TH_PlateResult)); //

    GetMem(pPResult,SizeOf(TH_PlateResult));  //ٿռ
    ZeroMemory(pPResult,SizeOf(TH_PlateResult)); //
    CopyMemory(pPResult, pResult, SizeOf(TH_PlateResult)); //

    strFile := ExtractFilePath(ParamStr(0))  +'Result\';
    if not DirectoryExists(strFile) then
    begin
       ForceDirectories(strFile); //Ŀ¼
    end;

    //Գƽ
    bIsEncrypt1 := True;
    for i:= 0 to 14 do
    begin
      if(pPResult.license[i] = #0)  then
      begin
        bIsEncrypt1 := False;
        Break;
      end;
    end;

    if(bIsEncrypt1) then
    begin
      sUserPwd := PChar(m_sUserPwd);

      mRet := VzLPRClient_AesCtrDecrypt(PChar(@pPResult.license[0]), 16, sUserPwd, PChar(@arrPlate[0]), 16) ;
      if(mRet = 0)then
      begin
        StrCopy(PChar(@pPResult.license[0]), PChar(@arrPlate[0]));
        strPlate := StrPas(@arrPlate[0]);
      end;
    end
    else
    begin
       strPlate := StrPas(@pPResult.license[0]);
    end;

    sPlatePath :=  strFile + strPlate +  FormatDateTime('_yyyymmddhhnnss',Now) + '.jpg' ;

    mRet := VzLPRClient_ImageSaveToJpeg(@pImgFull, PChar(sPlatePath), 90); //ͼ񱣴ΪJPEGָ·

    StrCopy(@pDevPlatePath.sPlatePath[0], PChar(sPlatePath));
     // ͽ߳
    PostMessage(FormMain.Handle, PLATE_INFO_MSG1,Integer(pPResult),Integer(pDevPlatePath));
  end;
end;

//ʾʶ 1
procedure TFormMain.GetPlateInfoMsg1(var Msg: TMessage);
var
  pDevPlatePath: PDevPlate_INFO;
  jpegImgPlate : TJPEGImage;
  pPResult : PTH_PlateResult;
  strFilePath : string;
begin
  pPResult :=  PTH_PlateResult(Msg.WParam);
  pDevPlatePath := PDevPlate_INFO(Msg.LParam);

  //ʾƺ
  edtplate1.Text := pPResult.license;

  //ʾʶͼƬ
  strFilePath := StrPas(@pDevPlatePath.sPlatePath[0]);
  if (Trim(strFilePath) <> '') then
  begin
    jpegImgPlate := TJPEGImage.Create;  //JPEGͼ

     try
      jpegImgPlate.LoadFromFile(strFilePath);

      imgPlate1.Picture.Graphic := jpegImgPlate;

    finally
      jpegImgPlate.Free;
    end;

  end;

  FreeMem(pPResult);  //ͷڴ
  FreeMem(pDevPlatePath);
end;

//ʾʶ 2
procedure TFormMain.GetPlateInfoMsg2(var Msg: TMessage);
var
  pDevPlatePath2: PDevPlate_INFO;
  strFile, strPlate: string;
  jpegImgPlate : TJPEGImage;
  pPResult2 : PTH_PlateResult;
begin
  pPResult2 := PTH_PlateResult(Msg.WParam);
  pDevPlatePath2   := PDevPlate_INFO(Msg.LParam);

  //ʾƺ
  edtPlate2.Text := pPResult2.license;

   //ʾʶͼƬ
  strFile := StrPas(@pDevPlatePath2.sPlatePath[0]);
  if (Trim(strFile) <> '') then
  begin
    jpegImgPlate := TJPEGImage.Create;  //JPEGͼ
    try
      jpegImgPlate.LoadFromFile(strFile);

      imgPlate2.Picture.Graphic := jpegImgPlate;

    finally
      jpegImgPlate.Free;
    end;
  end;

  FreeMem(pPResult2);  //ͷڴ
  FreeMem(pDevPlatePath2);
end;

//Ƶ
procedure TFormMain.btnVideoPlayClick(Sender: TObject);
var
  lprHandle, lprHandle1, lprHandle2  :Integer;
begin
    lprHandle := GetSeleHandle();
    if lprHandle = 0 then
    begin
      ShowMessage('ѡһ̨бе豸!');
      Exit;
    end
    else
    begin
      if((lprHandle = GetVideo1Handle()) or (lprHandle = GetVideo2Handle()))  then
      begin
        ShowMessage('豸ѾƵڣֹͣ!');
        Exit;
      end;

      if mFirst = True then
      begin
        if(mPlayHandle >0) then
        begin
          VzLPRClient_StopRealPlay(mPlayHandle);  //رյǰŵƵ
          mPlayHandle := 0;
        end;

        lprHandle1 := GetVideo1Handle();
        if (lprHandle1 > 0) then
        begin
          VzLPRClient_SetPlateInfoCallBack(lprHandle1, nil, nil, 0);
        end;

        VzLPRClient_SetPlateInfoCallBack(lprHandle, OnPlateInfo1, Self, 1);
        mPlayHandle := VzLPRClient_StartRealPlay(lprHandle, pnlVideo1.Handle); //ʵʱƵ
        pnlVideo1.Tag := lprHandle;
      end
      else
      begin
        if(mPlayHandle2 > 0) then
        begin
          VzLPRClient_StopRealPlay(mPlayHandle2);
          mPlayHandle2 := 0;
        end;

        lprHandle2 := GetVideo2Handle();
        if (lprHandle2 > 0) then
        begin
          VzLPRClient_SetPlateInfoCallBack(lprHandle2, nil, nil, 0);
        end;

        VzLPRClient_SetPlateInfoCallBack(lprHandle, OnPlateInfo2, Self, 1);
        mPlayHandle2 := VzLPRClient_StartRealPlay(lprHandle, pnlVideo2.Handle); //ʵʱƵ
        pnlVideo2.Tag := lprHandle;
      end;
    end;
end;

//ֶʶ
procedure TFormMain.btnManualClick(Sender: TObject);
var
  lprHandle,ret : Integer;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  if lprHandle > 0 then
  begin
    ret := VzLPRClient_ForceTrigger(lprHandle);
  end;

end;

//ر豸
procedure TFormMain.btnCloseClick(Sender: TObject);
var
  lprHandle : Integer;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  if(lprHandle = GetVideo1Handle) then
  begin
    if (mPlayHandle > 0) then
      begin
        VzLPRClient_StopRealPlay(mPlayHandle);
        mPlayHandle := 0;
      end;

      ClearPic1();
  end
  else
  begin
    if(mPlayHandle2 > 0) then
    begin
      VzLPRClient_StopRealPlay(mPlayHandle2);
      mPlayHandle2 := 0;
    end;

    ClearPic2();
  end;

  VzLPRClient_Close(lprHandle); //ر豸

  tvOpenDevice.Selected.Delete; //ɾб򿪵豸
end;

//Ƶؼ1¼
procedure TFormMain.video1Play(Sender: TObject);
begin
  pnlVideo1.Color :=  clGray;
  pnlVideo2.Color := clSilver;
  mFirst := True;
end;

//Ƶؼ2¼
procedure TFormMain.video2Play(Sender: TObject);
begin
  pnlVideo2.Color :=  clGray;
  pnlVideo1.Color := clSilver;
  mFirst := False;
end;

//ͼƬ1
procedure  TFormMain.ClearPic1();
begin
  pnlVideo1.Color := clSilver;
  pnlVideo1.Refresh;
  pnlVideo1.Tag := 0;

  edtplate1.Text := '';
  imgPlate1.Picture := nil;  //ͼƬ

  //ͼƬؼ1ɫ
  InitImgPlate1();
end;

//ͼƬ2
procedure  TFormMain.ClearPic2();
begin
  pnlVideo2.Color := clSilver;
  pnlVideo2.Refresh;
  pnlVideo2.Tag := 0;

  edtplate2.Text := '';
  imgPlate2.Picture := nil;  //ͼƬ

  //ͼƬؼ1ɫ
  InitImgPlate2();
end;

//ֹͣ
procedure TFormMain.btnVideoStopClick(Sender: TObject);
var
  lprHandle, lprHandle1, lprHandle2 : Integer;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  if(mFirst) then
  begin
    if (mPlayHandle > 0) then
    begin
      VzLPRClient_StopRealPlay(mPlayHandle);
      mPlayHandle := 0;
    end;

    lprHandle1 := GetVideo1Handle();
    if (lprHandle1 > 0) then
    begin
      VzLPRClient_SetPlateInfoCallBack(lprHandle1, nil, nil, 0);
    end;

    //ͼƬ1
    ClearPic1();
  end
  else
  begin
    if(mPlayHandle2 > 0) then
    begin
      VzLPRClient_StopRealPlay(mPlayHandle2);
      mPlayHandle2 := 0;
    end;

    lprHandle2 := GetVideo2Handle();
    if(lprHandle2 > 0) then
    begin
      VzLPRClient_SetPlateInfoCallBack(lprHandle2, nil, nil, 0);
    end;
  
     //ͼƬ2
    ClearPic2();

  end;
end;

//ץͼ
procedure TFormMain.btnCaptureClick(Sender: TObject);
var
  sFilePath ,sPlatePath : string;
  mRet :Integer;
begin
  sFilePath := ExtractFilePath(ParamStr(0)) + 'Snap\';
  if not DirectoryExists(sFilePath) then
  begin
    ForceDirectories(sFilePath);
  end;
  sPlatePath := sFilePath + FormatDateTime('yyyymmddhhnnss',Now) + '.jpg';
  mRet := -1;
  if(mFirst = True) then
  begin
    if(mPlayHandle > 0)  then
    begin
      mRet := VzLPRClient_GetSnapShootToJpeg2(mPlayHandle, PChar(sPlatePath), 80); //ڲŵƵĵǰ֡Ľͼָ·
    end;
  end
  else
  begin
    if(mPlayHandle2 > 0) then
    begin
      mRet := VzLPRClient_GetSnapShootToJpeg2(mPlayHandle2, PChar(sPlatePath), 80)
    end;
  end;

  if (mRet = 0) then
  begin
    ShowMessage('ͼɹ !');
  end
  else
  begin
    ShowMessage('ͼʧܣƵǷ񲥷 !');
  end;
end;

//ʼ¼
procedure TFormMain.btnRecordClick(Sender: TObject);
var
  lprHandle ,ret: Integer;
  sFilePath,sRecordPath : string;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  sFilePath := ExtractFilePath(ParamStr(0)) + 'Video\' ;
 if not DirectoryExists(sFilePath) then
  begin
    ForceDirectories(sFilePath);
  end;
                
  sRecordPath := sFilePath + FormatDateTime('yyyymmddhhmmss',Now) + '.avi';
  ret := VzLPRClient_SaveRealData(lprHandle, PChar(sRecordPath));
  
  btnRecord.Enabled := False;
  btnRecordStop.Enabled := True;
end;

//ֹͣ¼
procedure TFormMain.btnRecordStopClick(Sender: TObject);
var
  lprHandle ,ret : Integer;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  VzLPRClient_StopSaveRealData(lprHandle);  //ֹͣ¼

  btnRecord.Enabled := True;
  btnRecordStop.Enabled := False;
   
end;

//״̬
procedure TFormMain.btnIsConnectedClick(Sender: TObject);
var
  lprHandle ,mRet: Integer;
  cState : Byte;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  mRet := VzLPRClient_IsConnected(lprHandle,cState); //ȡ״̬
  if (cState = 1) then
  begin
    ShowMessage('!');
  end
  else
  begin
    ShowMessage('ʧ!');
  end;
end;

//GPIO
procedure TFormMain.btnGPIOClick(Sender: TObject);
var
  lprHandle,nValue : Integer;
  mRet :Integer;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  mRet := VzLPRClient_GetGPIOValue(lprHandle, 0, nValue);//ȡGPIO״̬
  if nValue = 0 then
  begin
    ShowMessage('IOIput is [·]');
  end
  else
  begin
    if nValue = 1 then
    begin
      ShowMessage('IOIput is [·]');
    end;
  end;
end;

//OSD
procedure TFormMain.btnOSDCfgClick(Sender: TObject);
var
  lprHandle : Integer;
  fromOSDSet : TFormOSDSet;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  fromOSDSet := TFormOSDSet.Create(Application);
  fromOSDSet.SetLPRHandle(lprHandle);
  fromOSDSet.Show;
end;

//
procedure TFormMain.btnBaseConfigClick(Sender: TObject);
var
  lprHandle : Integer;
  fromBaseCfg :TFormBaseCfg;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  fromBaseCfg := TFormBaseCfg.Create(Application);
  fromBaseCfg.SetLPRHandle(lprHandle);
  fromBaseCfg.Show;
end;

//Ƶ
procedure TFormMain.btnVideoConfigClick(Sender: TObject);
var
  lprHandle : Integer;
  fromVideoCfg :TFormVideoCfg;
begin
   lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  fromVideoCfg := TFormVideoCfg.Create(Application);
  fromVideoCfg.SetLPRHandle(lprHandle);
  fromVideoCfg.Show;
end;

//
procedure TFormMain.btnInAndOutClick(Sender: TObject);
var
  lprHandle : Integer;
  fromInAndOut : TFormInAndOut;
begin
   lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  fromInAndOut := TFormInAndOut.Create(Application);
  fromInAndOut.SetLPRHandle(lprHandle);
  fromInAndOut.Show;
end;

//ֹͣ
procedure TFormMain.btnStopSearchDevClick(Sender: TObject);
var
  mRet : Integer;
begin
  mRet := VZLPRClient_StopFindDevice();
  bFindDev := False;
end;

//豸ص
function OnDevFound(pStrDevName: PChar; pStrIPAddr: PChar; usPort1: Word; usPort2: Word; SL : LongWord; SH : LongWord; pUserData: Pointer): Integer; stdcall;
var
  pDeviceInfo : PDEVICE_INFO;
begin
  if ((pStrIPAddr <> nil) and (usPort1 > 0)) then
  begin
     GetMem(pDeviceInfo, SizeOf(DEVICE_INFO)); //ٿռ
     ZeroMemory(pDeviceInfo,SizeOf(DEVICE_INFO));//

     StrCopy(@pDeviceInfo.szIPAddr, pStrIPAddr);
     pDeviceInfo.usPort1 := usPort1;
     pDeviceInfo.usPort2 := usPort2;
     pDeviceInfo.SL := SL;
     pDeviceInfo.SH := SH;

     PostMessage(FormMain.Handle, DEV_FOUND_MSG ,Integer(pDeviceInfo), 0);
  end;
end;

//ʾҽ
procedure TFormMain.GetFindDevMsg(var Msg: TMessage);
var
  pDevInfo : PDEVICE_INFO;
begin
  pDevInfo := PDEVICE_INFO(Msg.WParam);
  if (pDevInfo <> nil) then
  begin
    tvFindDev.Items.AddObject(nil, StrPas(pDevInfo.szIPAddr), TObject(pDevInfo));
  end;

  FreeMem(pDevInfo);
end;

//ʼ
procedure TFormMain.btnStartSearchDevClick(Sender: TObject);
var
  mRet : Integer;
begin
  mRet := VZLPRClient_StopFindDevice();
  bFindDev := True;

  tvFindDev.Items.Clear;  //б

  VZLPRClient_StartFindDevice(OnDevFound, Self);
end;

//޸IP
procedure TFormMain.btnNetCfgClick(Sender: TObject);
var
  formNetCfg : TFormNetCfg;
  SL, SH : LongWord;
  IP : string;
begin
  if(tvFindDev.SelectionCount <= 0) then
  begin
    ShowMessage('ѡһ̨豸');
    Exit;
  end;
  SL := 0;
  SH := 0;
  IP := tvFindDev.Selected.Text;
  SL := PDEVICE_INFO(tvFindDev.Selected.Data)^.SL;
  SH := PDEVICE_INFO(tvFindDev.Selected.Data)^.SH;

  formNetCfg := TFormNetCfg.Create(Application);
  formNetCfg.SetNetParam(IP, SL, SH);
  formNetCfg.Show;
end;

//procedure TFormMain.LvFindDev_Deletion(Sender: TObject; Node: TTreeNode);
//begin
  //ͷڴ
  //Dispose(PDEVICE_INFO(Node.Data));
//end;

//
procedure TFormMain.btnWhiteListClick(Sender: TObject);
var
  lprHandle : Integer;
  fromWhiteList : TFormWhiteList;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  fromWhiteList := TFormWhiteList.Create(Application);
  fromWhiteList.SetLPRHandle(lprHandle);
  fromWhiteList.Show;
end;

//Ʋѯ
procedure TFormMain.btnPlateQueryClick(Sender: TObject);
var
  lprHandle : Integer;
  fromPlateQuery : TFormPlateQuery;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  fromPlateQuery := TFormPlateQuery.Create(Application);
  fromPlateQuery.SetLPRHandle(lprHandle, m_sAppPath);
  fromPlateQuery.Show;
end;

//485
procedure TFormMain.btnRS485Click(Sender: TObject);
var
  lprHandle : Integer;
  fromSerialCtl : TFormSerialControl;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  fromSerialCtl := TFormSerialControl.Create(Application);
  fromSerialCtl.SetLPRHandle(lprHandle);
  fromSerialCtl.Show;
end;

//ر
procedure TFormMain.FromClose(Sender: TObject; var Action: TCloseAction);
begin
  Action  := caFree;
  //رƵ1
  if(mPlayHandle > 0)then
  begin
    VzLPRClient_StopRealPlay(mPlayHandle);
    mPlayHandle := 0;
  end;

  //رƵ2
  if(mPlayHandle2 > 0)then
  begin
    VzLPRClient_StopRealPlay(mPlayHandle2);
    mPlayHandle2 := 0;
  end;

  
  //ֹͣ
  if(bFindDev = True) then
  begin
    VZLPRClient_StopFindDevice();
    bFindDev := False;
  end;
  
  //SDKͷȫ
  VzLPRClient_Cleanup();


end;


procedure TFormMain.btnPlayVoiceClick(Sender: TObject);
var
  lprHandle : Integer;
  fromPlayVoice : TFormPlayVoice;
begin
  lprHandle := GetSeleHandle();
  if lprHandle = 0 then
  begin
    ShowMessage('ѡһ̨бе豸!');
    Exit;
  end;

  fromPlayVoice := TFormPlayVoice.Create(Application);
  fromPlayVoice.SetLPRHandle(lprHandle);
  fromPlayVoice.Show;
end;

end.
