unit frmBaseCfg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, VzLPRSDK;

type
  TFormBaseCfg = class(TForm)
    lbl1: TLabel;
    chkRealResult: TCheckBox;
    chkPlatePoint: TCheckBox;
    chkVirtualAndReco: TCheckBox;
    chkStableTri: TCheckBox;
    lbl2: TLabel;
    chkVirtualTri: TCheckBox;
    chkIO1Tri: TCheckBox;
    chkIO2Tri: TCheckBox;
    chkIO3Tri: TCheckBox;
    lbl3: TLabel;
    chkBlue: TCheckBox;
    chkYellow: TCheckBox;
    chkBlack: TCheckBox;
    chkCoach: TCheckBox;
    chkPolice: TCheckBox;
    chkArm: TCheckBox;
    chkTag: TCheckBox;
    chkHK: TCheckBox;
    chkEC: TCheckBox;
    btnOK: TButton;
    procedure SetLPRHandle(handle: Integer);
    procedure btnOKClick(Sender: TObject);
  private
    procedure GetRealTimeResult;
    function SetRealTimeResult: Boolean;
    procedure GetTrigType;
    function SetTrigType: Boolean;
    procedure getPlateRecType;
    function setPlateRecType: Boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormBaseCfg: TFormBaseCfg;
  m_hLPRClient : Integer;
  drawMode : VZ_LPRC_DRAWMODE;
  uBitsRecType : Integer;
  uBitsTrigType : Integer;

implementation

{$R *.dfm}
procedure  TFormBaseCfg.SetLPRHandle(handle: Integer);
begin
  m_hLPRClient := handle;

  //ȡʵʱʾ
  GetRealTimeResult();

  //ȡ
  GetTrigType();

  //ȡʶ
  getPlateRecType();

end;

//ȡʵʱʾ
procedure  TFormBaseCfg.GetRealTimeResult();
var
   mRet : Integer;
begin
  mRet := VzLPRClient_GetDrawMode(m_hLPRClient, @drawMode); //ȡƵʾģʽ

  chkRealResult.Checked := (drawMode.byDspAddTarget = 1);//ʵʱ
  chkPlatePoint.Checked := (drawMode.byDspAddTrajectory = 1);//λ
  chkVirtualAndReco.Checked := (drawMode.byDspAddRule = 1) //Ȧʶ
end;

//ʵʱʾ
function TFormBaseCfg.SetRealTimeResult():Boolean;
var
   drawMode : VZ_LPRC_DRAWMODE;
   mRet : Integer;
   bFuncRet : Boolean;
begin
   bFuncRet := True;
   drawMode.byDspAddTarget := Integer(chkRealResult.Checked);
   drawMode.byDspAddTrajectory := Integer(chkPlatePoint.Checked);
   drawMode.byDspAddRule := Integer(chkVirtualAndReco.Checked);

   mRet := VzLPRClient_SetDrawMode(m_hLPRClient, @drawMode); //Ƶʾģʽ
   if (mRet <> 0) then
   begin
     ShowMessage('ʵʱʾʧ! ');
     bFuncRet := False;
   end;
   Result := bFuncRet;
end;

//ȡ
procedure  TFormBaseCfg.GetTrigType();
var
  uBitsTrigType : Integer;
  mRet : Integer;
begin
  mRet := VzLPRClient_GetPlateTrigType(m_hLPRClient, uBitsTrigType);  //ȡõĳʶ𴥷

  chkStableTri.Checked := ((uBitsTrigType and VZ_LPRC_TRIG_ENABLE_STABLE ) <> 0); //ȶʶ𴥷
  chkVirtualTri.Checked := ((uBitsTrigType and VZ_LPRC_TRIG_ENABLE_VLOOP ) <> 0); //Ȧ
  chkIO1Tri.Checked := ((uBitsTrigType and VZ_LPRC_TRIG_ENABLE_IO_IN1 ) <> 0);    //IO1
  chkIO2Tri.Checked := ((uBitsTrigType and VZ_LPRC_TRIG_ENABLE_IO_IN2 ) <> 0);    //IO2
  chkIO3Tri.Checked := ((uBitsTrigType and VZ_LPRC_TRIG_ENABLE_IO_IN3 ) <> 0);    //IO3
end;

//ô
function  TFormBaseCfg.SetTrigType():Boolean;
var
  mRet : Integer;
  bFuncRet : Boolean;
begin
  bFuncRet := True;

  //ȶʶ𴥷
  if (chkStableTri.Checked) then
  begin
    uBitsTrigType := uBitsTrigType or VZ_LPRC_TRIG_ENABLE_STABLE;
  end
  else
  begin
    uBitsTrigType := uBitsTrigType or 0;
  end;

  //Ȧ
  if (chkVirtualTri.Checked) then
  begin
    uBitsTrigType := uBitsTrigType or VZ_LPRC_TRIG_ENABLE_VLOOP;
  end
  else
  begin
    uBitsTrigType := uBitsTrigType or 0;
  end;

  //IO1
  if(chkIO1Tri.Checked) then
  begin
    uBitsTrigType := uBitsTrigType or VZ_LPRC_TRIG_ENABLE_IO_IN1;
  end
  else
  begin
    uBitsTrigType := uBitsTrigType or 0;
  end;

  //IO2
  if(chkIO2Tri.Checked) then
  begin
    uBitsTrigType := uBitsTrigType or VZ_LPRC_TRIG_ENABLE_IO_IN2;
  end
  else
  begin
    uBitsTrigType := uBitsTrigType or 0;
  end;

  //IO3
  if(chkIO3Tri.Checked) then
  begin
    uBitsTrigType := uBitsTrigType or VZ_LPRC_TRIG_ENABLE_IO_IN3;
  end
  else
  begin
    uBitsTrigType := uBitsTrigType or 0;
  end;

  mRet := VzLPRClient_SetPlateTrigType(m_hLPRClient, uBitsTrigType);
  if (mRet <> 0) then
  begin
    ShowMessage('ʧ!');
    bFuncRet := False;
  end;

  Result := bFuncRet;
end;

//ȡʶ
procedure TFormBaseCfg.getPlateRecType();
var
  uBitsRecType :Integer;
  mRet : Integer;
begin
  mRet := VzLPRClient_GetPlateRecType(m_hLPRClient, uBitsRecType); //ȡõҪʶĳ

  chkBlue.Checked := ((uBitsRecType and VZ_LPRC_REC_BLUE) <> 0 );
  chkYellow.Checked := ((uBitsRecType and VZ_LPRC_REC_YELLOW) <> 0 );
  chkBlack.Checked := ((uBitsRecType and VZ_LPRC_REC_BLACK) <> 0 );
  chkCoach.Checked := ((uBitsRecType and VZ_LPRC_REC_COACH) <> 0 );
  chkPolice.Checked := ((uBitsRecType and VZ_LPRC_REC_POLICE) <> 0 );
  chkArm.Checked :=  ((uBitsRecType and VZ_LPRC_REC_AMPOL) <> 0 );
  chkTag.Checked :=  ((uBitsRecType and VZ_LPRC_REC_ARMY) <> 0 );
  chkHK.Checked :=  ((uBitsRecType and VZ_LPRC_REC_GANGAO) <> 0 );
  chkEC.Checked :=  ((uBitsRecType and VZ_LPRC_REC_EMBASSY) <> 0 );
end;

//ó
function  TFormBaseCfg.setPlateRecType():Boolean;
var
  mRet : Integer;
  bFuncRet : Boolean;
begin
  bFuncRet := True;

  //
  if (chkBlue.Checked) then
  begin
    uBitsRecType := uBitsRecType or VZ_LPRC_REC_BLUE;
  end
  else
  begin
    uBitsRecType := uBitsRecType or 0;
  end;

  //
  if (chkYellow.Checked) then
  begin
    uBitsRecType := uBitsRecType or VZ_LPRC_REC_YELLOW;
  end
  else
  begin
    uBitsRecType := uBitsRecType or 0;
  end;

  //
  if(chkBlack.Checked) then
  begin
    uBitsRecType := uBitsRecType or VZ_LPRC_REC_BLACK;
  end
  else
  begin
    uBitsRecType := uBitsRecType or 0;
  end;

  //
  if(chkCoach.Checked) then
  begin
    uBitsRecType := uBitsRecType or VZ_LPRC_REC_COACH;
  end
  else
  begin
    uBitsRecType := uBitsRecType or 0;
  end;

  //
  if(chkPolice.Checked) then
  begin
    uBitsRecType := uBitsRecType or VZ_LPRC_REC_POLICE;
  end
  else
  begin
    uBitsRecType := uBitsRecType or 0;
  end;

  //侯
  if(chkArm.Checked) then
  begin
    uBitsRecType := uBitsRecType or VZ_LPRC_REC_AMPOL;
  end
  else
  begin
    uBitsRecType := uBitsRecType or 0;
  end;

  //
  if(chkTag.Checked) then
  begin
    uBitsRecType := uBitsRecType or VZ_LPRC_REC_ARMY;
  end
  else
  begin
    uBitsRecType := uBitsRecType or 0;
  end;

  //۰
  if(chkHK.Checked) then
  begin
    uBitsRecType := uBitsRecType or VZ_LPRC_REC_GANGAO;
  end
  else
  begin
    uBitsRecType := uBitsRecType or 0;
  end;

  //¹
  if(chkEC.Checked) then
  begin
    uBitsRecType := uBitsRecType or VZ_LPRC_REC_EMBASSY;
  end
  else
  begin
    uBitsRecType := uBitsRecType or 0;
  end;

  mRet := VzLPRClient_SetPlateRecType(m_hLPRClient, uBitsRecType);//Ҫʶĳ
  if(mRet <> 0) then
  begin
    ShowMessage('óʧ!');
    bFuncRet := False;
  end;

  Result := bFuncRet;
end;

//ȷ
procedure TFormBaseCfg.btnOKClick(Sender: TObject);
var
  bRecRet,bTrigRet,bRealRet:Boolean ;
begin
  bRealRet := SetRealTimeResult();
  bTrigRet := SetTrigType();
  bRecRet := setPlateRecType();
  if (bRealRet and bTrigRet and bRecRet) then
  begin
    ShowMessage('óɹ! ');
  end;

  Self.Close;
end;

end.
