unit frmOSDSet;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, VzLPRSDK, ComCtrls;

type
  TFormOSDSet = class(TForm)
    chkOSDDay: TCheckBox;
    lblDayStyle: TLabel;
    cbbDayStyle: TComboBox;
    Label1: TLabel;
    lbl1: TLabel;
    edtOSDDayX: TEdit;
    lbl2: TLabel;
    edtOSDDayY: TEdit;
    chkOSDTime: TCheckBox;
    lbl3: TLabel;
    cbbOSDTime: TComboBox;
    lbl4: TLabel;
    lbl5: TLabel;
    lbl6: TLabel;
    edtOSDTimeX: TEdit;
    edtOSDTimeY: TEdit;
    chkOSDText: TCheckBox;
    lbl7: TLabel;
    lbl8: TLabel;
    edtOSDText: TEdit;
    lbl9: TLabel;
    lbl10: TLabel;
    edtOSDTextX: TEdit;
    edtOSDTextY: TEdit;
    chkUpdateTime: TCheckBox;
    btnOSDSave: TButton;
    btnOSDCancel: TButton;
    dtpDate: TDateTimePicker;
    dtpTime: TDateTimePicker;
    procedure SetLPRHandle(mHandle: Integer);
    procedure btnOSDSaveClick(Sender: TObject);
    procedure btnOSDCancelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormOSDSet: TFormOSDSet;
  m_hLPRClient :Integer;
  osdParam :  VZ_LPRC_OSD_PARAM;

implementation

{$R *.dfm}
procedure  TFormOSDSet.SetLPRHandle(mHandle : Integer);
var
  nDayStyle, nTimeStyle, mRet : Integer;
  sOSDtext, sOSDDate, sOSDTime : string;
begin
  cbbDayStyle.Items.Add('YYYY/MM/DD');
  cbbDayStyle.Items.Add('MM/DD/YYYY');
  cbbDayStyle.Items.Add('DD/MM/YYYY');

  cbbOSDTime.Items.Add('12Hrs');
  cbbOSDTime.Items.Add('24Hrs');

  m_hLPRClient := mHandle; //ȡ豸

  mRet := VzLPRClient_GetOsdParam(m_hLPRClient, @osdParam); //ȡOSD
  //ʼOSD
  if (osdParam.dstampenable = 0) then
  begin
    chkOSDDay.Checked  := False;
  end
  else
  begin
    chkOSDDay.Checked  :=  True;
  end;

  //
  edtOSDDayX.Text := IntToStr(osdParam.datePosX);
  edtOSDDayY.Text := IntToStr(osdParam.datePosY);

  //ڸʽ
  nDayStyle := osdParam.dateFormat;
  if (nDayStyle >= 0) and (nDayStyle < 3)  then
  begin
    cbbDayStyle.ItemIndex := nDayStyle;
  end
  else
  begin
    cbbDayStyle.ItemIndex := 0;
  end;

  //ʼOSDʱ
  if(osdParam.tstampenable = 0) then
   begin
    chkOSDTime.Checked  := False;
  end
  else
  begin
    chkOSDTime.Checked  :=  True;
  end;

  //
  edtOSDTimeX.Text := IntToStr(osdParam.timePosX);
  edtOSDTimeY.Text := IntToStr(osdParam.timePosY);

  // ʱʽ
  nTimeStyle := osdParam.timeFormat;
  if(nTimeStyle = 0) or (nTimeStyle = 1 ) then
  begin
    cbbOSDTime.ItemIndex := nTimeStyle;
  end
  else
  begin
    cbbOSDTime.ItemIndex := 0;
  end;


  //ʼOSDı
  if(osdParam.nTextEnable = 0) then
  begin
    chkOSDText.Checked  := False;
  end
  else
  begin
    chkOSDText.Checked  :=  True;
  end;

  edtOSDTextX.Text := IntToStr(osdParam.nTextPositionX);
  edtOSDTextY.Text := IntToStr(osdParam.nTextPositionY);

  //
  sOSDtext := StrPas(@osdParam.overlaytext[0])  ;
  edtOSDText.Text  := sOSDtext;

  //ʾǰںʱ
  sOSDDate := FormatDateTime('ddddd',Now);
  dtpDate.Date := StrToDateTime(sOSDDate);

  sOSDTime := FormatDateTime('tt',Now);
  dtpTime.DateTime := StrToDateTime(sOSDTime);

end;

//OSD
procedure TFormOSDSet.btnOSDSaveClick(Sender: TObject);
var
  pDTinfo : VZ_DATE_TIME_INFO;
  nYear, nMonth, nDay, nHour, nMin, nSec, nMSec : Word;
  mRet, nRet : Integer;
begin
   //OSD
  if (chkOSDDay.Checked) then
  begin
    osdParam.dstampenable := 1;
  end
  else
  begin
    osdParam.dstampenable := 0;
  end;

  osdParam.datePosX := StrToInt(edtOSDDayX.Text);
  osdParam.datePosY := StrToInt(edtOSDDayY.Text);
  osdParam.dateFormat := cbbDayStyle.ItemIndex;

  //OSDʱ
  if(chkOSDTime.Checked) then
  begin
    osdParam.tstampenable :=1;
  end
  else
  begin
    osdParam.tstampenable := 0;
  end;

  osdParam.timePosX := StrToInt(edtOSDTimeX.Text);
  osdParam.timePosY := StrToInt(edtOSDTimeY.Text);
  osdParam.timeFormat := cbbOSDTime.ItemIndex;

  //OSDı
  if (chkOSDText.Checked) then
  begin
    osdParam.nTextEnable := 1;
  end
  else
  begin
    osdParam.nTextEnable := 0;
  end;

  osdParam.nTextPositionX := StrToInt(edtOSDTextX.Text);
  osdParam.nTextPositionY := StrToInt(edtOSDTextY.Text);

  StrCopy(@osdParam.overlaytext, PChar(edtOSDText.Text));

  mRet := VzLPRClient_SetOsdParam(m_hLPRClient, @osdParam);


  //ʱ
  if(chkUpdateTime.Checked) then
  begin
    DecodeDate(dtpDate.Date, nYear, nMonth, nDay); //ڿؼ
    DecodeTime(dtpTime.Time, nHour, nMin, nSec, nMSec); //ʱؼ

    pDTinfo.uYear := LongWord(nYear);
    pDTinfo.uMonth := LongWord(nMonth);
    pDTinfo.uDay := LongWord(nDay);
    pDTinfo.uHour := LongWord(nHour);
    pDTinfo.uMin  := LongWord(nMin);
    pDTinfo.uSec  := LongWord(nSec);

    nRet := VzLPRClient_SetDateTime(m_hLPRClient, @pDTinfo);//豸ʱ
    if((mRet = 0) and (nRet = 0)) then
    begin
       ShowMessage('޸ĳɹ!');
    end
    else
    begin
      ShowMessage('޸ʧ!');
    end;
  end
  else
  begin
    if (mRet = 0) then
    begin
      ShowMessage('OSD޸ĳɹ!');
    end
    else
    begin
      ShowMessage('OSD޸ʧ!');
    end;
  end;
  
  Self.Close;
end;

//ȡ
procedure TFormOSDSet.btnOSDCancelClick(Sender: TObject);
begin
  Self.Close;
end;

end.
