unit frmPlateQuery;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, VzLPRSDK, ExtCtrls , jpeg;
const
    PLATE_Query_MSG = WM_USER+105;

type
  TFormPlateQuery = class(TForm)
    lbl1: TLabel;
    dtpstarttimehour: TDateTimePicker;
    lbl2: TLabel;
    dtpendtimeday: TDateTimePicker;
    dtpendtimehour: TDateTimePicker;
    lbl3: TLabel;
    edtPlateQuery: TEdit;
    btnQuery: TButton;
    lvQueryResult: TListView;
    btnprepage: TButton;
    btnnextpage: TButton;
    dtpstarttimeday: TDateTimePicker;
    lblPageMsg: TLabel;
    procedure SetLPRHandle(mhandle: Integer; picPath:string);
    procedure FromPlateQuery_Create(Sender: TObject);
    procedure btnQueryClick(Sender: TObject);
    procedure btnprepageClick(Sender: TObject);
    procedure btnnextpageClick(Sender: TObject);
    procedure QueryResult_DbClick(Sender: TObject);

  private

    procedure ListViewClear;
    procedure QueryByPage(nPageIndex: Integer);
    procedure PlatePageMsgShow;
    procedure PlateQueryResult(var Msg: TMessage);message PLATE_Query_MSG;

    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormPlateQuery: TFormPlateQuery;
  m_hLPRClient :Integer;
  m_nTotalCount , m_nCurPage, m_nPageCount: Integer;
  m_strStartTime , m_strEndTime, m_strPageMsg, m_strPlate : string;
  ONE_PAGE_COUNT : Integer;
  m_pBufJeg : PByte;
  m_uSizeBufJpg : Integer;
  txtPicPath : string;

implementation
uses frmPlateShow;

{$R *.dfm}
//Ʋѯص
function gOnQueryPlateInfo(mhandle: VzLPRClientHandle; pUserData: Pointer;  pResult: PTH_PlateResult; uNumPlates: Word; eResultType: VZ_LPRC_RESULT_TYPE; var pImgFull: VZ_LPRC_IMAGE_INFO; var pImgPlateClip: VZ_LPRC_IMAGE_INFO): Integer; stdcall;
var
  pPResult : PTH_PlateResult;
begin
  if( pUserData <> nil ) then
  begin
    GetMem(pPResult, SizeOf(TH_PlateResult));
    ZeroMemory(ppResult, SizeOf(TH_PlateResult));
    CopyMemory(pPResult,pResult,SizeOf(TH_PlateResult));

    PostMessage(TFormPlateQuery(pUserData).Handle, PLATE_Query_MSG, Integer(pPResult) , Ord(eResultType)) ;
  end;
end;

//ʾƲѯ
procedure TFormPlateQuery.PlateQueryResult(var Msg: TMessage);
var
  pResult : PTH_PlateResult;
  eType : VZ_LPRC_RESULT_TYPE;
  strPlateID, szTime, strResultType, strPlateColor: string;
begin
  pResult := PTH_PlateResult(Msg.WParam);
  eType := VZ_LPRC_RESULT_TYPE(Msg.LParam);
  if(pResult <> nil) then
  begin
    strPlateID := '';
    szTime := '';
    strResultType := '';

    //ƺ
    strPlateID := IntToStr(pResult.uId);

    //ʶʱ
    szTime := Format('%d-%.2d-%.2d %.2d:%.2d:%.2d',[pResult.struBDTime.bdt_year,pResult.struBDTime.bdt_mon,pResult.struBDTime.bdt_mday,pResult.struBDTime.bdt_hour,pResult.struBDTime.bdt_min,pResult.struBDTime.bdt_sec]);

    //
    case eType of
      VZ_LPRC_RESULT_STABLE : strResultType := 'ȶ';
      VZ_LPRC_RESULT_FORCE_TRIGGER: strResultType := 'ֶ';
      VZ_LPRC_RESULT_IO_TRIGGER : strResultType := 'ظд';
      VZ_LPRC_RESULT_VLOOP_TRIGGER : strResultType := 'Ȧ';
    end;

    //ɫ
    case pResult.nColor of
      LC_UNKNOWN : strPlateColor := 'δ֪';
      LC_BLUE : strPlateColor := 'ɫ' ;
      LC_YELLOW : strPlateColor := 'ɫ';
      LC_WHITE : strPlateColor := 'ɫ';
      LC_BLACK : strPlateColor := 'ɫ';
      LC_GREEN : strPlateColor := 'ɫ';
    end;

    with lvQueryResult.Items.Add do
    begin
      Caption := strPlateID;
      SubItems.Add(StrPas(pResult.license));
      SubItems.Add(szTime);
      SubItems.Add(strResultType);
      SubItems.Add(strPlateColor);
    end;
  end;

  FreeMem(pResult);
end;

//ȡʼ
procedure  TFormPlateQuery.SetLPRHandle(mhandle : Integer; picPath:string );
begin
  txtPicPath := picPath;
  m_hLPRClient := mhandle;
  if (m_hLPRClient <> 0) then
  begin
    VzLPRClient_SetQueryPlateCallBack(m_hLPRClient, gOnQueryPlateInfo, Self);
  end;
end;

//
procedure TFormPlateQuery.FromPlateQuery_Create(Sender: TObject);
var
   sStartDate, sStartTime, sEndDate, sEndTime : string;
   Size : Byte;
begin
  ONE_PAGE_COUNT := 20;

  lvQueryResult.Columns.Add;
  lvQueryResult.Columns.Add;
  lvQueryResult.Columns.Add;
  lvQueryResult.Columns.Add;
  lvQueryResult.Columns.Add;
  lvQueryResult.Columns[0].Caption := '¼ID';
  lvQueryResult.Columns[1].Caption := 'ƺ';
  lvQueryResult.Columns[2].Caption := '¼ʱ';
  lvQueryResult.Columns[3].Caption := '';
  lvQueryResult.Columns[4].Caption := 'ɫ';
  lvQueryResult.Columns[0].Width := 70;
  lvQueryResult.Columns[1].Width := 90;
  lvQueryResult.Columns[2].Width := 150;
  lvQueryResult.Columns[3].Width := 90;
  lvQueryResult.Columns[4].Width := 70;

  //ʾǰںʱ
  sStartDate :=  FormatDateTime('ddddd',Now);
  dtpstarttimeday.Date := StrToDateTime(sStartDate);

  sStartTime :=  FormatDateTime('tt',Now);
  dtpstarttimehour.DateTime := StrToDateTime(sStartTime);

  sEndDate := FormatDateTime('ddddd',Now);
  dtpendtimeday.Date := StrToDateTime(sEndDate);

  sEndTime :=  FormatDateTime('tt',Now);
  dtpendtimehour.DateTime := StrToDateTime(sEndTime);
end;

//ѯ
procedure TFormPlateQuery.btnQueryClick(Sender: TObject);
var
  count, pageSize, nPageCount: Integer;
  FSetting : TFormatSettings;
  sStartDT, sEndDT, sPlate: string;
  szPageMsg : string;
begin
  ListViewClear();  //б

  count := 0;
  m_nTotalCount := 0;
  m_nCurPage := 0;
  m_nPageCount := 0;
  m_strStartTime := '';
  m_strEndTime := '';

  m_strPlate := edtPlateQuery.Text;
  FSetting.ShortDateFormat := 'yyyy-MM-dd ';
  sStartDT := DateTimeToStr(dtpstarttimeday.Date,FSetting) + TimeToStr(dtpstarttimehour.Time);
  sEndDT := DateToStr(dtpendtimeday.Date, FSetting) + TimeToStr(dtpendtimehour.Time);

  count := VzLPRClient_QueryCountByTimeAndPlate(m_hLPRClient, PChar(sStartDT), PChar(sEndDT), PChar(m_strPlate)); //ʱͳƺŲѯ¼
  if (count > 0 ) then
  begin
    pageSize := count div  ONE_PAGE_COUNT;
    if ((count mod ONE_PAGE_COUNT) = 0) then
    begin
      nPageCount := pageSize;
    end
    else
    begin
      nPageCount := pageSize + 1;
    end;
    szPageMsg := '' + IntToStr(count) + '¼, 1/' + IntToStr(nPageCount);

    m_nTotalCount := count;
    m_nPageCount := nPageCount;
    m_strStartTime := sStartDT;
    m_strEndTime := sEndDT;

    QueryByPage(0);
  end
  else
  begin
    szPageMsg :=  ' 0 ¼';
  end;
   m_strPageMsg := szPageMsg;

  //ʾѯƵļ¼Ϣ
  PlatePageMsgShow();

end;

//ʾѯƵļ¼Ϣ
procedure  TFormPlateQuery.PlatePageMsgShow();
begin
  lblPageMsg.Caption := m_strPageMsg;
end;

//б
procedure TFormPlateQuery.ListViewClear();
begin
  lvQueryResult.Items.Clear;
end;

//ҳѯ
procedure TFormPlateQuery.QueryByPage(nPageIndex : Integer);
var
  mRet : Integer;
begin
  ListViewClear();

  //ʱͳƺŲѯҳ¼
  mRet := VzLPRClient_QueryPageRecordByTimeAndPlate(m_hLPRClient, PChar(m_strStartTime), PChar(m_strEndTime),  PChar(m_strPlate), nPageIndex*ONE_PAGE_COUNT ,(nPageIndex + 1)*ONE_PAGE_COUNT);
end;

//һҳ
procedure TFormPlateQuery.btnprepageClick(Sender: TObject);
var
  nCurPage : Integer;
  sPageMsg : string;
begin
  nCurPage := m_nCurPage -1;
  if (nCurPage >= 0) then
  begin
    QueryByPage(nCurPage);  //ѯһҳ¼

    Dec(m_nCurPage);

    m_strPageMsg := '' + IntToStr(m_nTotalCount) + '¼, ' + IntToStr(nCurPage + 1) + '/' + IntToStr(m_nPageCount);
    PlatePageMsgShow();
  end
  else
  begin
    ShowMessage('һҳ¼!');
  end;

end;

//һҳ
procedure TFormPlateQuery.btnnextpageClick(Sender: TObject);
var
  nCurPage : Integer;
begin
  nCurPage := m_nCurPage + 1;
  if ((nCurPage >0) and (nCurPage < m_nPageCount)) then
  begin
    QueryByPage(nCurPage);

    Inc(m_nCurPage);

    m_strPageMsg := '' + IntToStr(m_nTotalCount) + '¼, '  + IntToStr(nCurPage + 1) + '/' + IntToStr(m_nPageCount);
    PlatePageMsgShow();
  end
  else
  begin
    ShowMessage('һҳ¼!');
  end;
end;

//б˫ʱ
procedure TFormPlateQuery.QueryResult_DbClick(Sender: TObject);
var
  id, mRet : Integer;
  filePath,imgPath : string;
  FileStream : TFileStream;
  formPlateShow : TFormPlateShow;
begin
  if(Assigned(lvQueryResult.Selected)) then  //ж˫ǷЧ
  begin
    id := StrToInt(lvQueryResult.Selected.Caption);

    m_uSizeBufJpg :=  1024 * 1024;
    GetMem(m_pBufJeg, m_uSizeBufJpg) ;
    ZeroMemory(m_pBufJeg, m_uSizeBufJpg);

    mRet := VzLPRClient_LoadImageById(m_hLPRClient, id, m_pBufJeg, @m_uSizeBufJpg);//IDȡͼƬ
    if(mRet <> 0) then
    begin
      Exit;
    end;

    filePath := txtPicPath +'Query\';
    if not DirectoryExists(filePath) then
    begin
       ForceDirectories(filePath);//Ŀ¼
    end;

    imgPath := filePath + IntToStr(id) + '.jpg';
    if ((mRet = 0)and (m_uSizeBufJpg > 0) and (m_uSizeBufJpg < 1024 * 1024)) then
    begin
      FileStream := TFileStream.Create(imgPath, fmCreate);
      FileStream.Position := 0;
      FileStream.WriteBuffer(m_pBufJeg^,m_uSizeBufJpg);
      FreeAndNil(FileStream);
    end
    else
    begin
      ShowMessage('ͼƬɾ!');
      Exit;
    end;

    formPlateShow := TFormPlateShow.Create(Application);
    formPlateShow.Show;
    formPlateShow.SetPicPath(imgPath);
  end;

  FreeMem(m_pBufJeg);

end;

end.
