unit frmVideoCfg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, VzLPRSDK;
type
  TFormVideoCfg = class(TForm)
    pgcVideoCfg: TPageControl;
    tsMainDataRate: TTabSheet;
    tsVideoSource: TTabSheet;
    lbl1: TLabel;
    cbbframe_size: TComboBox;
    lbl2: TLabel;
    cbbframe_rate: TComboBox;
    lbl3: TLabel;
    cbbencode_type: TComboBox;
    lbl4: TLabel;
    cbbcompress_mode: TComboBox;
    lbl5: TLabel;
    cbbimg_quality: TComboBox;
    lbl6: TLabel;
    edtrateval: TEdit;
    btnOK: TButton;
    lbl7: TLabel;
    lbl8: TLabel;
    lbl9: TLabel;
    lbl10: TLabel;
    lbl11: TLabel;
    lbl12: TLabel;
    lbl13: TLabel;
    cbbvideo_standard: TComboBox;
    cbbexposure_time: TComboBox;
    cbbimg_pos: TComboBox;
    btnRecovery: TButton;
    trckbrBright: TTrackBar;
    trckbrContrast: TTrackBar;
    trckbrSaturation: TTrackBar;
    trckbrDefinition: TTrackBar;
    procedure SetLPRHandle(mHandle: Integer);
    procedure btnOKClick(Sender: TObject);
    procedure cmb_encode_type_SelectedIndexChanged(Sender: TObject);
    procedure cmb_compress_mode_SelectedIndexChanged(Sender: TObject);
    procedure btnRecoveryClick(Sender: TObject);
    procedure cbbvideo_standard_SelectedIndexChanged(Sender: TObject);
    procedure cbbexposure_time_SelectedIndexChanged(Sender: TObject);
    procedure cbbimg_pos_SelectedIndexChanged(Sender: TObject);
    procedure trckbrBrightChange(Sender: TObject);
    procedure trckbrContrastChange(Sender: TObject);
    procedure trckbrSaturationChange(Sender: TObject);
    procedure trckbrDefinitionChange(Sender: TObject);

  private
    procedure LoadVideoCfg;
    procedure LoadVideoSource;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormVideoCfg: TFormVideoCfg;
  m_hLPRClient :Integer;

implementation

{$R *.dfm}
procedure TFormVideoCfg.SetLPRHandle(mHandle : Integer);
var
  strRate : string ;
  i :Integer;
begin
  m_hLPRClient := mHandle;

  if(m_hLPRClient <> 0) then
  begin
    //ʼ
    cbbframe_size.Items.Add('352x288');
    cbbframe_size.Items.Add('704x576');
    cbbframe_size.Items.Add('1280x720');
    cbbframe_size.Items.Add('1920x1080');

    for i:= 1 to 25 do
    begin
      strRate := IntToStr(i);
      cbbframe_rate.Items.Add(strRate);
    end;
     
    cbbencode_type.Items.Add('H264');
    cbbencode_type.Items.Add('JPEG');

    cbbcompress_mode.Items.Add('');
    cbbcompress_mode.Items.Add('');

    cbbimg_quality.Items.Add('');
    cbbimg_quality.Items.Add('');
    cbbimg_quality.Items.Add('');
    cbbimg_quality.Items.Add('е');
    cbbimg_quality.Items.Add('');
    cbbimg_quality.Items.Add('');
    cbbimg_quality.Items.Add('');

    //ʼƵԴ
    cbbvideo_standard.Items.Add('MaxOrZero');
    cbbvideo_standard.Items.Add('50Hz');
    cbbvideo_standard.Items.Add('60Hz');

    cbbexposure_time.Items.Add('0~8ms ͣƼ');
    cbbexposure_time.Items.Add('0~4ms ');
    cbbexposure_time.Items.Add('0~2ms Ƽ');

    cbbimg_pos.Items.Add('ԭʼͼ');
    cbbimg_pos.Items.Add('·ת');
    cbbimg_pos.Items.Add('ҷת');
    cbbimg_pos.Items.Add('ķת');

     //ȡƵԴ
    LoadVideoSource();

     //ȡ
    LoadVideoCfg();

  end;
end;

//ȡƵԴ
procedure TFormVideoCfg.LoadVideoSource();
var
   brt, cst, sat, hue, frequency, shutter, flip : Integer;
   mRet : Integer;
begin
   //ȡƵ
   mRet :=  VzLPRClient_GetVideoPara(m_hLPRClient, brt, cst, sat, hue);
   if (mRet = 0) then
   begin
      trckbrBright.Position := brt;
      trckbrContrast.Position := cst;
      trckbrSaturation.Position := sat;
      trckbrDefinition.Position := hue;
   end;

  //ȡƵʽ
  mRet := VzLPRClient_GetFrequency(m_hLPRClient, frequency);
  if(mRet = 0) then
  begin
    cbbvideo_standard.ItemIndex := frequency;
  end;


  //ȡعʱ
  mRet := VzLPRClient_GetShutter(m_hLPRClient, shutter);
  if (mRet = 0) then
  begin
    if(shutter = 2)then
    begin
      cbbexposure_time.ItemIndex := 0;
    end
    else
    if (shutter = 3) then
    begin
      cbbexposure_time.ItemIndex := 1;
    end
    else
    if(shutter = 4) then
    begin
      cbbexposure_time.ItemIndex := 2;
    end;
  end;

  //ȡͼת
  mRet := VzLPRClient_GetFlip(m_hLPRClient, flip);
  if (mRet = 0) then
  begin
    cbbimg_pos.ItemIndex := flip;
  end;
  
end;

//ȡ
procedure TFormVideoCfg.LoadVideoCfg();
var
  nSizeVal, nRateval, nEncodeType,  modeval, bitval, ratelist, levelval : Integer;
  mRet : Integer;
  strRateval : string ;
begin
  edtrateval.Text := strRateval;

  //ȡֱ
  mRet := VzLPRClient_GetVideoFrameSizeIndex(m_hLPRClient, nSizeVal);
  if (mRet = 0) then
  begin
    if (nSizeVal = 0) then
    begin
      cbbframe_size.ItemIndex := 1;
    end
    else
    begin
      if(nSizeVal = 1) then
      begin
       cbbframe_size.ItemIndex := 0;
      end
      else
      begin
        cbbframe_size.ItemIndex := nSizeVal;
      end;
    end;
  end;

  //ȡ֡
  mRet := VzLPRClient_GetVideoFrameRate(m_hLPRClient, nRateval);
  if(mRet = 0) then
  begin
    cbbframe_rate.ItemIndex := nRateval - 1;
  end;

  //ȡ뷽ʽ
  mRet := VzLPRClient_GetVideoEncodeType(m_hLPRClient, nEncodeType);
  if (mRet = 0) then
  begin
    if (nEncodeType = 0) then
    begin
      cbbencode_type.ItemIndex := 0;
      cbbcompress_mode.Enabled := True;
    end
    else
    begin
      cbbencode_type.ItemIndex := 1;
      cbbcompress_mode.Enabled := False;
    end;
  end;

  //ȡ
  mRet := VzLPRClient_GetVideoCompressMode(m_hLPRClient, modeval);
  if (mRet = 0) then
  begin
    cbbcompress_mode.ItemIndex := modeval;
    if (modeval = 0) then
     begin
       edtrateval.Enabled := True;
     end
    else
    begin
      edtrateval.Enabled := False;
    end;
  end;

  //ȡ
  mRet := VzLPRClient_GetVideoCBR(m_hLPRClient, bitval, ratelist);
  begin
     edtrateval.Text := IntToStr(bitval);
  end;

  //ȡͼ
  mRet := VzLPRClient_GetVideoVBR(m_hLPRClient, levelval);
  if (mRet = 0) then
  begin
    cbbimg_quality.ItemIndex := levelval;
  end;
end;

//
procedure TFormVideoCfg.btnOKClick(Sender: TObject);
var
  sRateVal : string;
  nRateVal, nSizeVal, nEncodeType, modeval, level: Integer;
  mRet : Integer;
begin
  //÷ֱ
  nSizeVal := cbbframe_size.ItemIndex;
  if (nSizeVal = 0) then
  begin
    nSizeVal := 1;
  end
  else
  begin
    if (nSizeVal = 1) then
    begin
      nSizeVal := 0;
    end;
  end;
  mRet := VzLPRClient_SetVideoFrameSizeIndex(m_hLPRClient, nSizeVal);
  if(mRet <> 0) then
  begin
    ShowMessage('÷ֱʧܣ!');
    Exit;
  end;

  //֡
  nRateVal := cbbframe_rate.ItemIndex + 1;
  mRet := VzLPRClient_SetVideoFrameRate(m_hLPRClient, nRateVal);
  if(mRet <> 0) then
  begin
    ShowMessage('֡ʧܣ!');
    Exit;
  end;

  //ñ뷽ʽ
  if(cbbencode_type.ItemIndex = 0) then
  begin
    nEncodeType := 0
  end
  else
  begin
    nEncodeType := 2;
  end;
  mRet := VzLPRClient_SetVideoEncodeType(m_hLPRClient, nEncodeType);
  if (mRet <> 0) then
  begin
    ShowMessage('ñ뷽ʽʧܣ!');
    Exit;
  end;

  //
  if (cbbcompress_mode.Enabled) then
  begin
    modeval := cbbcompress_mode.ItemIndex;
    mRet := VzLPRClient_SetVideoCompressMode(m_hLPRClient, modeval);
    if (mRet <> 0) then
    begin
      ShowMessage('ʧܣ!');
      Exit;
    end;
  end;

  //ͼ
  level := cbbimg_quality.ItemIndex;
  mRet := VzLPRClient_SetVideoVBR(m_hLPRClient, level);
  if (mRet <> 0) then
  begin
      ShowMessage('ͼʧܣ!');
      Exit;
  end;

  //
  sRateVal := edtrateval.Text;
  nRateVal := StrToInt(sRateVal);
  if ((nRateVal <= 0) or (nRateVal > 4096)) then
  begin
    ShowMessage('ΧΪ0-4096!');
    Exit;
  end;

  if(edtrateval.Enabled) then
  begin
    mRet := VzLPRClient_SetVideoCBR(m_hLPRClient, nRateVal);
    if (mRet <> 0) then
    begin
      ShowMessage('ʧܣ!');
      Exit;
    end;
  end;
  ShowMessage('óɹ !');
end;

procedure TFormVideoCfg.cmb_encode_type_SelectedIndexChanged(Sender: TObject);
var
  nCurSel : Integer;
begin
  nCurSel := cbbencode_type.ItemIndex;
  if (nCurSel = 0) then
  begin
    cbbcompress_mode.Enabled := True;
  end
  else
  begin
    cbbcompress_mode.Enabled := False;
  end;

end;

procedure TFormVideoCfg.cmb_compress_mode_SelectedIndexChanged(Sender: TObject);
var
  nCurSel : Integer;
begin
  if(cbbcompress_mode.Enabled) then
  begin
    nCurSel := cbbcompress_mode.ItemIndex;
    if(nCurSel = 0) then
    begin
      edtrateval.Enabled := True
    end
    else
    begin
      edtrateval.Enabled := False;
    end;
  end
  else
  begin
    edtrateval.Enabled := False;
  end;

end;


//ָĬ
procedure TFormVideoCfg.btnRecoveryClick(Sender: TObject);
var
  brt, cst, sat, hue:Integer;
  mRet : Integer;
begin
  brt := 50;
  trckbrBright.Position := brt;

  cst := 40;
  trckbrContrast.Position := cst;

  sat := 30;
  trckbrSaturation.Position := sat;

  hue := 50;
  trckbrDefinition.Position := hue;

  //Ƶ
  mRet := VzLPRClient_SetVideoPara(m_hLPRClient, brt, cst, sat, hue);

  //Ƶʽ
  mRet := VzLPRClient_SetFrequency(m_hLPRClient, 1);
  cbbvideo_standard.ItemIndex := 1;

  //عʱ
  mRet := VzLPRClient_SetShutter(m_hLPRClient, 3);
  cbbexposure_time.ItemIndex := 1;

  //ͼת
  mRet := VzLPRClient_SetFlip(m_hLPRClient, 0);
  cbbimg_pos.ItemIndex := 0;
end;

//Ƶʽ
procedure TFormVideoCfg.cbbvideo_standard_SelectedIndexChanged(
  Sender: TObject);
var
  frequency,mRet : Integer;
begin
  frequency := cbbvideo_standard.ItemIndex;
  mRet := VzLPRClient_SetFrequency(m_hLPRClient, frequency );
end;

//عʱ
procedure TFormVideoCfg.cbbexposure_time_SelectedIndexChanged(Sender: TObject);
var
  shutter, curSel ,mRet : Integer;
begin
  shutter := 0;
  curSel := cbbexposure_time.ItemIndex ;
  if(curSel = 0) then
  begin
    shutter := 2;
  end
  else
  if (curSel = 1) then
  begin
    shutter := 3;
  end
  else
  if(curSel = 2) then
  begin
    shutter := 4;
  end;

  mRet := VzLPRClient_SetShutter(m_hLPRClient, shutter);
end;

//ͼת
procedure TFormVideoCfg.cbbimg_pos_SelectedIndexChanged(Sender: TObject);
var
  flip, mRet: Integer;
begin
  flip := cbbimg_pos.ItemIndex;
  mRet := VzLPRClient_SetFlip(m_hLPRClient, flip);
end;

//
procedure TFormVideoCfg.trckbrBrightChange(Sender: TObject);
var
  brt, cst, sat, hue, mRet :Integer;
begin
  brt := trckbrBright.Position;
  cst := trckbrContrast.Position;
  sat := trckbrSaturation.Position;
  hue := trckbrDefinition.Position;

  mRet := VzLPRClient_SetVideoPara(m_hLPRClient, brt, cst, sat, hue);
end;

//öԱȶ
procedure TFormVideoCfg.trckbrContrastChange(Sender: TObject);
var
  brt, cst, sat, hue, mRet :Integer;
begin
  brt := trckbrBright.Position;
  cst := trckbrContrast.Position;
  sat := trckbrSaturation.Position;
  hue := trckbrDefinition.Position;

  mRet := VzLPRClient_SetVideoPara(m_hLPRClient, brt, cst, sat, hue);
end;

//ñͶ
procedure TFormVideoCfg.trckbrSaturationChange(Sender: TObject);
var
  brt, cst, sat, hue, mRet :Integer;
begin
  brt := trckbrBright.Position;
  cst := trckbrContrast.Position;
  sat := trckbrSaturation.Position;
  hue := trckbrDefinition.Position;

  mRet := VzLPRClient_SetVideoPara(m_hLPRClient, brt, cst, sat, hue);
end;

//
procedure TFormVideoCfg.trckbrDefinitionChange(Sender: TObject);
var
  brt, cst, sat, hue, mRet :Integer;
begin
  brt := trckbrBright.Position;
  cst := trckbrContrast.Position;
  sat := trckbrSaturation.Position;
  hue := trckbrDefinition.Position;

  mRet := VzLPRClient_SetVideoPara(m_hLPRClient, brt, cst, sat, hue);
end;

end.
