// package com;

import java.util.Arrays;
import java.util.List;

import com.sun.jna.ptr.ByteByReference;
import com.sun.jna.Native;
import com.sun.jna.Pointer;
import com.sun.jna.Structure;
import com.sun.jna.win32.StdCallLibrary;

public interface LPR extends StdCallLibrary {
	
	LPR INSTANCE = (LPR) Native.loadLibrary("VzLPRSDK", LPR.class);

	/**ͼϢ*/
	public static class VZ_LPRC_IMAGE_INFO_Pointer extends Structure
	{
		public int uWidth;			/**<*/
		public int uHeight;		/**<߶*/
		public int uPitch;			/**<ͼȵһռڴֽ*/
		public int uPixFmt;		/**<ͼظʽοöٶͼʽImageFormatXXX*/
		public ByteByReference pBuffer;	/**<ͼڴ׵ַ*/
		
	    public static class ByReference extends VZ_LPRC_IMAGE_INFO_Pointer implements Structure.ByReference {}  
	    public static class ByValue extends VZ_LPRC_IMAGE_INFO_Pointer implements Structure.ByValue {}  
	  
	    @Override  
	    protected List<String> getFieldOrder() {  
	        return Arrays.asList(new String[]{"uWidth", "uHeight", "uPitch", "uPixFmt","pBuffer"});  
	    }  
	}
	
	public static class VZ_TM extends Structure
	{
		public short nYear;	/**<*/
		public short nMonth;	/**<*/
		public short nMDay;	/**<*/
		public short nHour;	/**<ʱ*/
		public short nMin;		/**<*/
		public short nSec;		/**<*/
		
	    public static class ByReference extends VZ_TM implements Structure.ByReference {}  
	    public static class ByValue extends VZ_TM implements Structure.ByValue {}  
	  
	    @Override  
	    protected List<String> getFieldOrder() {  
	        return Arrays.asList(new String[]{"nYear", "nMonth", "nMDay", "nHour", "nMin", "nSec"});  
	    }  
	}
	
	/*
	public static class VZ_TM_PERIOD_OR_RANGE extends Structure
	{
		public int			uEnable;
		public int			uIsSeg;
		public VZ_TM_WEEK_SEGMENT  struWeekSeg[8];
		public VZ_TM_RANGE			struRange;
	}
	*/
	
	
	/**ڰеĳ¼*/
	public static class VZ_LPR_WLIST_VEHICLE extends Structure
	{
		public int	uVehicleID;
		public byte[] strPlateID = new byte[32];			/**<ַ*/
		public int	uCustomerID;							/**<ͻݿIDVZ_LPR_WLIST_CUSTOMER::uCustomerIDӦ*/
		public int	bEnable;								/**<ü¼Ч*/	
		public VZ_TM.ByReference		pStruTMOverdule;	/**<ü¼ʱ,Ϊձʾûйʱ*/
		public int	bUsingTimeSeg;							/**<Ƿʹʱ*/
		public byte[]	byTimeSegOrRange = new byte[256];   /**struTimeSegOrRange;			<ʱϢ*/
		public int	bAlarm;									/**<Ƿ񴥷¼*/
		public int	iColor;									/**<ɫ*/
		public int	iPlateType;								/**<*/
		public byte[]	strCode = new byte[32];				/**<*/
		public byte[]	strComment = new byte[64];			/**<*/
		
	    public static class ByReference extends VZ_LPR_WLIST_VEHICLE implements Structure.ByReference {}  
	    public static class ByValue extends VZ_LPR_WLIST_VEHICLE implements Structure.ByValue {}  
	}
	
	public static class VZ_LPR_WLIST_ROW extends Structure
	{
		public Pointer pCustomer;			/**<ͻ*/
		public VZ_LPR_WLIST_VEHICLE.ByReference pVehicle;				/**<Ϊ*/
		
	    public static class ByReference extends VZ_LPR_WLIST_ROW implements Structure.ByReference {}  
	    public static class ByValue extends VZ_LPR_WLIST_ROW implements Structure.ByValue {}  
	}
	
	/**ÿеĽ*/
	public static class VZ_LPR_WLIST_IMPORT_RESULT extends Structure
	{
		public int ret;
		public int error_code;
		
	    public static class ByReference extends VZ_LPR_WLIST_IMPORT_RESULT implements Structure.ByReference {}  
	    public static class ByValue extends VZ_LPR_WLIST_IMPORT_RESULT implements Structure.ByValue {}  
	}
	
	/**ʶ*/
	public enum VZ_LPRC_RESULT_TYPE
	{
		VZ_LPRC_RESULT_REALTIME,		/**<ʵʱʶ*/
		VZ_LPRC_RESULT_STABLE,			/**<ȶʶ*/
		VZ_LPRC_RESULT_FORCE_TRIGGER,	/**<áVzLPRClient_ForceTriggerʶ*/
		VZ_LPRC_RESULT_IO_TRIGGER,		/**<ⲿIOźŴʶ*/
		VZ_LPRC_RESULT_VLOOP_TRIGGER,	/**<Ȧʶ*/
		VZ_LPRC_RESULT_MULTI_TRIGGER,	/**<_FORCE_\_IO_\_VLOOP_еһֻͬʱҪÿʶTH_PlateResult::uBitsTrigTypeж*/
		VZ_LPRC_RESULT_TYPE_NUM			/**<*/
	}
	
	/**
	*  @brief ȫֳʼ
	*  @return 0ʾɹ-1ʾʧ
	*  @note нӿڵ֮ǰ
	*  @ingroup group_global
	*/
	int VzLPRClient_Setup();
	
	/**
	*  @brief һ豸
	*  @param  [IN] pStrIP 豸IPַ
	*  @param  [IN] wPort 豸Ķ˿ں
	*  @param  [IN] pStrUserName 豸û
	*  @param  [IN] pStrPassword 豸
	*  @return 豸Ĳʧʱ0
	*  @ingroup group_device
	*/
	int VzLPRClient_Open(String pStrIP, int wPort, String pStrUserName, String pStrPassword);
	
	/**
	*  @brief ͻͳ¼
	*  @param  [IN] handle VzLPRClient_Openõľ
	*  @param  [IN] rowcount ¼
	*  @param  [IN] pRowDatas ¼ĵַ
	*  @param  [OUT] results ÿǷɹ
	*  @return 0ʾɹ-1ʾʧ
	*  @ingroup group_database
	*/
	int VzLPRClient_WhiteListImportRows(int handle, int rowcount, VZ_LPR_WLIST_ROW.ByReference pRowDatas, VZ_LPR_WLIST_IMPORT_RESULT.ByReference pResults);	
	
	/**
	*  @brief ʶĻص
	*  @param  [IN] handle VzLPRClient_Openõľ
	*  @param  [IN] func ʶصΪNULLʾرոûصĹ
	*  @param  [IN] pUserData صе
	*  @param  [IN] bEnableImage ָʶĻصǷҪͼϢ1ΪҪ0ΪҪ
	*  @return 0ʾɹ-1ʾʧ
	*  @ingroup group_device
	*/
	int VzLPRClient_SetPlateInfoCallBack(int handle, VZLPRC_PLATE_INFO_CALLBACK func, Pointer pUserData, int bEnableImage);
	
	/**
	*  @brief ͼ񱣴ΪJPEGָ·
	*  @param  [IN] pImgInfo ͼṹ壬Ŀǰֻ֧ĬϵĸʽImageFormatRGB
	*  @param  [IN] pFullPathName ·JPG׺ļַ
	*  @param  [IN] nQuality JPEGѹȡֵΧ1~100
	*  @return 0ʾɹ-1ʾʧ
	*  @note   ļе·Ҫ
	*  @ingroup group_global
	*/
	int VzLPRClient_ImageSaveToJpeg(VZ_LPRC_IMAGE_INFO_Pointer.ByReference pImgInfo, String pFullPathName, int nQuality);
	
	/**  */
	public static class TH_RECT_Pointer extends Structure {
		public int left;
		public int top;
		public int right;
		public int bottom;
		
	    public static class ByReference extends TH_RECT_Pointer implements Structure.ByReference {}  
	    public static class ByValue extends TH_RECT_Pointer implements Structure.ByValue {}  
	  
	    @Override  
	    protected List<String> getFieldOrder() {  
	        return Arrays.asList(new String[]{"left", "top", "right", "bottom"});  
	    }  
	}
	
	public static class VZ_TIMEVAL_Pointer extends Structure
	{
		public int uTVSec;
		public int uTVUSec;
		
	    public static class ByReference extends VZ_TIMEVAL_Pointer implements Structure.ByReference {}  
	    public static class ByValue extends VZ_TIMEVAL_Pointer implements Structure.ByValue {}  
	  
	    @Override  
	    protected List<String> getFieldOrder() {  
	        return Arrays.asList(new String[]{"uTVSec", "uTVUSec"});  
	    }  
	}
	
	/**ֽʱ*/
	public static class VzBDTime_Pointer extends Structure
	{
	    public byte bdt_sec;    /**<룬ȡֵΧ[0,59]*/
	    public byte bdt_min;    /**<֣ȡֵΧ[0,59]*/
	    public byte bdt_hour;   /**<ʱȡֵΧ[0,23]*/
	    public byte bdt_mday;   /**<һеڣȡֵΧ[1,31]*/
	    public byte bdt_mon;    /**<·ݣȡֵΧ[1,12]*/
	    public byte[] res1 = new byte[3];    /**<Ԥ*/
	    public int bdt_year;   /**<*/
	    public byte[] res2 = new byte[4];    /**<Ԥ*/
	    
	    public static class ByReference extends VzBDTime_Pointer implements Structure.ByReference {}  
	    public static class ByValue extends VzBDTime_Pointer implements Structure.ByValue {}  
	  
	    @Override  
	    protected List<String> getFieldOrder() {  
	        return Arrays.asList(new String[]{"bdt_sec", "bdt_min","bdt_hour","bdt_mday","bdt_mon","res1","bdt_year","res2"});  
	    } 
	}
	   //broken-down time
	
	/** ʶṹ */
	public static class TH_PlateResult_Pointer extends Structure {
		public byte[] license = new byte[16]; // ƺ
		public byte[] color = new byte[8]; // ɫ
		public int nColor; // ɫ
		public int nType; // 
		public int nConfidence; // ƿŶ
		public int nBright; // 
		public int nDirection; // ˶0 unknown, 1 left, 2 right, 3 up , 4 down
		public TH_RECT_Pointer.ByValue rcLocation; // λ  error
		public int nTime; // ʶʱ
		public VZ_TIMEVAL_Pointer.ByValue tvPTS;
		public int uBitsTrigType;
		public byte nCarBright; // 
		public byte nCarColor; // ɫ
		public byte[] reserved0 = new byte[2];
		public int uId;
		public VzBDTime_Pointer.ByValue struBDTime;
		public byte[] reserved = new byte[68]; // 
		
	    public static class ByReference extends TH_PlateResult_Pointer implements Structure.ByReference {}  
	    public static class ByValue extends TH_PlateResult_Pointer implements Structure.ByValue {}  
	  
	    @Override  
	    protected List<String> getFieldOrder() {  
	        return Arrays.asList(new String[]{"license", "color", "nColor", "nType", "nConfidence", "nBright", "nDirection", "rcLocation", "nTime", "nCarBright", "nCarColor", "reserved"});  
	    }  
	}
	
	
	/**
	*  @brief ͨûصóʶϢ
	*  @param  [IN] handle			VzLPRClient_Openõľ
	*  @param  [IN] pUserData		ص
	*  @param  [IN] pResult			Ϣ׵ַṹ嶨 TH_PlateResult
	*  @param  [IN] uNumPlates		еĳƸ
	*  @param  [IN] eResultType		ʶͣöͶVZ_LPRC_RESULT_TYPE
	*  @param  [IN] pImgFull		ǰ֡ͼݣṹ嶨VZ_LPRC_IMAGE_INFO
	*  @param  [IN] pImgPlateClip	ǰ֡гͼ飬еԪ복ϢеĶӦ
	*  @return 0ʾɹ-1ʾʧ
	*  @note   Ҫûصؽͼ pImgFull pImgPlateClipҪûصVzLPRClient_SetPlateInfoCallBackʱͼݣûصصָΪգ
	*  @note   ʵʱVZ_LPRC_RESULT_REALTIMEĻصǲͼݵ
	*  @ingroup group_callback
	*/
	public static interface VZLPRC_PLATE_INFO_CALLBACK extends StdCallCallback{
	    public void invoke(int handle,Pointer pUserData,LPR.TH_PlateResult_Pointer.ByReference pResult,int uNumPlates,
	    		int eResultType,LPR.VZ_LPRC_IMAGE_INFO_Pointer.ByReference pImgFull,LPR.VZ_LPRC_IMAGE_INFO_Pointer.ByReference pImgPlateClip);
	}
}
