// NetGroupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NetGroup.h"
#include "NetGroupDlg.h"
#include <io.h>
#include <ShlObj.h>
#include <fstream>
#include <atlimage.h>

#include <thread>
#include <string>
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


void CALLBACK iOnViewerMouse(IV_EVENT eEvent, int x, int y, void *pUserData, int nId)
{
	CNetGroupDlg *pInstance = (CNetGroupDlg *)pUserData;
	pInstance->OnViewerMouse0(eEvent, x, y, nId);
}

void CALLBACK iOnIVPaint(int nID, bool bActive, bool bInUse, void *pUserData)
{
	CNetGroupDlg *pInstance = (CNetGroupDlg *)pUserData;
	pInstance->iOnIVPaint1(nID, bActive, bInUse);
}


int __stdcall OnPlateInfo(VzLPRClientHandle handle, void *pUserData,
						  const TH_PlateResult *pResult, unsigned uNumPlates,
						  VZ_LPRC_RESULT_TYPE eResultType,
						  const VZ_LPRC_IMAGE_INFO *pImgFull,
						  const VZ_LPRC_IMAGE_INFO *pImgPlateClip)
{
	CNetGroupDlg *pInstance = (CNetGroupDlg *)pUserData;
	pInstance->OnPlateInfo0(handle, pResult, uNumPlates, eResultType, pImgFull, pImgPlateClip);

	return(0);
}

int __stdcall PlateGroupInfo_cb(VzLPRClientHandle handle, void *pUserData, int exitEntryInfo, const TH_PlateResult *exitIvsInfo, const TH_PlateResult *entryIvsInfo, 
								const IVS_DG_DEVICE_INFO *exitDGInfo, const IVS_DG_DEVICE_INFO *entryDGInfo)
{
	CNetGroupDlg * ptrVzLPRSDKDemoDlg = ( CNetGroupDlg * )pUserData;

	if(ptrVzLPRSDKDemoDlg)
		ptrVzLPRSDKDemoDlg->RecivePlateGroupInfo(handle,exitEntryInfo,exitIvsInfo,entryIvsInfo, exitDGInfo, entryDGInfo);

	return 0;
}

static const char *iGetResultTypeName(VZ_LPRC_RESULT_TYPE eResultType)
{
	static const char *pStrTypeName[VZ_LPRC_RESULT_TYPE_NUM]
	= {"ʵʱ", "Զ", "", "ⲿ", "Ȧ", "ش"};

	return(pStrTypeName[eResultType]);
}

static const char *iGetDirString(int nDir)
{
	if(nDir == 3)
		return("");
	if(nDir == 4)
		return("");
	return(" ");
}


static const char *iGetResultTypeNameByBits(unsigned uBits)
{
	const int LenStr = 256;
	static char strTypes[LenStr];
	strTypes[0] = 0;
	if(uBits == 0)
	{
		strcat_s(strTypes, LenStr, iGetResultTypeName(VZ_LPRC_RESULT_REALTIME));
	}
	if(uBits & TRIGGER_TYPE_AUTO_BIT)
	{
		strcat_s(strTypes, LenStr, iGetResultTypeName(VZ_LPRC_RESULT_STABLE));
	}
	if(uBits & TRIGGER_TYPE_EXTERNAL_BIT)
	{
		strcat_s(strTypes, LenStr, iGetResultTypeName(VZ_LPRC_RESULT_IO_TRIGGER));
		strcat_s(strTypes, LenStr, "|");
	}
	if(uBits & TRIGGER_TYPE_SOFTWARE_BIT)
	{
		strcat_s(strTypes, LenStr, iGetResultTypeName(VZ_LPRC_RESULT_FORCE_TRIGGER));
		strcat_s(strTypes, LenStr, "|");
	}
	if(uBits & TRIGGER_TYPE_VLOOP_BIT)
	{
		strcat_s(strTypes, LenStr, iGetResultTypeName(VZ_LPRC_RESULT_VLOOP_TRIGGER));
		strcat_s(strTypes, LenStr, "|");
	}

	return(strTypes);
};



// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CNetGroupDlg dialog




CNetGroupDlg::CNetGroupDlg(CWnd* pParent /*=NULL*/)
: CDialog(CNetGroupDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	VzLPRClient_Setup();
}

CNetGroupDlg::~CNetGroupDlg()
{
	VzLPRClient_Cleanup();
}

void CNetGroupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_IPADDRESS_DEVICE, m_DeviceIP);
	DDX_Control(pDX, IDC_LIST_NET_GROUP_PLATE_RESULT, m_ListNetGroupPlate);
	DDX_Control(pDX, IDC_LIST_NET_GROUP_INFO, m_ListNetGroupInfo);

	//DDX_Control(pDX, IDC_LIST_DEVICE_IP, m_ListBoxDeviceIp);
	DDX_Control(pDX, IDC_IMAGE_ONE, m_winOut[0].m_struInterV);
	DDX_Control(pDX, IDC_IMAGE_TWO, m_winOut[1].m_struInterV);
	DDX_Control(pDX, IDC_IMAGE_THREE, m_winOut[2].m_struInterV);
	DDX_Control(pDX, IDC_IMAGE_FOU, m_winOut[3].m_struInterV);
	DDX_Control(pDX, IDC_LIST_DEVICE_INFO, m_listDeviceInfo);
}

BEGIN_MESSAGE_MAP(CNetGroupDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BTN_OPEN_DEVICE, &CNetGroupDlg::OnBnClickedBtnOpenDevice)
	ON_BN_CLICKED(IDC_BTN_CLOSE_DEVICE, &CNetGroupDlg::OnBnClickedBtnCloseDevice)
	ON_BN_CLICKED(IDC_BTN_STRAT_NET_GROUP, &CNetGroupDlg::OnBnClickedBtnStratNetGroup)
	ON_BN_CLICKED(IDC_BTN_CLOSE_NET_GROUP, &CNetGroupDlg::OnBnClickedBtnCloseNetGroup)
	ON_BN_CLICKED(IDC_BTN_NET_GROUP_CONFIG, &CNetGroupDlg::OnBnClickedBtnNetGroupConfig)
	ON_BN_CLICKED(IDC_BTN_STRAT_NET_GROUP2, &CNetGroupDlg::OnBnClickedBtnStratNetGroup2)
	ON_BN_CLICKED(IDC_BTN_HAND_TRRIGER, &CNetGroupDlg::OnBnClickedBtnHandTrriger)
	ON_MESSAGE(WM_GROUP_IMG_MSG, &CNetGroupDlg::OnGroupImgMsg)
END_MESSAGE_MAP()


// CNetGroupDlg message handlers

BOOL CNetGroupDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_DeviceIP.SetAddress(192,168,4,132);

	SetDlgItemText(IDC_EDIT_PORT,"80");

	SetDlgItemText(IDC_EDIT_USER,"admin");

	SetDlgItemText(IDC_EDIT_PASSWORD,"admin");

	InitPlateGroupList();


	int nIDCEditResult[MAX_OUTPUT_NUM] =
	{
		IDC_EDIT_ONE, IDC_EDIT_TWO,
		IDC_EDIT_THREE, IDC_EDIT_FOUR
	};
	for(int i=0; i<MAX_OUTPUT_NUM; i++)
	{
		m_winOut[i].pEditResult = (CEdit *)GetDlgItem(nIDCEditResult[i]);
		m_winOut[i].m_struInterV.SetID(i);
		m_winOut[i].m_struInterV.SetInteractCallback(iOnViewerMouse, this);
		m_winOut[i].m_struInterV.SetCallBackOnPaint(iOnIVPaint, this);
	}


	Select(0);


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNetGroupDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNetGroupDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNetGroupDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CNetGroupDlg::OnBnClickedBtnOpenDevice()
{
	// TODO: Add your control notification handler code here

	BYTE ip1,ip2,ip3,ip4;
	m_DeviceIP.GetAddress(ip1,ip2,ip3,ip4);

	if(m_DeviceIP.IsBlank())
	{
		MessageBox("дipַ");
	}

	unsigned short port;
	char strip[50];

	GetDlgItemText(IDC_EDIT_PORT,strip,50);

	if(strlen(strip) == 0)
	{
		MessageBox("дip˿");
	}

	port = atoi(strip);


	sprintf_s(strip,50,"%d.%d.%d.%d",ip1,ip2,ip3,ip4);

	char user[50],password[50];

	GetDlgItemText(IDC_EDIT_USER,user,50);

	GetDlgItemText(IDC_EDIT_PASSWORD,password,50);


	if(strlen(user) == 0)
	{
		MessageBox("дû");
	}

	if(strlen(password) == 0)
	{
		MessageBox("д");
	}

	int itemCount =  m_listDeviceInfo.GetItemCount();

	if( m_VzClientTcp.OpenDevice( strip ,port,user,password ) )
	{
		//m_ListBoxDeviceIp.AddString( strip );

		LVITEM lv;


		lv.mask = LVIF_TEXT;
		lv.iItem = itemCount;
		lv.iSubItem = 0;
		lv.pszText = strip;
		lv.cchTextMax = strlen(strip);
		m_listDeviceInfo.InsertItem((&lv));

		lv.iSubItem = 1;
		lv.pszText = "";
		lv.cchTextMax = strlen("");
		m_listDeviceInfo.SetItem((&lv));



	}
	else 
	{
		MessageBox("ʧ");
	}

}

void CNetGroupDlg::OnBnClickedBtnCloseDevice()
{
	// TODO: Add your control notification handler code here

	POSITION pos=m_listDeviceInfo.GetFirstSelectedItemPosition();

	int iSelectNum=-1;
	CString textip;
	bool errorFlag= false;

	if(pos  )
	{

		iSelectNum= m_listDeviceInfo.GetNextSelectedItem(pos);

		if(iSelectNum <0 ||iSelectNum>=m_listDeviceInfo.GetItemCount())
		{
			errorFlag = true;
		}

	}
	else
	{ 
		errorFlag = true;
	}

	if(errorFlag)
	{

		if( m_listDeviceInfo.GetItemCount() > 0 )
			MessageBox("ѡ豸");
		else
		{
			MessageBox("豸");
		}
		return;
	}

	textip =m_listDeviceInfo.GetItemText(iSelectNum,0);

	if( !textip.IsEmpty() && m_VzClientTcp.CloseDevice(textip.GetBuffer())  )
	{
		m_listDeviceInfo.DeleteItem(iSelectNum);

		Delete(textip.GetBuffer());

	}
	else
	{
		MessageBox("ر豸ʧ");
	}
}

void CNetGroupDlg::OnBnClickedBtnStratNetGroup()
{
	// TODO: Add your control notification handler code here
	POSITION pos=m_listDeviceInfo.GetFirstSelectedItemPosition();

	int iSelectNum=-1;
	CString textip;
	bool errorFlag= false;

	if(pos  )
	{

		iSelectNum= m_listDeviceInfo.GetNextSelectedItem(pos);

		if(iSelectNum <0 ||iSelectNum>=m_listDeviceInfo.GetItemCount())
		{
			errorFlag = true;
		}

	}
	else
	{ 
		errorFlag = true;
	}

	if(errorFlag)
	{

		if( m_listDeviceInfo.GetItemCount() > 0 )
			MessageBox("ѡ豸");
		else
		{
			MessageBox("豸");
		}
		return;
	}


	textip =m_listDeviceInfo.GetItemText(iSelectNum,0);

	if( !m_VzClientTcp.SetDGResultEnable( textip.GetBuffer(),true ) )
	{
		MessageBox("ʧ");

	}
	else
	{
		LVITEM lv;


		lv.mask = LVIF_TEXT;
		lv.iItem = iSelectNum;
		lv.iSubItem = 1;
		lv.pszText = "";
		lv.cchTextMax = strlen("");
		m_listDeviceInfo.SetItem((&lv));

		m_VzClientTcp.SetPlateGroupInfoCallBack(textip.GetBuffer(),PlateGroupInfo_cb,this);

	}


}

void CNetGroupDlg::OnBnClickedBtnCloseNetGroup()
{
	// TODO: Add your control notification handler code here

	POSITION pos=m_listDeviceInfo.GetFirstSelectedItemPosition();

	int iSelectNum=-1;
	CString textip;
	bool errorFlag= false;

	if(pos  )
	{

		iSelectNum= m_listDeviceInfo.GetNextSelectedItem(pos);

		if(iSelectNum <0 ||iSelectNum>=m_listDeviceInfo.GetItemCount())
		{
			errorFlag = true;
		}

	}
	else
	{ 
		errorFlag = true;
	}

	if(errorFlag)
	{

		if( m_listDeviceInfo.GetItemCount() > 0 )
			MessageBox("ѡ豸");
		else
		{
			MessageBox("豸");
		}
		return;
	}


	textip =m_listDeviceInfo.GetItemText(iSelectNum,0);


	if( !m_VzClientTcp.SetDGResultEnable( textip.GetBuffer(),false ) )
	{
		MessageBox("ʧ");

	}
	else
	{
		LVITEM lv;


		lv.mask = LVIF_TEXT;
		lv.iItem = iSelectNum;
		lv.iSubItem = 1;
		lv.pszText = "";
		lv.cchTextMax = strlen("");
		m_listDeviceInfo.SetItem((&lv));
		m_VzClientTcp.SetPlateGroupInfoCallBack(textip.GetBuffer(),0,0);
	}



}

void CNetGroupDlg::OnBnClickedBtnNetGroupConfig()
{
	// TODO: Add your control notification handler code here
	POSITION pos=m_listDeviceInfo.GetFirstSelectedItemPosition();

	int iSelectNum=-1;
	CString textip;
	bool errorFlag= false;

	if(pos  )
	{

		iSelectNum= m_listDeviceInfo.GetNextSelectedItem(pos);

		if(iSelectNum <0 ||iSelectNum>=m_listDeviceInfo.GetItemCount())
		{
			errorFlag = true;
		}

	}
	else
	{ 
		errorFlag = true;
	}

	if(errorFlag)
	{

		if( m_listDeviceInfo.GetItemCount() > 0 )
			MessageBox("ѡ豸");
		else
		{
			MessageBox("豸");
		}
		return;
	}


	textip =m_listDeviceInfo.GetItemText(iSelectNum,0);

	//ȿҳ

}

void CNetGroupDlg::OnBnClickedBtnStratNetGroup2()
{
	// TODO: Add your control notification handler code here


	POSITION pos=m_listDeviceInfo.GetFirstSelectedItemPosition();

	int iSelectNum=-1;
	CString textip;
	bool errorFlag= false;

	if(pos  )
	{

		iSelectNum= m_listDeviceInfo.GetNextSelectedItem(pos);

		if(iSelectNum <0 ||iSelectNum>=m_listDeviceInfo.GetItemCount())
		{
			errorFlag = true;
		}

	}
	else
	{ 
		errorFlag = true;
	}

	if(errorFlag)
	{

		if( m_listDeviceInfo.GetItemCount() > 0 )
			MessageBox("ѡ豸");
		else
		{
			MessageBox("豸");
		}
		return;
	}


	textip =m_listDeviceInfo.GetItemText(iSelectNum,0);


	if( IsInclude( textip.GetBuffer() ) )
	{
		unsigned int inum  = 0;

		if(Get( textip.GetBuffer() ,inum) )
		{
			if(inum == m_nIdxWinCurrSelected )  //ͬһ
				return;


			m_VzClientTcp.SetPlateInfoCallBack( textip.GetBuffer()  ,0,0,true);
			Delete( textip.GetBuffer()  );
		}

	}

	if( IsInclude(m_nIdxWinCurrSelected )   )
	{
		std::string ip;

		Get(m_nIdxWinCurrSelected,ip);

		m_VzClientTcp.SetPlateInfoCallBack((char*)ip.c_str(),0,0,true);

		Delete((char*)ip.c_str());


	}

	if( !textip.IsEmpty() && m_VzClientTcp.SetPlateInfoCallBack(textip.GetBuffer(),OnPlateInfo,this,true)  )
	{

		m_VzClientTcp.PlayVedio(textip.GetBuffer(),m_winOut[m_nIdxWinCurrSelected*2].GetHWnd());

		Insert(textip.GetBuffer(),m_nIdxWinCurrSelected);
	}
	else
	{
		MessageBox("豸Ƶʧ");
	}


}


void  CNetGroupDlg::InitPlateGroupList()
{
	LVCOLUMN lc;

	lc.mask = LVCF_TEXT | LVCF_WIDTH;
	lc.pszText = "豸IP";
	lc.cx = 100;
	lc.cchTextMax = strlen("豸IP");
	m_ListNetGroupPlate.InsertColumn(0, &lc);


	lc.pszText = "ƺ";
	lc.cx = 70;
	lc.cchTextMax = strlen("ƺ");
	m_ListNetGroupPlate.InsertColumn(1, &lc);

	lc.pszText = "ʱ";
	lc.cx = 120;
	lc.cchTextMax = strlen("ʱ");
	m_ListNetGroupPlate.InsertColumn(2, &lc);

	lc.pszText = "ʱ";
	lc.cx = 120;
	lc.cchTextMax = strlen("ʱ");
	m_ListNetGroupPlate.InsertColumn(3, &lc);

	lc.pszText = "ʱ";
	lc.cx = 100;
	lc.cchTextMax = strlen("ʱ");
	m_ListNetGroupPlate.InsertColumn(4, &lc);

	lc.mask = LVCF_TEXT | LVCF_WIDTH;
	lc.pszText = "豸IP";
	lc.cx = 150;
	lc.cchTextMax = strlen("豸IP");
	m_listDeviceInfo.InsertColumn(0, &lc);


	lc.pszText = "ʶ";
	lc.cx = 130;
	lc.cchTextMax = strlen("ʶ");
	m_listDeviceInfo.InsertColumn(1, &lc);

	DWORD dwStyle = m_listDeviceInfo.GetExtendedStyle(); 
	dwStyle |= LVS_EX_FULLROWSELECT; 
	m_listDeviceInfo.SetExtendedStyle(dwStyle); 
}

void CNetGroupDlg::RecivePlateGroupInfo(VzLPRClientHandle handle, int exitEntryInfo, const TH_PlateResult *exitIvsInfo, const TH_PlateResult *entryIvsInfo, const IVS_DG_DEVICE_INFO *exitDGInfo, const IVS_DG_DEVICE_INFO *entryDGInfo)
{
	int itemCount = m_ListNetGroupPlate.GetItemCount();

	char strtemp[50];
	LVITEM lv;


	lv.mask = LVIF_TEXT;
	lv.iItem = itemCount;
	lv.iSubItem = 0;
	lv.pszText = (LPSTR)entryDGInfo->vzIP;
	lv.cchTextMax = strlen(entryDGInfo->vzIP);
	m_ListNetGroupPlate.InsertItem((&lv));

	//ƺ
	sprintf_s(strtemp, 50, "%s", entryIvsInfo->license);
	lv.mask = LVIF_TEXT;
	lv.iSubItem = 1;
	lv.pszText = strtemp;
	lv.cchTextMax = strlen(strtemp);
	m_ListNetGroupPlate.SetItem((&lv));

	

	//ʱ
	sprintf_s(strtemp, 50, "%d:%d:%d %d:%d:%d", entryIvsInfo->struBDTime.bdt_year, entryIvsInfo->struBDTime.bdt_mon, entryIvsInfo->struBDTime.bdt_mday, entryIvsInfo->struBDTime.bdt_hour, entryIvsInfo->struBDTime.bdt_min, entryIvsInfo->struBDTime.bdt_sec);
	
	COleDateTime entry;
	entry.ParseDateTime(strtemp);

	lv.iSubItem = 2;
	lv.pszText = strtemp;
	lv.cchTextMax = strlen(strtemp);
	m_ListNetGroupPlate.SetItem((&lv));

	//ʱ
	bool exitEmptyFlag = true;

	COleDateTime exit;
	if(strlen(exitIvsInfo->license) != 0)
		exitEmptyFlag = false;

	if(!exitEmptyFlag)
	{

		sprintf_s(strtemp, 50, "%d:%d:%d %d:%d:%d", exitIvsInfo->struBDTime.bdt_year, exitIvsInfo->struBDTime.bdt_mon, exitIvsInfo->struBDTime.bdt_mday, exitIvsInfo->struBDTime.bdt_hour, exitIvsInfo->struBDTime.bdt_min, exitIvsInfo->struBDTime.bdt_sec);
		exit.ParseDateTime(strtemp);

		lv.iSubItem = 3;
		lv.pszText = strtemp;
		lv.cchTextMax = strlen(strtemp);
		m_ListNetGroupPlate.SetItem((&lv));
	}


	//ͣ
	if(strcmp(exitIvsInfo->license,entryIvsInfo->license)==0 && !exitEmptyFlag)
	{

		//CTimeSpan  every = exit - entry;

		//sprintf_s(strtemp, 50, "%d", every.GetDays()*3600*24+ every.GetHours()*3600+every.GetMinutes()*60+every.GetSeconds());
		//lv.iSubItem = 4;
		//lv.pszText = strtemp;
		//lv.cchTextMax = strlen(strtemp);
		//m_ListNetGroupPlate.SetItem((&lv));
	}

	// ȡͼƬ
	if ( exitIvsInfo->uId > 0 && strlen(exitDGInfo->vzSN) > 0 )
	{
		LoadGroupImg(handle, exitIvsInfo->uId, exitDGInfo->vzSN, exitIvsInfo->license, false);
	}

	// ȡͼƬ
	if ( entryIvsInfo->uId > 0 && strlen(entryDGInfo->vzSN) > 0 )
	{
		// LoadGroupImg(handle, entryIvsInfo->uId, entryDGInfo->vzSN, entryIvsInfo->license, true);
	}
}


void CNetGroupDlg::OnViewerMouse0(IV_EVENT eEvent, int x, int y, int nId)
{
	if(eEvent == IV_EVENT_L_BTN_DOWN)
	{ 
		Select(nId/2);
	}
}


void CNetGroupDlg::iOnIVPaint1(int nID, bool bActive, bool bInUse)
{

	m_winOut[nID].ShowString();

	if(bInUse)
	{
		//if(nID>= (MAX_OUTPUT_NUM>>1))
		m_winOut[nID].ShowFrame();
	}
}


void  CNetGroupDlg::Select(unsigned int id)
{
	OutputWin &winOut = m_winOut[id*2];
	OutputWin &winOut2 = m_winOut[id*2 + 1];

	//	
	m_nIdxWinCurrSelected = id;
	winOut.m_struInterV.SetActive(true);
	winOut2.m_struInterV.SetActive(true);
	for(int i=0; i<MAX_OUTPUT_NUM; i++)
	{
		if(i==id*2 || i==id*2+1)
			continue;
		m_winOut[i].m_struInterV.SetActive(false);
	}
}




void CNetGroupDlg::OnPlateInfo0(VzLPRClientHandle handle,
								const TH_PlateResult *pResult, unsigned uNumPlates,
								VZ_LPRC_RESULT_TYPE eResultType,
								const VZ_LPRC_IMAGE_INFO *pImgFull,
								const VZ_LPRC_IMAGE_INFO *pImgPlateClip)
{
	if(handle == NULL || pResult == NULL || uNumPlates == 0)
		return;

	char strip[20];

	memset(strip,0,20);

	m_VzClientTcp.GetRelateIp(handle,strip,20);

	unsigned  int iSelectNum = 0 ;


	if( Get(strip,iSelectNum) )
	{
		char strMsg[MAX_LEN_STR] = {0};

		for(unsigned i=0; i<uNumPlates; i++)
		{
			char strTmp[MAX_LEN_STR];

			sprintf_s(strTmp, MAX_LEN_STR, " [%s:%s =%d)] %s %d/%02d/%02d %02d:%02d:%02d",
				iGetResultTypeNameByBits(pResult[i].uBitsTrigType),	pResult[i].license,
				pResult[i].rcLocation.right - pResult[i].rcLocation.left, iGetDirString(pResult[i].nDirection),
				pResult[i].struBDTime.bdt_year, pResult[i].struBDTime.bdt_mon, pResult[i].struBDTime.bdt_mday,
				pResult[i].struBDTime.bdt_hour, pResult[i].struBDTime.bdt_min, pResult[i].struBDTime.bdt_sec);
			strcat_s(strMsg, MAX_LEN_STR, strTmp);
		}

		OutputWin *pOutWin = 0;

		if(eResultType == VZ_LPRC_RESULT_REALTIME )
		{
			pOutWin = &m_winOut[iSelectNum*2];
		}
		else
		{
			pOutWin = &m_winOut[iSelectNum*2+1];
		}


		if(pOutWin)
		{
			pOutWin->UpdateString(strMsg);

			if(pImgFull)
			{
				pOutWin->SetFrame(pImgFull->pBuffer, pImgFull->uWidth, pImgFull->uHeight, pImgFull->uPitch);
				//unsigned uYOffset = 4;
				//for(unsigned i=0; i<uNumPlates; i++)
				//{
					//pOutWin->AddPatch(pImgPlateClip[i].pBuffer, pImgPlateClip[i].uWidth,
					//pImgPlateClip[i].uHeight, pImgPlateClip[i].uPitch, 4, uYOffset);
					//uYOffset += pImgPlateClip[i].uHeight;
				//}
			}
		}
	}
}



void  CNetGroupDlg::Insert(char *ip,unsigned int id)
{
	bool bFind = false;

	for(unsigned int i = 0 ;  i < m_vipid.size(); i++ )
	{
		if( strcmp( m_vipid[i].ip.c_str() ,ip)==0 || m_vipid[i].id == id  )
		{
			bFind = true;

			break;
		}
	}


	if(!bFind)
	{
		ipid ii;

		ii.ip = ip;
		ii.id = id;

		m_vipid.push_back(ii);
	}

}

bool  CNetGroupDlg::IsInclude(char *ip)
{
	bool bFind = false;

	for(unsigned int i = 0 ;  i < m_vipid.size(); i++ )
	{
		if( strcmp( m_vipid[i].ip.c_str() ,ip)==0  )
		{
			bFind = true;

			break;
		}
	}

	if(bFind )
		return true;
	else
		return false;
}

bool  CNetGroupDlg::IsInclude(unsigned int id)
{
	bool bFind = false;

	for(unsigned int i = 0 ;  i < m_vipid.size(); i++ )
	{
		if( m_vipid[i].id == id)
		{
			bFind = true;

			break;
		}
	}

	if(bFind )
		return true;
	else
		return false;
}


bool  CNetGroupDlg::Get(char *ip ,unsigned int & id)
{
	for(unsigned int i = 0 ;  i < m_vipid.size(); i++ )
	{
		if( strcmp( m_vipid[i].ip.c_str() ,ip)==0 )
		{
			id = m_vipid[i].id;

			return true;
		}
	}

	return false;
}

bool  CNetGroupDlg::Get(unsigned int  id,std::string &ip)
{
	for(unsigned int i = 0 ;  i < m_vipid.size(); i++ )
	{
		if(  id == m_vipid[i].id)
		{
			ip = m_vipid[i].ip ;

			return true;
		}
	}

	return false;
}


bool  CNetGroupDlg::Delete(char *ip)
{
	for(unsigned int i = 0 ;  i < m_vipid.size(); i++ )
	{
		if( strcmp( m_vipid[i].ip.c_str() ,ip)==0 )
		{
			OutputWin &winOut = m_winOut[m_vipid[i].id*2];
			OutputWin &winOut2 = m_winOut[m_vipid[i].id*2 + 1];


			winOut.SetClientHandle(0);
			winOut.UpdateString("");
			winOut.m_struInterV.Invalidate();

			winOut2.SetClientHandle(0);
			winOut2.UpdateString("");
			winOut2.m_struInterV.Invalidate();

			m_vipid.erase( m_vipid.begin() + i );

			return true;
		}
	}

	return true;
}


OutputWin *CNetGroupDlg::iGetOutputWinByIdx(int iSelectNumWin)
{
	if(iSelectNumWin >= 0 && iSelectNumWin < (MAX_OUTPUT_NUM>>1))
		return(m_winOut + iSelectNumWin);

	return(NULL);
}

OutputWin *CNetGroupDlg::iGetStableOutputWinByIdx(int iSelectNum)
{
	OutputWin *pWin = iGetOutputWinByIdx(iSelectNum);
	if(pWin == NULL)
		return(NULL);

	return(pWin + (MAX_OUTPUT_NUM>>1));
}



void CNetGroupDlg::OnBnClickedBtnHandTrriger()
{
	// TODO: Add your control notification handler code here

	POSITION pos=m_listDeviceInfo.GetFirstSelectedItemPosition();

	int iSelectNum=-1;
	CString textip;
	bool errorFlag= false;

	if(pos  )
	{

		iSelectNum= m_listDeviceInfo.GetNextSelectedItem(pos);

		if(iSelectNum <0 ||iSelectNum>=m_listDeviceInfo.GetItemCount())
		{
			errorFlag = true;
		}

	}
	else
	{ 
		errorFlag = true;
	}

	if(errorFlag)
	{

		if( m_listDeviceInfo.GetItemCount() > 0 )
			MessageBox("ѡ豸");
		else
		{
			MessageBox("豸");
		}
		return;
	}


	textip =m_listDeviceInfo.GetItemText(iSelectNum,0);




	if( !m_VzClientTcp.ForceTrigger( textip.GetBuffer() ) )
	{
		MessageBox("ֶʧ");

	}

}

// ȡǰ·
string GetAppPath()
{
	string sAppPath;

	TCHAR tszModule[MAX_PATH + 1] = { 0 };
	::GetModuleFileName(NULL, tszModule, MAX_PATH);

	sAppPath.assign((char*)tszModule);
	int pos = sAppPath.find_last_of('\\');
	sAppPath = sAppPath.substr(0, pos);

	return sAppPath;
}

int IsPathExist(const char *filename)
{
	return (_access(filename, NULL) == 0);
}

bool WriteImgFile(const char *filepath, unsigned char *pData, unsigned int len)
{
	int num = 0;

	FILE *fp = NULL;
	fopen_s(&fp, filepath, "wb+");

	if (fp == NULL)
	{
		return false;
	}

	num = fwrite(pData, sizeof(char), len, fp);
	fclose(fp);

	return num > 0;
}

bool CNetGroupDlg::LoadGroupImg(VzLPRClientHandle handle, int id, std::string sn,std::string plate, bool isEntry)
{
	bool ret = false;

	auto LoadImgProc = [&](VzLPRClientHandle handle, int id, std::string sn, std::string plate, bool isEntry) -> void
	{
		int img_size = 1280 * 720;
		char *img_buf = new char[img_size];
		memset(img_buf, 0, img_size);

		int ret_load = VzLPRClient_LoadGroupFullImageById(handle, id, sn.c_str(), img_buf, &img_size);
		if (ret_load == 0)
		{
			char *img_path = new char[MAX_PATH];
			memset(img_path, 0, MAX_PATH);

			// ͼƬ
			string sAppPath = GetAppPath();

			// ļ
			char szImgDir[MAX_PATH] = { 0 };
			sprintf_s(szImgDir, sizeof(szImgDir), "%s\\Cap", sAppPath.c_str());

			if (!IsPathExist(szImgDir))
			{
				::CreateDirectory(szImgDir, NULL);
			}

			strcat(szImgDir, "\\");
			if (!IsPathExist(szImgDir))
			{
				::CreateDirectory(szImgDir, NULL);
			}

			if (isEntry)
			{
				strcat(szImgDir, "\\");
				if (!IsPathExist(szImgDir))
				{
					::CreateDirectory(szImgDir, NULL);
				}
			}
			else
			{
				strcat(szImgDir, "\\");
				if (!IsPathExist(szImgDir))
				{
					::CreateDirectory(szImgDir, NULL);
				}
			}

			SYSTEMTIME st;
			GetLocalTime(&st);

			sprintf_s(img_path, MAX_PATH, "%s\\%d-%02d-%02d_%02d%02d%02d%03d_%s.jpg", szImgDir, st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond, st.wMilliseconds, plate.c_str());

			WriteImgFile(img_path, (unsigned char *)img_buf, img_size);

			this->PostMessage(WM_GROUP_IMG_MSG, (WPARAM)img_path, (LPARAM)isEntry);
		}

		delete[] img_buf;
		img_buf = NULL;
	};


	std::thread oThread(LoadImgProc, handle, id, sn, plate, isEntry);
	oThread.detach();

	return ret;
}

LRESULT CNetGroupDlg::OnGroupImgMsg(WPARAM w, LPARAM l)
{
	char *img_path = (char *)w;
	bool isEntry = (bool)l;

	if (img_path != NULL)
	{
		OnShowImgMessage(isEntry, img_path);

		delete[] img_path;
		img_path = NULL;
	}

	return 0;
}

bool CNetGroupDlg::OnShowImgMessage(bool isEntry, char *img_path)
{
	bool ret = false;

	CWnd *pWnd = NULL;
	if (isEntry)
	{
		pWnd = this->GetDlgItem(IDC_IMAGE_TWO);
	}
	else
	{ 
		pWnd = this->GetDlgItem(IDC_IMAGE_FOU);
	}

	if (pWnd == NULL || img_path == NULL)
	{
		return false;
	}

	CDC *pDC = pWnd->GetDC();

	RECT rc;
	pWnd->GetClientRect(&rc);

	CImage img;
	HRESULT hr = img.Load(img_path);
	if (SUCCEEDED(hr))
	{
		RECT rcSrc;
		rcSrc.left = 0;
		rcSrc.top = 0;
		rcSrc.right = img.GetWidth();
		rcSrc.bottom = img.GetHeight();

		SetStretchBltMode(pDC->m_hDC, COLORONCOLOR);

		img.Draw(pDC->m_hDC, rc, rcSrc);
		ReleaseDC(pDC);

		ret = true;
	}

	return ret;
}