// NetGroupDlg.h : header file
//

#pragma once
#include "afxcmn.h"
#include<VzLPRClientSDK.h>
#include <vector>
#include "afxwin.h"
#include "VzClientTcp.h"
#include "OutputWin.h"

#define MAX_OUTPUT_NUM	4

typedef struct tag_ipid
{
	unsigned int id;
	std::string ip;
	
}ipid;




// CNetGroupDlg dialog
class CNetGroupDlg : public CDialog
{
// Construction
public:
	CNetGroupDlg(CWnd* pParent = NULL);	// standard constructor
    ~CNetGroupDlg();

// Dialog Data
	enum { IDD = IDD_NETGROUP_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedBtnOpenDevice();
	afx_msg void OnBnClickedBtnCloseDevice();
	afx_msg void OnBnClickedBtnStratNetGroup();
	afx_msg void OnBnClickedBtnCloseNetGroup();
	afx_msg void OnBnClickedBtnNetGroupConfig();
	afx_msg LRESULT OnGroupImgMsg(WPARAM w, LPARAM l);
	CIPAddressCtrl m_DeviceIP;
	CListCtrl m_ListNetGroupPlate;
	CListCtrl m_ListNetGroupInfo;
	
	afx_msg void OnBnClickedBtnStratNetGroup2();

	
    void InitPlateGroupList();

	void RecivePlateGroupInfo(VzLPRClientHandle handle, int exitEntryInfo, const TH_PlateResult *exitIvsInfo, const TH_PlateResult *entryIvsInfo, const IVS_DG_DEVICE_INFO *exitDGInfo, const IVS_DG_DEVICE_INFO *entryDGInfo);

	void OnViewerMouse0(IV_EVENT eEvent, int x, int y, int nId);

	void iOnIVPaint1(int nID, bool bActive, bool bInUse);

	//CListBox m_ListBoxDeviceIp;
	
	OutputWin    m_winOut[MAX_OUTPUT_NUM];

	unsigned int   m_nIdxWinCurrSelected;

	void  Select(unsigned int id);

	 

	void  Insert(char *ip,unsigned int id);
	bool  IsInclude(char *ip);

	bool  IsInclude(unsigned int id);

	bool  Get(char *ip ,unsigned int & id);
	bool  Get(unsigned int  id,std::string &ip);
	bool  Delete(char *ip);

	bool LoadGroupImg(VzLPRClientHandle handle, int id, std::string sn, std::string plate, bool isEntry = true);

	std::vector<ipid>   m_vipid;
  
	OutputWin * iGetOutputWinByIdx(int nIdxWin);

	OutputWin * iGetStableOutputWinByIdx(int nIdx);

	void    OnPlateInfo0(VzLPRClientHandle handle,
								const TH_PlateResult *pResult, unsigned uNumPlates,
								VZ_LPRC_RESULT_TYPE eResultType,
								const VZ_LPRC_IMAGE_INFO *pImgFull,
								const VZ_LPRC_IMAGE_INFO *pImgPlateClip);


	CVzClientTcp   m_VzClientTcp;
	
	afx_msg void OnBnClickedBtnHandTrriger();

	bool OnShowImgMessage(bool isEntry, char *img_path);

	CListCtrl m_listDeviceInfo;
	CEdit m_editOne;
	CEdit m_editThree;
};
