#include "StdAfx.h"
#include "VzClientTcp.h"

CVzClientTcp::CVzClientTcp(void)
{
	VzLPRClient_Setup();
}

CVzClientTcp::~CVzClientTcp(void)
{
	CloseAllDevice();
	VzLPRClient_Cleanup();
}



bool CVzClientTcp::OpenDevice( char * ip,unsigned short port,char * username,char * password )
{
    if( IsInclude( ip ,strlen(ip) ) )
	{
	   SetErrorText("Ѵڴ򿪵豸",strlen("Ѵڴ򿪵豸"));
       return false;
 	}

	//豸
	VzLPRClientHandle handle = VzLPRClient_Open( ip,port,username,password );


	if( handle )
	{ 
	    Insert( ip,handle );

       return true;
	}
	else
	{
        SetErrorText("豸ʧ",strlen("豸ʧ"));
		return false;
	}

}

bool CVzClientTcp::CloseDevice( char * ip )
{
     DeviceRelateGroup  drg;

     if( Get(ip,drg) )
	 {
		 //ԭص
		  VzLPRClient_SetPlateInfoCallBack(drg.handle, NULL, NULL, 0);

		  VzLPRClient_SetPlateGroupInfoCallBack(drg.handle,NULL,NULL);


		 //Ƿڲ״̬
		 if(drg.play_handle && VzLPRClient_StopRealPlay(drg.play_handle) == -1 )    
		 {
			 SetErrorText("ֹͣ豸ʧ",strlen("ֹͣ豸ʧ"));
			  return false;
		 }

		 if( VzLPRClient_Close(drg.handle) == -1)
		 {
              SetErrorText("ر豸ʧ",strlen("ر豸ʧ"));
			  return false;
		 }

		 Delete(ip);

		 return true;
	 }

     SetErrorText("رδ򿪵豸",strlen("رδ򿪵豸"));
	 return false;
}

void CVzClientTcp::CloseAllDevice()
{
     DeviceRelateGroup  drg;

     while( Get( (unsigned short)0 ,drg) )
	 {
		  //Ƿڲ״̬
		 if(drg.play_handle )    
		 {
             VzLPRClient_StopRealPlay(drg.play_handle);
		 }

		 if( VzLPRClient_Close(drg.handle) == 0)
		 {
             Delete(drg.ip);
		 }
	 }
}


bool CVzClientTcp::PlayVedio( char *ip , HWND hwnd )
{ 
	DeviceRelateGroup  drg;
 
	//z鴰ھǷѾװ
	if(Get(hwnd,drg))
	{
		ASSERT(drg.play_handle != -1);
		 
		if( VzLPRClient_StopRealPlay(drg.play_handle) == -1 )    
		{
			SetErrorText("ֹͣԭռõǰھ豸ʧ",strlen("ֹͣԭռõǰھ豸ʧ"));
			return false;
		}

		Config(drg.ip,0,0);
	}
 
    if( Get(ip,drg) )
	{
		//Ƿڲ״̬
		if(drg.play_handle)
		{
			if(drg.hwnd != hwnd)   //Ƿͬһھ
			{
				if( VzLPRClient_StopRealPlay(drg.play_handle) == -1 )    
				{
					SetErrorText("ֹͣǰ豸ʧ",strlen("ֹͣǰ豸ʧ"));
					return false;
				}

				Config(drg.ip,0,0);
			}
			else 
				return true;
		}
        
        //豸
		drg.play_handle = VzLPRClient_StartRealPlay(drg.handle,(void*)hwnd);

		if( drg.play_handle  == -1 )
		{
		   SetErrorText("ŵǰ豸ʧ",strlen("ŵǰ豸ʧ"));
           return false;
		}

		 Config(drg.ip,drg.play_handle,hwnd);
		return true;
	}

	SetErrorText("δ򿪵豸",strlen("δ򿪵豸"));
    return false;
}

bool CVzClientTcp::StopVedio( char *ip )
{
    DeviceRelateGroup  drg;

    if( Get(ip,drg) )
	{ 
		if( !drg.play_handle || VzLPRClient_StopRealPlay(drg.handle) == 0 )
		{
			Config(drg.ip,0,0);

			return true;
		}
		else
		{ 
			SetErrorText("ֹͣ豸ʧ",strlen("ֹͣ豸ʧ"));
            return false;
		}
	}
	
    SetErrorText("δ򿪵豸",strlen("δ򿪵豸"));
    return false;
} 

bool CVzClientTcp::GetOvzid( char * ip ,VZ_OVZID_RESULT* pData )
{
     DeviceRelateGroup  drg;

    if( Get(ip,drg) )
	{
		if( VzLPRClient_GetOvzid(drg.handle,pData) == 0 )
		{
			return true;
		}
	}

	SetErrorText("δ򿪵豸",strlen("δ򿪵豸"));

	return false;
}

bool CVzClientTcp::SetDGResultEnable( char * ip,bool bEnable )
{
    DeviceRelateGroup  drg;

    if( Get(ip,drg) )
	{
		if( VzLPRClient_SetDGResultEnable(drg.handle,bEnable) == 0 )
		{
			return true;
		}
		else
		{
           SetErrorText("ʧ",strlen("ʧ"));
		   return false;
		}

	}

	SetErrorText("δ򿪵豸",strlen("δ򿪵豸"));

	return false;
}

bool CVzClientTcp::ConfigDevicegroup(char * ip,VZ_OVZID_INFO *pInfo)
{
     return false;
}

bool CVzClientTcp::SetPlateInfoCallBack(char *ip,VZLPRC_PLATE_INFO_CALLBACK func,void *pUserData, int bEnableImage)
 {
   DeviceRelateGroup  drg;

    if( Get(ip,drg) )
	{
		if( VzLPRClient_SetPlateInfoCallBack(drg.handle,func,pUserData,bEnableImage) == 0 )
		{
			return true;
		}
		else
		{
           SetErrorText("óƻصʧ",strlen("óƻصʧ"));
		   return false;
		}
	}

	SetErrorText("δ򿪵豸",strlen("δ򿪵豸"));
	return false;
 }



bool CVzClientTcp::SetPlateGroupInfoCallBack(char * ip, VZLPRC_PLATE_GROUP_INFO_CALLBACK func, void *pUserData)
{
    DeviceRelateGroup  drg;

    if( Get(ip,drg) )
	{
		if( VzLPRClient_SetPlateGroupInfoCallBack(drg.handle,func,pUserData) == 0 )
		{
			return true;
		}
		else
		{
           SetErrorText("صʧ",strlen("صʧ"));
		   return false;
		}
	}

	SetErrorText("δ򿪵豸",strlen("δ򿪵豸"));
	return false;

}

bool CVzClientTcp::GetRelateIp( VzLPRClientHandle handle, char * ip ,unsigned short len )
{
   return Get( handle, ip, len );
}

unsigned short CVzClientTcp::GetLastErrorText(char *text ,unsigned short len)
{
	if(!text)
       return 0;

	int    iCopyLen  = m_ErrorText.size() > len ? len:m_ErrorText.size();

	memcpy(text,m_ErrorText.c_str(),iCopyLen);

	return iCopyLen;
}

bool CVzClientTcp::ForceTrigger(char * ip ) 
 {
   DeviceRelateGroup  drg;

    if( Get(ip,drg) )
	{
		if( VzLPRClient_ForceTrigger (drg.handle ) == 0 )
		{
			return true;
		}
	}

	SetErrorText("δ򿪵豸",strlen("δ򿪵豸"));
	return false;
 }

void CVzClientTcp::Insert(char * ip,VzLPRClientHandle handle)
{
	bool  bFind = false;

	for(unsigned int i = 0 ;  i < m_DeviceRelateGroup.size(); i++ )
	{
		if( strcmp(ip,m_DeviceRelateGroup[i].ip) == 0  )
		{
             bFind = true;

			 break;
		}
	}

    if(!bFind)
	{
		DeviceRelateGroup  drg;

		memset(drg.ip,0,sizeof(drg.ip));

		memcpy_s(drg.ip,20,ip,strlen(ip));

		drg.handle = handle;
		drg.play_handle = 0;
		drg.hwnd = 0;

		m_DeviceRelateGroup.push_back(drg);
	}
}
bool CVzClientTcp::Config(char * ip,int play_hand,HWND hwnd)
{
  
	for(unsigned int i = 0 ;  i < m_DeviceRelateGroup.size(); i++ )
	{
		if( strcmp(ip,m_DeviceRelateGroup[i].ip) == 0  )
		{
			m_DeviceRelateGroup[i].play_handle = play_hand;
			m_DeviceRelateGroup[i].hwnd = hwnd;
			return true;
		}
	}

    return false;
}

void CVzClientTcp::Delete(char * ip)
{
    for(unsigned int i = 0 ;  i < m_DeviceRelateGroup.size(); i++ )
	{
		if( strcmp(ip,m_DeviceRelateGroup[i].ip) == 0  )
		{
             m_DeviceRelateGroup.erase(m_DeviceRelateGroup.begin()+i);

			 break;
		}
	}
}

bool CVzClientTcp::Get(VzLPRClientHandle handle, char * ip ,unsigned short len )
{
    for(unsigned int i = 0 ;  i < m_DeviceRelateGroup.size(); i++ )
	{
		if( m_DeviceRelateGroup[i].handle == handle )
		{
			memcpy_s(ip,len,m_DeviceRelateGroup[i].ip,20);

			return true;
		}
	}

	return false;
}

bool CVzClientTcp::Get( char * ip ,DeviceRelateGroup &drg )
{
    for(unsigned int i = 0 ;  i < m_DeviceRelateGroup.size(); i++ )
	{
		if( strcmp(ip,m_DeviceRelateGroup[i].ip) == 0  )
		{
             drg = m_DeviceRelateGroup[i];

			 return true;
		}
	}

	return false;
}

bool  CVzClientTcp::Get(HWND hwnd,DeviceRelateGroup &drg)
{
  for(unsigned int i = 0 ;  i < m_DeviceRelateGroup.size(); i++ )
	{
		if( hwnd == m_DeviceRelateGroup[i].hwnd )
		{
             drg = m_DeviceRelateGroup[i];

			 return true;
		}
	}

	return false;
}

bool  CVzClientTcp::Get(unsigned short num ,DeviceRelateGroup &drg)
{
	if(num >= m_DeviceRelateGroup.size() )
		return false;

	drg = m_DeviceRelateGroup[num];

	return true;

}

void CVzClientTcp::SetErrorText(char * text ,unsigned short len)
{
    m_ErrorText = text;
}

bool  CVzClientTcp::IsInclude(char * ip,unsigned short len)
{
     bool  bFind = false;

	for(unsigned int i = 0 ;  i < m_DeviceRelateGroup.size(); i++ )
	{
		if( strcmp(ip,m_DeviceRelateGroup[i].ip) == 0  )
		{
             bFind = true;

			 break;
		}
	}

    if(!bFind)
	{
		return false;
	}
	else
		return true;
}