// DlgSubVideoCfgR1.cpp : implementation file
//

#include "stdafx.h"
#include "VzLPRSDKDemo.h"
#include "DlgSubVideoCfgR1.h"


// CDlgSubVideoCfgR1 dialog

IMPLEMENT_DYNAMIC(CDlgSubVideoCfgR1, CDialog)

CDlgSubVideoCfgR1::CDlgSubVideoCfgR1(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSubVideoCfgR1::IDD, pParent)
{
	m_hLPRClient = NULL;

	m_nMinDataRate = 0;
	m_nMaxDataRate = 0;
}

CDlgSubVideoCfgR1::~CDlgSubVideoCfgR1()
{
}

void CDlgSubVideoCfgR1::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMB_ENCODE_TYPE, m_cmbEncodeType);
	DDX_Control(pDX, IDC_CMB_FRAME_RATE, m_cmbFrameRate);
	DDX_Control(pDX, IDC_CMB_COMPRESS_MODE, m_cmbCompressMode);
	DDX_Control(pDX, IDC_CMB_IMG_QUALITY, m_cmbImgQuality);
	DDX_Control(pDX, IDC_CMB_FRAME_SIZE, m_cmbFrameSize);
	DDX_Control(pDX, IDC_EDIT_RATEVAL, m_editRateval);
	DDX_Control(pDX, IDC_CMB_STREAM_TYPE, m_cmbStreamType);
}


BEGIN_MESSAGE_MAP(CDlgSubVideoCfgR1, CDialog)
	ON_CBN_SELCHANGE(IDC_CMB_STREAM_TYPE, &CDlgSubVideoCfgR1::OnCbnSelchangeCmbStreamType)
	ON_BN_CLICKED(IDOK, &CDlgSubVideoCfgR1::OnBnClickedOk)
	ON_CBN_SELCHANGE(IDC_CMB_COMPRESS_MODE, &CDlgSubVideoCfgR1::OnCbnSelchangeCmbCompressMode)
END_MESSAGE_MAP()


// CDlgSubVideoCfgR1 message handlers

void CDlgSubVideoCfgR1::Load( )
{
	VZ_LPRC_R_ENCODE_PARAM encode_param = {0};

	VzLPRClient_RGet_Encode_Param(m_hLPRClient, 0, &encode_param);
	m_cmbStreamType.SetCurSel(encode_param.default_stream);

	LoadStreamParam(encode_param.default_stream);
}

void CDlgSubVideoCfgR1::LoadStreamParam( int stream_index )
{
	int modeval = 0;

	VZ_LPRC_R_ENCODE_PARAM encode_param = {0};
	VzLPRClient_RGet_Encode_Param(m_hLPRClient, stream_index, &encode_param);

	bool sub_stream = false;

	// 
	if( stream_index == 1 )
	{
		sub_stream = true;
	}

	int index = 0;

	VZ_LPRC_R_ENCODE_PARAM_PROPERTY param_property = {0};
	VzLPRClient_RGet_Encode_Param_Property(m_hLPRClient, &param_property);

	m_cmbFrameSize.ResetContent( );
	int resolution_cur = encode_param.resolution;

	m_nMinDataRate = param_property.data_rate_min;
	m_nMaxDataRate = param_property.data_rate_max;

	while( param_property.resolution[index].resolution_type > 0 )
	{
		m_cmbFrameSize.AddString(param_property.resolution[index].resolution_content);
		m_cmbFrameSize.SetItemData(index, param_property.resolution[index].resolution_type);

		if( resolution_cur == param_property.resolution[index].resolution_type )
		{
			m_cmbFrameSize.SetCurSel(index);
		}

		index++;

		if( sub_stream && index >= 3 )
		{
			break;
		}
	}

	if( encode_param.frame_rate >= 1 && encode_param.frame_rate <= 25 )
	{
		m_cmbFrameRate.SetCurSel(encode_param.frame_rate - 1);
	}

	if( encode_param.video_quality >=0 && encode_param.video_quality <= 6 )
	{
		m_cmbImgQuality.SetCurSel(encode_param.video_quality);
	}
	else
	{
		m_cmbImgQuality.SetCurSel(3);
	}

	CString strRateval ;
	strRateval.Format("%d", encode_param.data_rate / 1000);
	m_editRateval.SetWindowText( strRateval );

	//
	modeval = encode_param.rate_type;
	m_cmbCompressMode.SetCurSel(modeval);

	m_editRateval.EnableWindow(modeval == 0?TRUE:FALSE);
	m_cmbImgQuality.EnableWindow(modeval == 0? FALSE:TRUE);	
	
}

BOOL CDlgSubVideoCfgR1::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_cmbStreamType.AddString("");
	m_cmbStreamType.AddString("");

	m_cmbEncodeType.AddString("H264");
	m_cmbEncodeType.SetCurSel(0);

	CString strRate;
	for( int i = 1; i <= 25; i++ )
	{
		strRate.Format("%d", i);
		m_cmbFrameRate.AddString( strRate );
	}

	m_cmbCompressMode.AddString("");
	m_cmbCompressMode.AddString("");

	m_cmbImgQuality.AddString("");
	m_cmbImgQuality.AddString("");
	m_cmbImgQuality.AddString("");
	m_cmbImgQuality.AddString("е");
	m_cmbImgQuality.AddString("");
	m_cmbImgQuality.AddString("");
	m_cmbImgQuality.AddString("");

	Load();
	return TRUE;
}

void CDlgSubVideoCfgR1::SetLPRHandle( VzLPRClientHandle hLPRClient )
{
	m_hLPRClient = hLPRClient;
}

void CDlgSubVideoCfgR1::OnCbnSelchangeCmbStreamType()
{
	int cur_sel = m_cmbStreamType.GetCurSel( );
	LoadStreamParam(cur_sel);
}

// Ƶ
void CDlgSubVideoCfgR1::OnBnClickedOk()
{
	int stream_type = m_cmbStreamType.GetCurSel( );

	VZ_LPRC_R_ENCODE_PARAM encode_param = {0};
	encode_param.default_stream = stream_type;

	int frame_size = m_cmbFrameSize.GetCurSel();
	int frame_type = m_cmbFrameSize.GetItemData(frame_size);
	encode_param.resolution =  frame_type;

	encode_param.frame_rate = m_cmbFrameRate.GetCurSel() + 1;

	encode_param.rate_type = m_cmbCompressMode.GetCurSel();

	encode_param.video_quality = m_cmbImgQuality.GetCurSel();

	CString strRateval;
	m_editRateval.GetWindowText(strRateval);

	int nRate = atoi(strRateval.GetBuffer(0)) * 1000;

	if( nRate < m_nMinDataRate || nRate > m_nMaxDataRate )
	{
		CString msgInfo;
		msgInfo.Format("ΧΪ%d-%d룡", m_nMinDataRate / 1000, m_nMaxDataRate / 1000);

		MessageBox(msgInfo);
		return;
	}

	encode_param.data_rate = nRate;

	int ret = VzLPRClient_RSet_Encode_Param(m_hLPRClient, stream_type, &encode_param);
	if( ret != 0 )
	{
		MessageBox("Ƶʧܣԣ");
	}

	MessageBox("Ƶɹ");
}

void CDlgSubVideoCfgR1::OnCbnSelchangeCmbCompressMode()
{
	int nCurSel = m_cmbCompressMode.GetCurSel();
	if ( nCurSel == 0 )
	{
		m_editRateval.EnableWindow(TRUE);
		m_cmbImgQuality.EnableWindow(FALSE);
	}
	else
	{
		m_editRateval.EnableWindow(FALSE);
		m_cmbImgQuality.EnableWindow(TRUE);
	}
}
