// DlgTalkClient.cpp : ʵļ
//

#include "stdafx.h"
#include "DlgTalkClient.h"
#include "mmsystem.h"

#define ONPHONE_TEXT _T("ͨ")
#define CALLING_TEXT _T("")

// CDlgTalkClient Ի


IMPLEMENT_DYNAMIC(CDlgTalkClient, CDialog)

CDlgTalkClient::CDlgTalkClient(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgTalkClient::IDD, pParent),
  m_rDev(NULL),
  m_recordTime(0),
  m_bRecording(false),
  m_ntalkHandle(0)
{
  m_RequestIP.clear();
}

CDlgTalkClient::~CDlgTalkClient()
{
}

void CDlgTalkClient::InitTreeData(vector <DeviceLPR *> *treedata)
{
  m_rDev = treedata;
}

void CDlgTalkClient::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_TALK_TREE_DEVICE, m_treeTalkDeviceList);
  DDX_Control(pDX, IDC_BTN_RECIVE, m_btnStartTalk);
  DDX_Control(pDX, IDC_BTN_CLOSE, m_btnStopTalk);
  DDX_Control(pDX, IDC_BTN_RECORD, m_btnRecord);
}

HTREEITEM CDlgTalkClient::finditem(HTREEITEM  item, CString strtext)
{
  HTREEITEM  hfind;
  //ֱӷNULL

  if (item == NULL)
    return  NULL;

  //
  while (item != NULL)
  {
    //ǰڵ㼴ҽڵ
    CString str1 = m_treeTalkDeviceList.GetItemText(item);
    int resultstr1 = str1.Find(strtext);
    if (m_treeTalkDeviceList.GetItemText(item).Find(strtext) >= 0)
      return   item;

    //ҵǰڵӽڵ
    if (m_treeTalkDeviceList.ItemHasChildren(item))
    {
      item = m_treeTalkDeviceList.GetChildItem(item);
      //ݹòӽڵ½ڵ
      hfind = finditem(item, strtext);
      if (hfind)
      {
        return  hfind;
      }
      else   //ӽڵδڵ㣬ֵܽڵ
        item = m_treeTalkDeviceList.GetNextSiblingItem(m_treeTalkDeviceList.GetParentItem(item));
    }
    else{   //ӽڵ㣬ֵܽڵ
      item = m_treeTalkDeviceList.GetNextSiblingItem(item);
    }
  }

  return item;
}

static int CALLBACK TreeCompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
  //ѸúԼĹ
  VzTreeCtrl* pmyTreeCtrl = (VzTreeCtrl*)lParamSort;
  int item1Weigth = 0, item2Weigth = 0;
  CString strItem1 = pmyTreeCtrl->GetItemText((HTREEITEM)lParam1);
  CString strItem2 = pmyTreeCtrl->GetItemText((HTREEITEM)lParam2);

  //ͨȨ+100
  if (-1 != strItem1.Find(ONPHONE_TEXT)){
    item1Weigth += 100;
  }
  if (-1 != strItem2.Find(ONPHONE_TEXT)){
    item2Weigth += 100;
  }

  //Ȩ+10
  if (-1 != strItem1.Find(CALLING_TEXT)){
    item1Weigth += 10;
  }
  if (-1 != strItem2.Find(CALLING_TEXT)){
    item2Weigth += 10;
  }

  //ַԱȨ+1
  int compareResult = strItem1.Compare(strItem2);
  item1Weigth += compareResult;

  if (item1Weigth < item2Weigth) return 1;
  else if (item1Weigth == item2Weigth) return 0;
  else if (item1Weigth > item2Weigth) return -1;

  return 0;
}


static void CALLBACK ServerRequestTalkCB(VzLPRClientHandle handle, int state, const char* error_msg, void* pUserData){
  CDlgTalkClient *pTC = (CDlgTalkClient *)pUserData;
  pTC->RequestTalk(handle);
}

void CDlgTalkClient::UpdateTree()
{
  TVSORTCB tvs;
  tvs.hParent = m_treeTalkDeviceList.GetRootItem();
  tvs.lpfnCompare = TreeCompareProc;
  tvs.lParam = (LPARAM)&m_treeTalkDeviceList;

  m_treeTalkDeviceList.SortChildrenCB(&tvs);
}

void CDlgTalkClient::AddOnPhtonText(CString &str)
{
  int str1len = str.GetLength();
  for (int i = str1len; i < 20; ++i)
  {
    str.Append("  ");
  }
  str.Append(ONPHONE_TEXT);
}

void CDlgTalkClient::AddCallingText(CString &str)
{
  int str1len = str.GetLength();
  for (int i = str1len; i < 20; ++i)
  {
    str.Append("  ");
  }
  str.Append(CALLING_TEXT);
}

void CDlgTalkClient::RemoveOnPhoneText(CString &str)
{
  str.Replace(ONPHONE_TEXT, _T(""));
  str.Remove(' ');
}

void CDlgTalkClient::RemoveCallingText(CString &str)
{
  str.Replace(CALLING_TEXT, _T(""));
  str.Remove(' ');
}

//int CDlgTalkClient::GetTalkServerStatus(CString strIP)
//{
//  int status = 0;
//  //VzLPRClient_GetTalkServerStatus(strIP, &status);
//  return status;
//}

int CDlgTalkClient::StartTalkByIP(CString strIP)
{
  HTREEITEM item = finditem(m_treeTalkDeviceList.GetRootItem(), strIP);
  return StartTalkByItem(item);
}

int CDlgTalkClient::StartTalkByItem(HTREEITEM item)
{
  //ȡipַ
  CString strIP = m_treeTalkDeviceList.GetItemText(item);
  RemoveOnPhoneText(strIP);
  RemoveCallingText(strIP);
  int treesize = m_rDev->size();
  m_ntalkHandle = m_treeTalkDeviceList.GetItemData(item);
  char IP[20];
  VzLPRClient_GetDeviceIP(m_ntalkHandle, IP, 20);
  int ret = VzLPRClient_StartTalk(m_ntalkHandle, 640);
  if (-2 == ret)
  {
    //æ
    m_ntalkHandle = 0;
    return ret;
  }
  else if( ret != 0)
  {
	  return ret;
  }

  CString str = m_treeTalkDeviceList.GetItemText(item);
  //ͨССַ
  RemoveOnPhoneText(str);
  RemoveCallingText(str);
  //ӡͨСʾ
  AddOnPhtonText(str);
  m_treeTalkDeviceList.SetItemText(item, str);
  UpdateTree();
  return ret;
  //todo
}

void CDlgTalkClient::StopTalkByIP(CString strIP)
{
  HTREEITEM item = finditem(m_treeTalkDeviceList.GetRootItem(), strIP);
  StopTalkByItem(item);
}

void CDlgTalkClient::StopTalkByItem(HTREEITEM item)
{
  CString str = m_treeTalkDeviceList.GetItemText(item);
  //ͨССַ
  RemoveOnPhoneText(str);
  RemoveCallingText(str);
  if (m_ntalkHandle)
  {
    VzLPRClient_StopTalk(m_ntalkHandle);
    m_ntalkHandle = 0;
  }
  m_treeTalkDeviceList.SetItemText(item, str);
  UpdateTree();
}

void CDlgTalkClient::StopTalk()
{
  HTREEITEM item = finditem(m_treeTalkDeviceList.GetRootItem(), ONPHONE_TEXT);
  StopTalkByItem(item);
  StopRecord();
}

bool CDlgTalkClient::IsItemOnPhone(HTREEITEM item)
{
  CString str = m_treeTalkDeviceList.GetItemText(item);
  int iLocation = str.Find(ONPHONE_TEXT);
  return (iLocation != -1) ? true : false;
}

bool CDlgTalkClient::IsItemCalling(HTREEITEM item)
{
  CString str = m_treeTalkDeviceList.GetItemText(item);
  int iLocation = str.Find(CALLING_TEXT);
  return (iLocation != -1) ? true : false;
}

std::string CDlgTalkClient::GetAppPath()
{
	std::string sAppPath;

	TCHAR tszModule[MAX_PATH + 1] = { 0 };
	::GetModuleFileName(NULL, tszModule, MAX_PATH);

	sAppPath.assign(tszModule);
	int pos = sAppPath.find_last_of('\\');
	sAppPath = sAppPath.substr(0, pos);

	return sAppPath;
}


void CDlgTalkClient::StartRecord()
{
  if (m_bRecording)
    return;
  //todo
  std::string record_path = GetAppPath() + "\\testrecord.wav";
  VzLPRClient_StartRecordAudio(m_ntalkHandle, record_path.c_str());
  m_recordTime = 0;
  RefreshRecordBtnText(_T("¼"));
  SetTimer(1, 1000, NULL);
  m_bRecording = true;
}

void CDlgTalkClient::StopRecord()
{
  if (!m_bRecording)
    return;
  //todo
  VzLPRClient_StopRecordAudio(m_ntalkHandle);
  m_recordTime = 0;
  KillTimer(1);
  RefreshRecordBtnText(_T("¼"));
  m_bRecording = false;
}

void CDlgTalkClient::RefreshRecordBtnText(CString str)
{
  m_btnRecord.SetWindowTextA(str);
}

void CDlgTalkClient::RequestTalk(VzLPRClientHandle handle)
{
  char IP[20];
  if (!VzLPRClient_GetDeviceIP(handle, IP, 20)){
    HTREEITEM item = finditem(m_treeTalkDeviceList.GetRootItem(), IP);
    if (!IsItemOnPhone(item)&&!IsItemCalling(item))
    {
      CString sIP = IP;
      EnterCriticalSection(&m_csRequestIP);
      m_RequestIP.push_back(sIP);
      LeaveCriticalSection(&m_csRequestIP);
      AddCallingText(sIP);
      m_treeTalkDeviceList.SetItemText(item, sIP);
      UpdateTree();
      m_treeTalkDeviceList.SelectItem(item);
      if (!m_ntalkHandle)
      {
        SetTimer(2, 3000, NULL);
        //̲
        PostMessage(WM_TIMER, 2, NULL);
      }
      SetTimer(3, 16000, NULL);
    }
  }
}

void CDlgTalkClient::StopRequestTalk(){
  EnterCriticalSection(&m_csRequestIP);
  if (m_RequestIP.size() > 0)
  {
    CString sIP = m_RequestIP.front();
    m_RequestIP.pop_front();
    HTREEITEM item = finditem(m_treeTalkDeviceList.GetRootItem(), sIP);
    if (item)
    {
      if (m_treeTalkDeviceList.GetItemData(item) != m_ntalkHandle)
      {
        m_treeTalkDeviceList.SetItemText(item, sIP);
        UpdateTree();
      }
    }
    if (m_RequestIP.size() <= 0)
    {
      KillTimer(2);
      KillTimer(3);
    }
  }
  LeaveCriticalSection(&m_csRequestIP);

}

BEGIN_MESSAGE_MAP(CDlgTalkClient, CDialog)
  ON_BN_CLICKED(IDC_BTN_RECIVE, &CDlgTalkClient::OnBnClickedBtnRecive)
  ON_BN_CLICKED(IDC_BTN_CLOSE, &CDlgTalkClient::OnBnClickedBtnClose)
  ON_BN_CLICKED(IDC_BTN_RECORD, &CDlgTalkClient::OnBnClickedBtnRecord)
  ON_NOTIFY(TVN_SELCHANGED, IDC_TALK_TREE_DEVICE, &CDlgTalkClient::OnSelchangedTalkTreeDevice)
  ON_WM_TIMER()
  ON_WM_CLOSE()
END_MESSAGE_MAP()


// CDlgTalkClient Ϣ

static void iImageListLoadIDB(int IDB_, CImageList *pImgList)
{
  CBitmap bitmap;
  bitmap.LoadBitmap(IDB_);
  pImgList->Add(&bitmap, RGB(0, 0, 0));
}

void CDlgTalkClient::OnBnClickedBtnRecive()
{
  // TODO:  ڴӿؼ֪ͨ
  //״̬
  m_btnStartTalk.EnableWindow(FALSE);
  KillTimer(2);
  HTREEITEM item = m_treeTalkDeviceList.GetSelectedItem();
  int ret = StartTalkByItem(item);
  if( ret == 0 )
  {
	  m_btnStopTalk.EnableWindow(TRUE);
	  m_btnRecord.EnableWindow(TRUE);
  }
  else
  {
	  CString strMsg;
	  strMsg.Format("ʼԽʧ,ֵ:%d", ret);
	  MessageBox(strMsg);
  
	  m_btnStartTalk.EnableWindow(TRUE);
  }
}


void CDlgTalkClient::OnBnClickedBtnClose()
{
  // TODO:  ڴӿؼ֪ͨ
  m_btnStopTalk.EnableWindow(FALSE);
  m_btnRecord.EnableWindow(FALSE);
  HTREEITEM item = m_treeTalkDeviceList.GetSelectedItem();
  StopTalk();
  m_btnStartTalk.EnableWindow(TRUE);
}

void CDlgTalkClient::OnBnClickedBtnRecord()
{
  // TODO:  ڴӿؼ֪ͨ
  if (m_bRecording)
  {
    StopRecord();
  }
  else {
    StartRecord();
  }
}


BOOL CDlgTalkClient::OnInitDialog()
{
  CDialog::OnInitDialog();

  InitializeCriticalSection(&m_csRequestIP);
  // TODO:  ڴӶĳʼ
  //Ϊm_treeDeviceListͼб
  m_pImageList = new CImageList();
  m_pImageList->Create(16, 16, ILC_COLOR32, 0, 2);
  iImageListLoadIDB(IDB_BMP_ONLINE, m_pImageList);
  iImageListLoadIDB(IDB_BMP_ONLINE, m_pImageList);
  m_treeTalkDeviceList.SetImageList(m_pImageList, TVSIL_NORMAL);
  int treesize = m_rDev->size();
  if (treesize == 0)
  {
    m_btnStartTalk.EnableWindow(FALSE);
  }
  for (int i = 0; i < treesize; i++)
  {
    DeviceLPR *pDeviceLPR = (*m_rDev)[i];

	std::string device_info = pDeviceLPR->strIP;
	if(pDeviceLPR->device_sn != "")
	{
		device_info += "(" + pDeviceLPR->device_sn + ")";
	}
	
    //ظip
    if (NULL != finditem(m_treeTalkDeviceList.GetRootItem(), device_info.c_str()))
    {
      continue;
    }
    HTREEITEM hItem = m_treeTalkDeviceList.InsertItem(device_info.c_str(), 0, 1);
    m_treeTalkDeviceList.SetItemData(hItem, (DWORD)pDeviceLPR->hLPRClient);
    //m_treeTalkDeviceList.SetItemData(hItem, pDeviceLPR->hLPRClient);//ָڴ򿪵ľ
    m_treeTalkDeviceList.SelectItem(hItem);//ѡضSelectItem
    VzLPRClient_SetRequestTalkCallBack(pDeviceLPR->hLPRClient, ServerRequestTalkCB, this);
    CString strItem1 = m_treeTalkDeviceList.GetItemText(hItem);
  }
  UpdateTree();
  return TRUE;  // return TRUE unless you set the focus to a control
  // 쳣:  OCX ҳӦ FALSE
}



void CDlgTalkClient::OnSelchangedTalkTreeDevice(NMHDR *pNMHDR, LRESULT *pResult)
{
  LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
  // TODO:  ڴӿؼ֪ͨ
  //if (IsItemOnPhone(pNMTreeView->itemNew.hItem))
  //{
  //  m_btnStartTalk.EnableWindow(FALSE);
  //  m_btnStopTalk.EnableWindow(TRUE);
  //  m_btnRecord.EnableWindow(TRUE);
  //}
  //else if (IsItemCalling(pNMTreeView->itemNew.hItem))
  //{
  //  m_btnStartTalk.EnableWindow(TRUE);
  //  m_btnStartTalk.SetWindowTextA(_T(""));
  //  m_btnStopTalk.EnableWindow(FALSE);
  //  m_btnRecord.EnableWindow(FALSE);
  //}
  //else{
  //  m_btnStartTalk.EnableWindow(TRUE);
  //  m_btnStartTalk.SetWindowTextA(_T(""));
  //  m_btnStopTalk.EnableWindow(FALSE);
  //  m_btnRecord.EnableWindow(FALSE);
  //}
  *pResult = 0;
}


void CDlgTalkClient::OnTimer(UINT_PTR nIDEvent)
{
  // TODO:  ڴϢ/Ĭֵ
  CString strrecord;
  switch (nIDEvent)
  {
  case 1:
    m_recordTime += 1;
    if (m_recordTime / 3600 == 0)
      strrecord.Format(_T("¼\n%2.2d:%2.2d"), m_recordTime / 60, m_recordTime % 60);
    else
      strrecord.Format(_T("¼\n%2.2d:%2.2d:%2.2d"), m_recordTime / 3600, m_recordTime / 60, m_recordTime % 60);
    RefreshRecordBtnText(strrecord);
    break;

  case 2:
	  if(m_btnStartTalk.IsWindowEnabled())
	  {
		sndPlaySound("testring.wav", SND_ASYNC);
	  }
    break;

  case 3:
    StopRequestTalk();
    break;

  default:
    break;
  }
  CDialog::OnTimer(nIDEvent);
}


void CDlgTalkClient::OnClose()
{
	int treesize = m_rDev->size();

  // TODO:  ڴϢ/Ĭֵ
	for (int i = 0; i < treesize; i++)
	{
		DeviceLPR *pDeviceLPR = (*m_rDev)[i];
		if ( pDeviceLPR != NULL)
		{
			VzLPRClient_SetRequestTalkCallBack(pDeviceLPR->hLPRClient, NULL, NULL);
		}
	}

  StopTalk();
  

  EnterCriticalSection(&m_csRequestIP);
  DeleteCriticalSection(&m_csRequestIP);
  CDialog::OnClose();
}
