#pragma once
#include "afxcmn.h"
#include "VzTreeCtrl.h"
#include "VzDeviceLPR.h"
#include <VzLPRClientSDK.h>

#include <vector>
#include <list>
#include <string>
#include "resource.h"
#include "afxwin.h"

using namespace std;

// CDlgTalkClient Ի

class CDlgTalkClient : public CDialog
{
	DECLARE_DYNAMIC(CDlgTalkClient)

public:
	CDlgTalkClient(CWnd* pParent = NULL);   // ׼캯
  virtual ~CDlgTalkClient();
  void InitTreeData(vector <DeviceLPR *> *treedata);

// Ի
	enum { IDD = IDD_DLG_TALK };

protected:
  bool m_bRecording;
  int m_recordTime;

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧
  HTREEITEM CDlgTalkClient::finditem(HTREEITEM  item, CString strtext);
  void UpdateTree();
  void AddOnPhtonText(CString &str);      // ַм롰ͨС
  void AddCallingText(CString &str);      // ַм롰С
  void RemoveOnPhoneText(CString &str);   // ɾַеġͨС
  void RemoveCallingText(CString &str);   // ɾַеġС

//  int GetTalkServerStatus(CString strIP);

  int StartTalkByIP(CString strIP);
  int StartTalkByItem(HTREEITEM item);

  void StopTalkByIP(CString strIP);
  void StopTalkByItem(HTREEITEM item);
  void StopTalk();

  bool IsItemOnPhone(HTREEITEM item);     //ͨ
  bool IsItemCalling(HTREEITEM item);     //ڱ

  void StartRecord();
  void StopRecord();
  void RefreshRecordBtnText(CString str);

  void StopRequestTalk();

  std::string GetAppPath();


  CImageList *m_pImageList;
  vector <DeviceLPR *> *m_rDev;
  list <CString> m_RequestIP;
  CRITICAL_SECTION m_csRequestIP; //֤IPݰȫ
	DECLARE_MESSAGE_MAP()
public:
  afx_msg void OnBnClickedBtnRecive();
  afx_msg void OnBnClickedBtnClose();
  afx_msg void OnBnClickedBtnRecord();
  VzTreeCtrl m_treeTalkDeviceList;
  virtual BOOL OnInitDialog();
  void RequestTalk(VzLPRClientHandle handle);

  VzLPRClientHandle m_ntalkHandle;

  CButton m_btnStartTalk;
  CButton m_btnStopTalk;
  CButton m_btnRecord;
  afx_msg void OnSelchangedTalkTreeDevice(NMHDR *pNMHDR, LRESULT *pResult);
  afx_msg void OnTimer(UINT_PTR nIDEvent);
  afx_msg void OnClose();
};
