#ifndef _VZ_CLIENT_SDK_FACE_DEFINE_H_
#define _VZ_CLIENT_SDK_FACE_DEFINE_H_
#include <VzClientSDK_CommonDefine.h>

// һͼƬ
#define MAX_FACE_COUNT 108

/**Ϣ*/
typedef struct tagTH_FaceRect
{
	unsigned short left;	// 
	unsigned short top;		// 
	unsigned short right;	// 
	unsigned short bottom;	// 
}TH_FaceRect;

typedef struct tagTH_FaceImg
{
	char imt_type[12];		// ͼ 磺bmp,jpg,jpeg
	unsigned char* img_buf; // ͼbuf
	unsigned int img_len;	// ͼ񳤶
}TH_FaceImg;

typedef struct tagTH_FaceItem
{
	unsigned int face_id;		// ID
	short confidence;			// Ŷ
	short eye_dist;				// ͫ
	short yaw;					// ˮƽתǣʵ[-180.0, 180.0]
	short pitch;				// ǣʵϸ[-180.0, 180.0]
	short roll;					// תǣʵ[-180.0, 180.0]
	TH_FaceRect face_rect; 		// 
}TH_FaceItem;

// ץĽϢ
typedef struct tagTH_FaceResult 
{
	unsigned char trigger;  					// ͣ1Զץģ2ֶץ
	char datetime[20];							// ʱ䣬ʽyyyy-MM-dd HH:mm:ss
	unsigned int msec;							// ʱ
	unsigned char num;							// 
	TH_FaceItem face_items[MAX_FACE_COUNT];     // Ϣ
	TH_FaceImg face_imgs[MAX_FACE_COUNT];		// ͼ
	TH_FaceImg snap_img;						// ȫͼͼ
	char serialno[32];							// 豸к
	unsigned char person_num;					// 
	unsigned char sex;							// 0:У1:Ů2:δ֪
	unsigned char age;							// 1: 2: 3: 4:꣬5:δ֪
	unsigned char have_hat;                     // 0:û1:У2:δ֪
	unsigned char have_glasses;                 // 0:û1:У2:δ֪
	unsigned char have_mask;                    // 0:û1:У2:δ֪
	char reserved[122];							// 
}TH_FaceResult;

// ץĹ
#define MAX_POLYGON_PT_COUNT 10
#define MAX_RULE_POLYGON_COUNT 1
typedef struct tagTH_FacePoint
{
	unsigned short x;
	unsigned short y;
}TH_FacePoint;

typedef struct tagTH_FacePolygon
{
	unsigned char id;
	unsigned char enable;
	unsigned char point_num;
	TH_FacePoint  polygon_points[MAX_POLYGON_PT_COUNT];
}TH_FacePolygon;

typedef struct tagTH_FaceRuleArea
{
	unsigned char polygon_num; // ʶ
	TH_FacePolygon area_polygons[MAX_RULE_POLYGON_COUNT];
}TH_FaceRuleArea;

// ι
#define MAX_SHIELD_POLYGON_COUNT 4
typedef struct tagTH_FaceShieldArea
{
	unsigned char polygon_num; // 
	TH_FacePolygon area_polygons[MAX_SHIELD_POLYGON_COUNT];
}TH_FaceShieldArea;


// SDϢ
typedef struct tagTH_FaceSDInfo
{
	int sector_size;		// 豸С
	int state;				// 豸״̬5. 8.쳣
	long long used;			// λֽڣ豸ʹôС
	long long total_size;	// λֽڣ豸ܴС⣩
}TH_FaceSDInfo;

// Ƶ
typedef struct tagTH_FaceVideoParam
{
	short brightness;		// ȣĬֵ50
	short contrast;			// ԱȶȣĬֵ50
	short saturation;		// ͶȣĬֵ50
	short sharpness;		// ȣĬֵ50
	short max_gain;			// 棬Ĭֵ50
	short max_exposure;		// عʱ
	short flip;				// ͼת0ԭʼͼ1·ת2ҷת3ķתĬֵ0
}TH_FaceVideoParam;

#define MAX_FACE_TIME_LEN 16

typedef struct tagTH_FaceDaynightParam
{
	short daynight_type;			// ҹת0ҹ䣬1ʱл2죬3Զ4봥
	short distance_level;			// ȼĬֵ50
	short sensitivity;				// ԶתȣĬֵ3
	short filter_time;				// ԶתĹʱ䣬Ĭֵ60
	char begin_time[MAX_FACE_TIME_LEN];	// ʱлĿʼʱ䣬ʽHH:mm:ssĬֵ07:00:00
	char end_time[MAX_FACE_TIME_LEN];	// ʱлĽʱ䣬ʽHH:mm:ssĬֵ18:00:00
	short alarm_status;				// ״̬0죬1ҹĬֵ1
}TH_FaceDaynightParam;

typedef struct tagTH_FaceVideoDaynightParam
{
	TH_FaceVideoParam video_param;			// Ƶ
	TH_FaceDaynightParam daynight_param;	// ҹת
}TH_FaceVideoDaynightParam;

// Աͳƹ
#define MAX_FLOW_POINT_COUNT 8
typedef struct tagTH_FaceFlowStatistic
{
	unsigned char is_open;     // ǷԱͳ
	unsigned char is_area1;    // Ƿ1Աͳ
	unsigned char is_area2;    // Ƿ2Աͳ
	unsigned char point_count; // ĸ
	TH_FacePoint points[MAX_FLOW_POINT_COUNT];

}TH_FaceFlowStatistic;

typedef struct tagTH_FaceCvbsParam
{
	int cvbs;             // 1 0:
	int cvbs_signal_sys;  // ģʽ 0PAL, 1:NTSC
}TH_FaceCvbsParam;
#endif