/*
* vzsdk
* Copyright 2013 - 2016, Vzenith Inc.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*  1. Redistributions of source code must retain the above copyright notice,
*     this list of conditions and the following disclaimer.
*  2. Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions and the following disclaimer in the documentation
*     and/or other materials provided with the distribution.
*  3. The name of the author may not be used to endorse or promote products
*     derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
* EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
* OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
* WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
* ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
#ifndef _VZ_LPRC_TCP_SDK_H_
#define _VZ_LPRC_TCP_SDK_H_
#include "vzsdk/vzlprtcpsdkdefine.h"

#ifdef WIN32
#ifdef _DEV_API_
#define VZ_LPRC_TCP_API __declspec(dllexport)
#else
#define VZ_LPRC_TCP_API __declspec(dllimport)
#endif

#define __STDCALL __stdcall
#else
#define	VZ_LPRC_TCP_API
#define __STDCALL
#endif

#ifdef __cplusplus
extern "C"
{
#endif

/**
* @defgroup group_global ȫֲ
* @defgroup group_device 豸
* @defgroup group_callback ص
*/

/**
*  @brief ȫֳʼ
*  @return 0ʾɹ-1ʾʧ
*  @note нӿڵ֮ǰ
*  @ingroup group_global
*/
extern "C"  int __STDCALL VzLPRTcp_Setup();

/**
*  @brief ȫͷ
*  @note ڳʱãͷSDKԴ
*  @ingroup group_global
*/
VZ_LPRC_TCP_API void __STDCALL VzLPRTcp_Cleanup();

/**
*  @brief һ豸
*  @param  [IN] pStrIP 豸IPַ
*  @param  [IN] wPort 豸Ķ˿ں
*  @param  [IN] pStrUserName 豸û
*  @param  [IN] pStrPassword 豸
*  @return 豸Ĳʧʱ0
*  @ingroup group_device
*/
VZ_LPRC_TCP_API VzLPRTcpHandle __STDCALL VzLPRTcp_Open(const char *pStrIP, WORD wPort, const char *pStrUserName, const char *pStrPassword);

/**
*  @brief رһ豸
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @return 0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_Close(VzLPRTcpHandle handle);

/**
*  @brief ͨIPַرһ豸
*  @param  [IN] pStrIP 豸IPַ
*  @return 0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_CloseByIP(const char *pStrIP);

/**
*  @brief ȡ豸к
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [OUT] pSN 豸к
*  @return 0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_GetDeviceSN(VzLPRTcpHandle handle, char* pSN);

/**
*  @brief ȡ״̬
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN/OUT] pStatus ȡ״̬ıַΪ 1ϣ0δ
*  @return 0ʾɹ-1ʾʧ
*  @note   ûڵøúѯ豸ǷߣԼߺǷָ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_IsConnected(VzLPRTcpHandle handle, BYTE *pStatus);

/**
*  @brief ͨûصóʶϢ
*  @param  [OUT] handle			VzLPRTcp_Openõľ
*  @param  [OUT] pUserData		ص
*  @param  [OUT] pResult		Ϣ׵ַṹ嶨 TH_PlateResult
*  @param  [OUT] uNumPlates		еĳƸ
*  @param  [OUT] eResultType	ʶͣöͶVZ_LPRC_RESULT_TYPE
*  @param  [OUT] pImgFull		ǰ֡ͼ׵ַ
*  @param  [OUT] nFullSize		ͼڴеĴС
*  @param  [OUT] pImgPlateClip	ǰ֡гͼ
*  @param  [OUT] nClipSize		ͼڴеĴС
*  @return 0ʾɹ-1ʾʧ
*  @note   Ҫûصؽͼ pImgFull pImgPlateClipҪûصVzLPRTcp_SetPlateInfoCallBackʱͼݣûصصָΪգ
*  @ingroup group_callback
*/
typedef int (__STDCALL *VZLPRC_TCP_PLATE_INFO_CALLBACK)(VzLPRTcpHandle handle, void *pUserData,
        const TH_PlateResult *pResult, unsigned uNumPlates,
        VZ_LPRC_RESULT_TYPE eResultType,
        unsigned char *pImgFull, int nFullSize,
        unsigned char *pImgPlateClip, int nClipSize);

/**
*  @brief ʶĻص
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] func ʶصΪNULLʾرոûصĹ
*  @param  [IN] pUserData صе
*  @param  [IN] bEnableImage ָʶĻصǷҪͼϢ1ΪҪ0ΪҪ
*  @return 0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SetPlateInfoCallBack(VzLPRTcpHandle handle, VZLPRC_TCP_PLATE_INFO_CALLBACK func, void *pUserData, int bEnableImage);


/**
*  @brief ͼ񱣴ΪJPEGָ·
*  @param  [IN] pImgBuf  ͼڴ׵ַ
*  @param  [IN] nImgSize ͼڴС
*  @param  [IN] pSavePathName ·JPG׺ļַ
*  @param  [IN] nQualityԤ JPEGѹȡֵΧ1~100
*  @return 0ʾɹ-1ʾʧ
*  @note   ļе·Ҫ
*  @ingroup group_global
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_ImageSaveToJpeg(unsigned char *pImgBuf, int nImgSize, const char *pSavePathName, int nQuality);

/**
*  @brief ͨûص͸ͨյ
*  @param  [IN] nSerialHandle VzLPRTcp_SerialStartصľ
*  @param  [IN] pRecvData	յݵ׵ַ
*  @param  [IN] uRecvSize	յݵĳߴ
*  @param  [IN] pUserData	ص
*  @ingroup group_callback
*/
typedef void (__STDCALL *VZDEV_TCP_SERIAL_RECV_DATA_CALLBACK)(int nSerialHandle, const unsigned char *pRecvData, unsigned uRecvSize, void *pUserData);

/**
*  @brief ͸ͨ
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] nSerialPort ָʹ豸Ĵţ0ʾһڣ1ʾڶ
*  @param  [IN] func ݵĻص
*  @param  [IN] pUserData ݻص
*  @return 0ʾɹֵʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SerialStart(VzLPRTcpHandle handle, int nSerialPort,
        VZDEV_TCP_SERIAL_RECV_DATA_CALLBACK func, void *pUserData);
/**
*  @brief ͸ͨ
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] nSerialPort ָʹ豸Ĵţ0ʾһڣ1ʾڶ
*  @param [IN] pData Ҫݿ׵ַ
*  @param [IN] uSizeData Ҫݿֽ
*  @return 0ʾɹֵʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SerialSend(VzLPRTcpHandle handle, int nSerialPort, const unsigned char *pData, unsigned uSizeData);

/**
*  @brief ͸ֹͨͣ
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @return 0ʾɹֵʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SerialStop(VzLPRTcpHandle handle);

/**
*  @brief IOԶλ
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] uChnId IOͨţ0ʼ
*  @param  [IN] nDuration ʱʱ䣬ȡֵΧ[500, 5000]
*  @return 0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SetIOOutputAuto(VzLPRTcpHandle handle, unsigned uChnId, int nDuration);


/**
*  @brief IO״̬
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] uChnId IOͨţ0ʼ
*  @param  [OUT] nOutput ҪõIO״̬0ʾ̵·1ʾ̵·
*  @return 0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SetIOOutput(VzLPRTcpHandle handle, unsigned uChnId, int nOutput);

/**
*  @brief ͨûص豸һ״̬Ϣ
*  @param  [IN] handle		VzLPRTcp_Openõľ
*  @param  [IN] pUserData	ص
*  @param  [IN] eNotify		ͨϢ
*  @param  [IN] pStrDetail	ϸַ
*  @ingroup group_callback
*/
typedef void (__STDCALL *VZLPRC_TCP_COMMON_NOTIFY_CALLBACK)(VzLPRTcpHandle handle
        , void *pUserData
        , VZ_LPRC_COMMON_NOTIFY eNotify
        , const char *pStrDetail);

/**
*  @brief 豸ӷصĻص
*  @param  [IN] func 豸ӽ״̬ͨûص
*  @param  [IN] pUserData صе
*  @return 0ʾɹ-1ʾʧ
*  @ingroup group_global
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SetCommonNotifyCallBack(VZLPRC_TCP_COMMON_NOTIFY_CALLBACK func, void *pUserData);

/**
*  @brief IDȡͼƬ
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] id     Ƽ¼ID
*  @param  [IN] pdata  洢ͼƬڴ
*  @param  [IN][OUT] size Ϊ봫ֵΪͼƬڴĴСصǻȡjpgͼƬڴĴС
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_LoadImageById(VzLPRTcpHandle handle, int id, void *pdata, int* size);

/**
*  @brief ȡGPIO״̬
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] gpioIn Ϊ01
*  @param  [OUT] value 0·1·
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_GetGPIOValue(VzLPRTcpHandle handle, int gpioIn, int *value);

/**
*  @brief ѻ飬ʵѻԶлĹܡ
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] pUserData ݻص
*  @note   Чǰ᣺豸ġҳġ֤TABҳеġΪѻԶá
*  @note   øýӿڣ豸øýӿڵĿͻ֮ͻγɰ󶨣ͻ豸֮ô豸ϵİΪͣ״̬IOźſƵբ̧˺485Э飻
*  @note   ͻ豸豸֮ˣ߿ͻ˹رգߵ˹رѻ飨CancelOfflineCheckӿڣô豸ϵİã豸ݰƵբ̧˺485Э飻
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SetOfflineCheck(VzLPRTcpHandle handle);

/**
*  @brief رѻ
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] pUserData ݻص
*  @note   Чǰ᣺豸ġҳġ֤TABҳеġΪѻԶá
*  @note   رѻ飬豸ڰIOźſƵբ̧˺485Э顣
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_CancelOfflineCheck(VzLPRTcpHandle handle);

/**
*  @brief źţǿƴǰʱ̵ݲ
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @return 0ʾɹ-1ʾʧ
*  @note   ʶͨصķʽأǰƵ޳ƣصᱻ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_ForceTrigger(VzLPRTcpHandle handle);

/**
* @brief ȡ LastError
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_GetLastError( );


/**
*  @brief IDȡƼ¼
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] id     Ƽ¼ID
*  @param  [IN] pResultƼ¼
*  @return 0ʾɹ-1ʾʧ
*  @note   ʶͨصķʽأǰƵ޳ƣصᱻ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_LoadRecordById(VzLPRTcpHandle handle, int id, TH_PlateResult *pResult);

/**
*  @brief ȡ豸IP
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @return 豸IP
*  @ingroup group_device
*/
VZ_LPRC_TCP_API const char* __STDCALL VzLPRTcp_GetIP(VzLPRTcpHandle handle);

/**
*  @brief һ¼
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] pLprWlistVehicle ¼
*  @return 0ʾɹ-1ʾʧ
*  @note   ¼Ѿڣ¡ڣӵݿС
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_ImportWlistVehicle(VzLPRTcpHandle handle, VZ_LPR_WLIST_VEHICLE *pWlist);

/**
*  @brief ݳƺɾ
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] plateCode ƺ
*  @return 0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_DeleteWlistVehicle(VzLPRTcpHandle handle, const char* plateCode);

/**
*  @brief ݳƺŲѯ
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] plateCode ƺ
*  @return 0ʾɹ-1ʾʧ
*  @note   ͨصƺΪգеİ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_QueryWlistVehicle(VzLPRTcpHandle handle, const char* plateCode);

/**
*  @brief ͨûصðѯ
*  @param  [IN] handle			VzLPRTcp_Openõľ
*  @param  [IN] pUserData		ص
*  @param  [IN] pWlist			׵ַṹ嶨 VZ_LPR_WLIST_VEHICLE
*  @param  [IN] uCount			еĳƸ
*  @return 0ʾɹ-1ʾʧ
*  @ingroup group_callback
*/
typedef int (__STDCALL *VZLPRC_TCP_WLIST_RECV_CALLBACK)(VzLPRTcpHandle handle, void *pUserData,
        const VZ_LPR_WLIST_VEHICLE *pWlist, unsigned uCount);

/**
*  @brief ðĻص
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] func صΪNULLʾرոûصĹ
*  @param  [IN] pUserData صе
*  @return 0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SetWlistInfoCallBack(VzLPRTcpHandle handle, VZLPRC_TCP_WLIST_RECV_CALLBACK func, void *pUserData);


/***********************************************************************
@brief GPIOص
@param [IN] nGPIOId GPIOID
@param [IN] nVal  GPIOֵ
@param [IN] pUserData ûԶ
@return 
***********************************************************************/
typedef void (__STDCALL *VZLPRC_GPIO_RECV_CALLBACK)(VzLPRTcpHandle handle, int nGPIOId, int nVal, void* pUserData);

/**
*  @brief GPIOص
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [IN] func GPIOص
*  @param  [IN] pUserData ûԶ
*  @return  ֵΪ0ʾɹ-1ʾʧ
*/
VZ_LPRC_TCP_API  int __STDCALL VzLPRTcp_SetReciveGpioCallback(VzLPRTcpHandle handle, VZLPRC_GPIO_RECV_CALLBACK func, void* pUserData);

/**
*  @brief ץͼ
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [OUT] imgBufferͼƬBUF
*  @param  [IN] ͼƬBUFĳ
*  @return  ֵ-1ʾʧ,ʾصͼƬֽ
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_GetSnapImageData(VzLPRTcpHandle handle, char * imgBuffer, int imgBufferMaxLength);

/**
*  @brief ȡƵַ
*  @param  [IN] handle VzLPRTcp_Openõľ
*  @param  [OUT] urlƵַ
*  @param  [IN] urlMaxLength Ƶbufĳ
*  @return  ֵΪ0ʾɹ-1ʾʧ
*/
VZ_LPRC_TCP_API  int __STDCALL VzLPRTcp_GetRtspUrl(VzLPRTcpHandle handle, char *url, int urlMaxLength);


/**
*  @brief Ź
*  @param [IN] handle VzLPRTcp_Openõľ
*  @param [IN] voice ŵ
*  @param [IN] voice_len ֵĳ
*  @param [IN] interval ļĲż(0-5000)
*  @param [IN] volume С(0-100)
*  @param [IN] male (0Ů1)
*  @return ֵΪ0ʾɹֵʾʧܡ
*/
VZ_LPRC_TCP_API  int __STDCALL VzLPRTcp_PlayVoice(VzLPRTcpHandle handle, const char *voice, int voice_len, int interval, int volume, int male);


/**
*  @brief ȡ豸ʱ
*  @param [IN] handle VzLPRTcp_Openõľ
*  @param [OUT] pDTInfo ڴŻȡ豸ʱϢ VZ_DATE_TIME_INFO
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_GetDateTime(VzLPRTcpHandle handle, VZ_DATE_TIME_INFO *pDTInfo);

/**
*  @brief 豸ʱ
*  @param [IN] handle VzLPRTcp_Openõľ
*  @param [IN] pDTInfo Ҫõ豸ʱϢ VZ_DATE_TIME_INFO
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SetDateTime(VzLPRTcpHandle handle, const VZ_DATE_TIME_INFO *pDTInfo);

/**
*  @brief ȡȦ
*  @param [IN] handle VzLPRTcp_Openõľ
*  @param [OUT] pVirtualLoops ȦϢ VZ_LPRC_VIRTUAL_LOOPS
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_GetVirtulLoop(VzLPRTcpHandle handle, VZ_LPRC_VIRTUAL_LOOPS *pVirtualLoops);

/**
*  @brief Ȧ
*  @param [IN] handle VzLPRTcp_Openõľ
*  @param [IN] pVirtualLoops ȦϢ VZ_LPRC_VIRTUAL_LOOPS
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SetVirtulLoop(VzLPRTcpHandle handle, const VZ_LPRC_VIRTUAL_LOOPS *pVirtualLoops);

/**
*  @brief ȡʶ
*  @param [IN] handle VzLPRTcp_Openõľ
*  @param [OUT] pROI ʶ VZ_LPRC_ROI
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_GetRegionOfInterest(VzLPRTcpHandle handle, VZ_LPRC_ROI * pROI);

/**
*  @brief ʶ
*  @param [IN] handle VzLPRTcp_Openõľ
*  @param [IN] pROI ʶ VZ_LPRC_ROI
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SetRegionOfInterest(VzLPRTcpHandle handle, const VZ_LPRC_ROI * pROI);

/**
*  @brief 
*  @param [IN] handle VzLPRTcp_Openõľ
*  @param [IN] pNetParam  VZ_LPRC_NETCFG
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SetNetworkParam(VzLPRTcpHandle handle, const VZ_LPRC_NETCFG * pNetParam);

/**
*  @brief ȡ
*  @param [IN] handle VzLPRTcp_Openõľ
*  @param [OUT] pNetParam  VZ_LPRC_NETCFG
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_GetNetworkParam(VzLPRTcpHandle handle, VZ_LPRC_NETCFG * pNetParam);

/**
*  @brief Զ䱶۽
*  @param [IN] handle VzLPRTcp_Openõľ
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_AutoFocus(VzLPRTcpHandle handle);

/**
*  @brief 䱶۽
*  @param [IN] handle VzLPRTcp_Openõľ
*  @param [IN] value ͣ VZ_LENS_OPT
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_CtrlLens(VzLPRTcpHandle handle, int value);

/**
*  @brief ȡ㷨ʶ
*  @param [IN] handle VzLPRTcp_Openõľ
*  @param [OUT] param 㷨ʶ
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_GetAlgResultParam(VzLPRTcpHandle handle, VZ_ALG_RESULT_PARAM * param);

/**
*  @brief 㷨ʶ
*  @param [IN] handle VzLPRTcp_Openõľ
*  @param [IN] param 㷨ʶ
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SetAlgResultParam(VzLPRTcpHandle handle, const VZ_ALG_RESULT_PARAM * param);

/**
*  @brief LED
*  @param [IN] handle VzLPRTcp_Openõľ
*  @param [IN] param LED
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SetLedParam(VzLPRTcpHandle handle, const VZ_LED_PARAM * param);

/**
*  @brief ȡLED
*  @param [IN] handle VzLPRTcp_Openõľ
*  @param [OUT] param LED
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_GetLedParam(VzLPRTcpHandle handle, VZ_LED_PARAM* param);

/**
*  @brief ȫָĬ
*  @param [IN] handle  VzLPRTcp_Open nõľ
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_RestoreConfig(VzLPRTcpHandle handle);

/**
*  @brief ָֻĬ
*  @param [IN] handle  VzLPRTcp_Open õľ
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_RestoreConfigPartly(VzLPRTcpHandle handle);

/**
*  @brief дû˽ݣڶμ
*  @param [IN] handle  VzLPRTcp_Open õľ
*  @param [IN] pUserData û
*  @param [IN] uSizeData ûݵĳȣ128ֽ
*  @return ֵΪ0ʾɹֵʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_WriteUserData(VzLPRTcpHandle handle, const unsigned char *pUserData, unsigned uSizeData);


/**
*  @brief û˽ݣڶμ
*  @param [IN] handle  VzLPRTcp_Open õľ
*  @param [IN/OUT] pBuffer ڴŶû
*  @param [IN] uSizeBuf ûݻСߴ磬С128ֽ
*  @return ֵΪʵûݵֽ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_ReadUserData(VzLPRTcpHandle handle, unsigned char *pBuffer, unsigned uSizeBuf);


/**
*  @brief ȡ豸Ĵ洢Ϣ
*  @param [IN] handle VzLPRClient_Openõľ
*  @param [IN/OUT] pSDInfo ڴŻȡ洢豸Ϣ VZ_STORAGE_DEVICES_INFO
*  @return ֵΪ0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_GetStorageDeviceInfo(VzLPRTcpHandle handle, VZ_STORAGE_DEVICES_INFO *pSDInfo);


/**
*  @brief ȡڲ
*  @param  [IN] handle  VzLPRTcp_Open õľ
*  @param  [IN] nSerialPort ָʹ豸Ĵţ0ʾһڣ1ʾڶ
*  @param  [OUT] pParameter ҪȡĴڲ VZ_SERIAL_PARAMETER
*  @return 0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_GetSerialParameter(VzLPRTcpHandle handle, int nSerialPort, VZ_SERIAL_PARAMETER *pParameter);


/**
*  @brief ôڲ
*  @param  [IN] handle   VzLPRTcp_Open õľ
*  @param  [IN] nSerialPort ָʹ豸Ĵţ0ʾһڣ1ʾڶ
*  @param  [IN] pParameter ҪõĴڲ VZ_SERIAL_PARAMETER
*  @return 0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_SetSerialParameter(VzLPRTcpHandle handle, int nSerialPort, const VZ_SERIAL_PARAMETER *pParameter);


/**
*  @brief ȡIO״̬
*  @param  [IN] handle   VzLPRTcp_Open õľ
*  @param  [IN] uChnId IOͨţ0ʼ
*  @param  [OUT] pOutput IO״̬0ʾ̵·1ʾ̵·
*  @return 0ʾɹ-1ʾʧ
*  @ingroup group_device
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_GetIOOutput(VzLPRTcpHandle handle, unsigned uChnId, int *pOutput);


/**
*  @brief ޸
*  @param  [IN] SL        豸кŵλֽ
*  @param  [IN] SH		  豸кŸλֽ
*  @param [IN] strNewIP   IP     ʽ"192.168.3.109"
*  @param [IN] strGateway      ʽ"192.168.3.1"
*  @param [IN] strNetmask  ʽ"255.255.255.0"
*  @note ʵֿ޸IPĹ
*  @ingroup group_global
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_UpdateNetworkParam(unsigned int SL,
        unsigned int SH,
        const char* strNewIP,
        const char* strGateway,
        const char *strNetmask);

/**
*  @brief ͨûصҵ豸Ϣ
*  @param  [IN] pStrDevName 豸
*  @param  [IN] pStrIPAddr  豸IPַ
*  @param  [IN] usPort1   豸˿ں
*  @param  [IN] usPort2   Ԥ
*  @param  [IN] SL          豸кŵλֽ
*  @param  [IN] SH      豸кŸλֽ
*  @param  [IN] netmask      豸
*  @param  [IN] gateway      豸
*  @param  [IN] pUserData ص
*  @ingroup group_callback
*/
typedef void(__STDCALL *VZLPRC_FIND_DEVICE_CALLBACK)(const char *pStrDevName, const char *pStrIPAddr, WORD usPort1, WORD usPort2, unsigned int SL, unsigned int SH, char* netmask, char* gateway, void *pUserData);


/**
*  @brief ʼ豸
*  @param  [IN] func ҵ豸ͨûص
*  @param  [IN] pUserData صе
*  @return 0ʾɹ-1ʾʧ
*  @ingroup group_global
*/
VZ_LPRC_TCP_API int __STDCALL VzLPRTcp_StartFindDevice(VZLPRC_FIND_DEVICE_CALLBACK func, void *pUserData);

/**
*  @brief ֹͣ豸
*  @ingroup group_global
*/
VZ_LPRC_TCP_API void __STDCALL VZLPRTcp_StopFindDevice();



#ifdef __cplusplus
}
#endif

#endif
